1000 REMark CT_AMEND - Cash Trader Amendment Module
1005 REMark Updated 24/3/2002 Rich Mellor
1010 :
1020 REMark    Chas Dillon, Apr 87
1030 :
1040 REMark  Extra cmds/fns: CLOCK
1050 :
1060 TURBO_objfil "win2_ct_amend_exe"
1070 TURBO_taskn  "CTAmend 3.7"
1080 TURBO_objdat 15
1090 TURBO_repfil
1100 TURBO_diags 'd' : TURBO_struct 's' : TURBO_model '<'
1110 TURBO_optim 'b' : TURBO_locstr 'i' : TURBO_windo 0
1120 :
1130 :
1140 IMPLICIT% rng_sel, rng_min, rng_max, ii, jj, kk, dy, mm, yr, grp_id
1150 IMPLICIT% filno, rcd, key, grp_or_head, ht, vt, hhh, vvv, st, nd
1160 IMPLICIT% fc_yes, fc_no, fc_refb, fc_reft, fc_dtyb, fc_dtyt, fc_aodb
1170 IMPLICIT% fc_aodt, fc_medb, fc_medt, fc_actb, fc_actt, fc_rptb, fc_rptt
1180 IMPLICIT% head_ptr
1190 :
1200 WHEN ERRor
1210   WINDOW 258,70,120,70 : BORDER 1,0 : PAPER 4 : INK 0
1220   CLS : PRINT ' An error has occurred ... (';ERNUM%!!ERLIN%;')'
1230   PRINT ' Please check correct volumes are loaded'
1240   PRINT ' and ';drive2$;' is write enabled'
1250   PRINT \'   Press ENTER to retry; ESC to quit'
1260   Get_Key 0 : IF exception : STOP
1270   CLS : RETRY
1280 END WHEN
1290 :
1300 DIM vers$(10) : vers$ = "CTver 3.8"
1310 :
1320 DIM drive1$(42),drive2$(42),cart$(6),q$(100),wk$(4)
1330 DIM f$(2),n$(70),file$(42),last_used_doc_date$(12),doc_reftxt$(12)
1340 DIM fullname$(42),example$(4),name$(42),last$(20),create$(20),vatno$(20)
1350 DIM nextvat$(20), eoy$(20), form$(6), extract$(10), vfq$(6)
1360 DIM prin$(6), lastvat$(20)
1370 :
1380 money_fieldsize% = 10
1390 IF COMPILED:addr = OPTION_CMD$
1400 :
1410 IF COMPILED
1420   drive1$ = Pull_Up$(0)
1430   drive2$ = Pull_Up$(44)
1440   cart$   = Pull_Up$(88)
1460   tran_lim_max% = PEEK_W(addr+110)
1470   anal_lim_max% = PEEK_W(addr+112)
1480   grup_lim_max% = PEEK_W(addr+114)
1490   vatf_lim_max% = PEEK_W(addr+116)
1500   lines_per_doc_max% = PEEK_W(addr+118)
1510 ELSE
1520   drive1$ = "win2_CT_"
1530   drive2$ = "win2_CT_"
1540   cart$   = "DISK"
1560   tran_lim_max% = 6000
1570   anal_lim_max% = 300
1580   grup_lim_max% = 20
1590   vatf_lim_max% = 9
1600   lines_per_doc_max% = 35
1610 END IF
1620 :
1630 REMark grup_pop_lim% = anal_lim_max% DIV grup_lim_max%
1640 :
1650 REMark >>>--<<<   Figurative Constants -------------------------------
1660 :
1670 MANIFEST : fc_yes = 7   : fc_no = 8
1680 MANIFEST : fc_refb = 0  : fc_reft = 7
1690 MANIFEST : fc_dtyb = 8  : fc_dtyt = 12
1700 MANIFEST : fc_aodb = 13 : fc_aodt = 14
1710 MANIFEST : fc_medb = 15 : fc_medt = 17
1720 MANIFEST : fc_actb = 18 : fc_actt = 23
1730 MANIFEST : fc_rptb = 24 : fc_rptt = 29
1740 :
1750 MANIFEST : lf_arrow% = 192 : rt_arrow% = 200 : up_arrow% = 208
1760 MANIFEST : ctrl_lf%  = 194 : ctrl_rt%  = 202 : dn_arrow% = 216 : del_lf%   = 194
1770 MANIFEST : F1_key%   = 232 : F2_key%   = 236 : ENTER%    = 10  : ESC% = 27
1780 :
1790 REMark >>>++<<<   ----------------------------------------------------
1800 :
1810 no_of_paras% = 11
1820 OPEN #14,'con' : IF COMPILED : OPEN #0,'scr' : OPEN #1,'scr'
1830 :
1840 REMark DATA "Unspec. CASH","CHEQUE......","STNDNG ORDER","DIRECT DEBIT"
1850 REMark DATA "TRANSFER....","INTEREST....","BANK CHARGES","UNPAID CHQUE"
1860 REMark DATA "   PAID   ","ADJUSTMENT"," RECEIVED ","BOUGHT  CR"," SOLD  CR "
1870 REMark DATA "ACCEPT THIS LINE","DELETE THIS LINE","ENTER MORE LINES"
1880 DATA "SALES..............","COST OF SALES......","OVERHEADS..........","FIXED ASSETS.......","CAPITAL EMPLOYED...","CRNT ASSET/LIABILTY","YES","NO "
1890 DATA "Dec",31,"Jan",31,"Feb",29,"Mar",31,"Apr",30,"May",31,"Jun",30,"Jul",31,"Aug",31,"Sep",30,"Oct",31,"Nov",30,"Dec",31
1900 DATA " Enter a NEW Group "," Amend a Group Name "," Enter a NEW Analysis Head "," Amend an Analysis Head "," Personalise System "," Exit to Main Menu "
1910 DATA " Long Name ",1," Short Name ",2," VAT Number ",4," Vat Frequency ",5
1920 DATA " Last VAT Return ",6," Next VAT Return ",7," End of Year ",8
1930 DATA " Printer ",10," No. of Printer Lines ",11," Formfeed Character ",12
1940 DATA " Change VAT Tables ",14
1950 :
1960 DIM grup_desc$(grup_lim_max%,15), grup_rept%(grup_lim_max%)
1970 DIM grup_popl%(grup_lim_max%), grup_max_popl%(grup_lim_max%)
1980 DIM anal_desc$(anal_lim_max%,15), anal_vtcd%(anal_lim_max%)
1990 DIM anal_blnc(anal_lim_max%), anal_price%(anal_lim_max%)
2000 DIM vatf_pcnt(vatf_lim_max%), vatf_desc$(vatf_lim_max%,4)
2010 DIM vatf_gros(vatf_lim_max%), vatf_vat(vatf_lim_max%)
2020 DIM vatf_rate$(3,8)
2030 DIM rept_grp$(8,19),rg(7) : REMark ,op$(15,16)
2040 DIM m$(12,3),m%(12)
2050 DIM paratxt$(no_of_paras%,28), vertpos%(no_of_paras%)
2060 DIM options$(5,27)
2070 :
2080 RETRY_HERE
2090 :
2100 RESTORE
2110 REMark FOR ii=0 TO 15 : READ op$(ii)
2120 FOR ii=1 TO 8  : READ rept_grp$(ii)
2130 FOR ii=0 TO 12 : READ m$(ii),m%(ii)
2140 FOR ii=0 TO 5  : READ options$(ii)
2150 FOR ii=1 TO no_of_paras% : READ paratxt$(ii), vertpos%(ii)
2160 :
2170 Setup_Analysis_Tables
2180 Do_Amendments
2190 :
2200 IF COMPILED : CLOSE #0 : CLOSE #1
2210 CLOSE #3 : CLOSE #4 : CLOSE #9
2220 STOP
2230 :
2240 DEFine PROCedure Setup_Analysis_Tables
2250 LOCal ii
2260   OPEN_IN #5,drive2$&"ct_register"
2270   INPUT #5,fullname$, example$, name$, last$, create$, vatno$
2280   CLOSE #5
2290   OPEN_IN #5,drive2$&"ct_paramfile"
2300   INPUT #5,nextvat$, eoy$, printlines, form$, extract$, vfq$
2310   INPUT #5,prin$, lastvat$, vatclear, vatdoc : CLOSE #5
2320   Identify_File 2 : OPEN_IN #5,file$ : INPUT #5,n$
2330   FOR ii=1 TO grup_lim_max%
2335     IF EOF(#5):grup_lim_max%=ii-1:EXIT ii
2340     INPUT #5,n$ : n$ = n$ & "0000"
2350     grup_desc$(ii)=n$(1 TO 15) : grup_rept%(ii)=n$(16)
2360     grup_popl%(ii)=n$(17 TO 19) : grup_max_popl%(ii) = n$(20 TO 22)
2365   END FOR ii
2370   CLOSE #5
2380   Identify_File 3 : OPEN_IN #5,file$ : INPUT #5,n$
2390   FOR ii=1 TO Active_Heads%
2400     INPUT #5,n$ : n$ = n$ & "00000"
2410     anal_desc$(ii)=n$(1 TO 15) : anal_vtcd%(ii)=n$(16)
2420     anal_blnc(ii)=n$(17 TO 26) : anal_price%(ii)=n$(27 TO 31)
2430     END FOR ii : CLOSE #5
2440   Identify_File 4 : OPEN_IN #5,file$
2450   FOR ii=0 TO vatf_lim_max%
2460     INPUT #5,n$
2470     vatf_pcnt(ii)=n$(1 TO 5) : vatf_desc$(ii)=n$(6 TO 9)
2480     vatf_gros(ii)=n$(10 TO 19) : vatf_vat(ii)=n$(20 TO)
2490     END FOR ii
2500   INPUT #5,n$
2510   last_used_doc_date$=n$(1 TO 9) : doc_ct%=n$(10 TO 13) : tran_ct%=n$(14 TO 17)
2520   INPUT #5,n$
2530   FOR ii=0 TO 3 : vatf_rate$(ii)=n$((ii*8)+1 TO (ii*8)+8)
2540   CLOSE #5 : grup_desc$(0)="COMMENT ONLY..."
2550   OPEN #9,'scr'
2560   vatind = 0 : Zap_Display_Ptrs 0 : Zap_Display_Ptrs 1
2570   ht=1 : vt=1 : ch%=1 : wndo_depf% = 16
2580   last_used_grp% = 0
2590   amended = 0
2600   END DEFine
2610 :
2620 DEFine PROCedure Identify_File(filno)
2630   SELect ON filno
2640     =1 : file$="ct_transact_dat" : rec_lenf%=35
2650     =2 : file$="ct_group_dat"    : rec_lenf%=22
2660     =3 : file$="ct_analysis_dat" : rec_lenf%=31
2670     =4 : file$="ct_vatfile_dat"  : rec_lenf%=29
2680     =5 : file$="ct_header_dat"   : rec_lenf%=60
2690     =REMAINDER : CLS : PRINT "wrong filenumber" : STOP
2700     END SELect
2710   file$=drive2$&file$
2720   END DEFine
2730 :
2740 DEFine PROCedure Store (filno,rcd)
2750 LOCal x$(12)
2760   Identify_File filno : n$=FILL$(" ",rec_lenf%)
2770   SELect ON filno
2780     =2 : n$(1 TO 15)=grup_desc$(rcd) : n$(16)=grup_rept%(rcd)
2790          n$(17 TO 19)=grup_popl%(rcd) : n$(20 TO 22) = grup_max_popl%(rcd)
2800     =3 : n$(1 TO 15)=anal_desc$(rcd) : n$(16)=anal_vtcd%(rcd)
2810          n$(17 TO 26)=Decimal$(anal_blnc(rcd)) : n$(27 TO 31) = anal_price%(rcd)
2820     =4 : x$=Decimal$(vatf_pcnt(rcd)) : n$(1 TO 5)=x$(6 TO)
2830          n$(6 TO 9)=vatf_desc$(rcd)
2840          n$(10 TO 19)=Decimal$(vatf_gros(rcd))
2850          n$(20 TO)=Decimal$(vatf_vat(rcd))
2860     END SELect
2870   END DEFine
2880 :
2890 DEFine PROCedure Storeanal
2900 LOCal ii
2910   Identify_File 3 : OPEN #5,file$ : INPUT #5,n$
2920   FOR ii=1 TO Active_Heads% : Store 3,ii : PRINT #5,n$
2930   CLOSE #5 : Identify_File 2 : OPEN #5,file$ : INPUT #5,n$
2940   FOR ii=1 TO grup_lim_max% : Store 2,ii : PRINT #5,n$
2950   CLOSE #5
2960   END DEFine
2970 :
2980 DEFine PROCedure Storevat
2990 LOCal ii
3000   Identify_File 4 : OPEN #5,file$
3010   FOR ii=0 TO vatf_lim_max% : Store 4,ii : PRINT #5,n$
3020   n$=FILL$(" ",29)
3030   n$(1 TO 9)=last_used_doc_date$ : n$(10 TO 13)=doc_ct% : n$(14 TO 17)=tran_ct%
3040   PRINT #5,n$
3050   n$=FILL$(" ",32)
3060   FOR ii=0 TO 3 : n$((ii*8)+1 TO (ii*8)+8)=vatf_rate$(ii)
3070   PRINT #5,n$ : CLOSE #5
3080   END DEFine
3090 :
3100 DEFine FuNction Analysis_Base%(grp%)
3110 LOCal ii, jj
3120   jj = 1
3130   FOR ii=1 TO grp%-1 : jj = jj + grup_max_popl%(ii)
3140   RETurn jj
3150   END DEFine
3160 :
3170 DEFine FuNction Analysis_Group%(analcd%)
3180 LOCal ii, jj
3190   jj = analcd%
3200   FOR ii = 1 TO grup_lim_max%
3210     jj = jj-grup_max_popl%(ii) : IF jj <= 0 : RETurn ii
3220     END FOR ii
3230   END DEFine
3240 :
3250 DEFine FuNction Active_Groups%
3260 LOCal ii,jj
3270   jj=0 : FOR ii=1 TO grup_lim_max% : jj = jj+(grup_rept%(ii)<>0)
3280   RETurn jj
3290   END DEFine
3300 :
3310 DEFine FuNction Active_Heads%
3320 LOCal ii, jj
3330   jj = 0
3340   FOR ii=1 TO grup_lim_max% : jj = jj + grup_max_popl%(ii)
3350   RETurn jj
3360   END DEFine
3370 :
3380 DEFine PROCedure Do_Amendments
3390   RETRY_HERE
3400   REPeat reploop
3410     Build_Menu_Screen
3420     WINDOW 224,122,224,89 : PAPER 0,4 : CLS
3430     WINDOW 224,122,214,79 : BORDER 1,0
3440     WINDOW 220,120,216,80 : BORDER 3,7 : PAPER 2 : INK 0 : CLS
3450     rng_min = 0 : rng_max = 5 : rng_sel = 0
3460     FOR ors = rng_min TO rng_max : Highlight 5
3470     next_avail_grp% = Active_Groups% + 1
3480     REPeat inside
3490       WINDOW #0,312,20,106,236 : PAPER #0,4 : INK #0,0
3500       PRINT #0,"  Use  &  to move indicator: Hit ENTER to accept."
3510       Select_Menu_Option 5,2,0
3520       CLS #0
3530       IF rng_sel > 0 OR next_avail_grp% <= grup_lim_max% : EXIT inside
3540       Complain_Toomany 1
3550       END REPeat inside
3560     IF rng_sel = rng_max : EXIT reploop
3570     CLOSE #3 : Set_Window_3  0
3580 :
3590     Re_Design_Screen_Format
3600     SELect ON rng_sel
3610       =0 : Create_New_Group 1, next_avail_grp%
3620       =1 : Amend 1
3630       =2 : Create_New_Group 2, last_used_grp%
3640       =3 : Amend 2
3650       =4 : Amend_Paras
3660       END SELect
3670     END REPeat reploop
3680   IF NOT amended : RETurn
3690   PAPER 2 : INK 7 : CLS
3700   PRINT \\\\'   Do you want to SAVE or IGNORE'
3710   PRINT '  the changes you have just made ?'
3720   PRINT \TO 15;'S or I'
3730   Get_Key 0
3740   CLOSE #3 : Set_Window_3  0
3750   IF NOT (f$=='S') : RETurn
3760   CLS
3770   PRINT \\"          SAVING  DATA"\\\"         DO NOT DISTURB"
3780   CLS #3 : PRINT #3,"   Saving  Data"\"  Do not Disturb"
3790   FOR ii=1 TO 4 : RECOL 2,3,4,5,6,7,0,1
3800   Storeanal : Storevat
3810   OPEN #5,drive2$&"ct_paramfile"
3820   PRINT #5,nextvat$\ eoy$\ printlines\ form$\ extract$\ vfq$
3830   PRINT #5,prin$\ lastvat$\ ""&vatclear\ ""&vatdoc
3840   CLOSE #5
3850   DELETE drive2$&"ct_register" : OPEN_NEW #5,drive2$&"ct_register"
3860   PRINT #5,fullname$\ example$\ name$\ last$\ create$\ vatno$ : CLOSE #5
3870   END DEFine
3880 :
3890 DEFine PROCedure Re_Design_Screen_Format
3900   WINDOW 512,256,0,0 : PAPER 2 : CLS : OPEN #4,'scr'
3910   WINDOW #4,322,172,35,29 : PAPER #4,0,2 : CLS #4
3920   WINDOW #4,322,172,25,19 : PAPER #4,7 : INK #4,0 : BORDER #4,1,0
3930   CLS #4
3940   x=INT((53-LEN(options$(rng_sel)))/2)
3950   AT #4,0,0 : PAPER #4,4 : INK #4,0 : PRINT #4,FILL$(" ",53)
3960   AT #4,0,0 : PRINT #4,FILL$(" ",x);options$(rng_sel)
3970   WINDOW #4,322,162,25,29 : PAPER #4,7 : INK #4,0 : BORDER #4,1,0
3980   CLS #4 : Zap_Display_Ptrs 0
3990   OPEN #3,'scr'
4000   WINDOW #3,106,172,395,29 : PAPER #3,0,2 : CLS #3
4010   WINDOW #3,106,172,385,19 : PAPER #3,7 : INK #3,0 : BORDER #3,1,0
4020   CLS #3 : Zap_Display_Ptrs 1
4030   WINDOW 458,22,40,230 : PAPER 0,2 : CLS
4040   WINDOW 458,22,30,220 : BORDER 1,0 : PAPER 4 : INK 0 : CLS
4050   WINDOW 448,12,35,225 : BORDER 1,4
4060   Message  1 + (rng_sel = 4)
4070   IF rng_sel < 4 : Show_Categories
4080   END DEFine
4090 :
4100 DEFine PROCedure Message(nx)
4110   PAPER #3,4 : INK #3,0 : BORDER #3,1,7 : CLS #3
4120   IF nx=1
4130     PRINT #3," Think carefully  before changing  a name."
4140     PRINT #3,"Values previouslyentered, will be allocated to the NEW name,even forpast Documents.  "
4150     INK #3,2
4160     PRINT #3,\" VAT Rate cannot change for  the  same reason."
4170     ELSE
4180     PRINT #3," Please refer to"\" the section on"\"  UTILITIES"\"in the User Guide"\" before changing"\" any data here."
4190     END IF
4200   PAPER #3,0 : INK #3,2
4210   IF nx=1
4220     PRINT #3,\\"      Press        ESC to abort.  "
4230     ELSE
4240     PRINT #3,\\"      Press        ESC to Return      to Menu.     "
4250     END IF
4260   PAPER #3,7 : INK #3,0
4270   END DEFine
4280 :
4290 DEFine PROCedure Complain_Toomany(grp_or_head)
4300   IF grp_or_head=1
4310     WINDOW #9,163,55,33,175 : PAPER #9,4,0 : CLS #9
4320     WINDOW #9,163,55,25,165
4330     ELSE
4340     WINDOW #9,163,55,133,125 : PAPER #9,7,0 : CLS #9
4350     WINDOW #9,163,55,125,115
4360     END IF
4370   PAPER #9,0 : INK #9,2 : BORDER #9,1,7 : CLS #9
4380   PRINT #9\\"   No more spare ";
4390   IF grp_or_head=1
4400     PRINT #9,'Groups'\"  Please use Amend Group" : ELSE
4410     PRINT #9,'Heads'\" Use Amend Analysis Head"
4420     END IF
4430   BEEP 32000,10,100,1,-1,0,0,10000
4440   REPeat drain : IF LEN(INKEY$(#14,0))=0 : EXIT drain
4450   q$ = INKEY$(#14,300)
4460   IF grp_or_head=1
4470     WINDOW #9,173,65,25,165 : PAPER #9,4 : CLS #9
4480     ELSE
4490     Zap_Display_Ptrs 0 : Show_Categories : END IF
4500   END DEFine
4510 :
4520 DEFine PROCedure Select_Menu_Option(col%,paph%,inkh%)
4530   REPeat smo_lp
4540     ors=rng_sel
4550     PAPER 0 : INK 7 : Highlight col%
4560     Get_Key 0
4570     IF key = ENTER% AND NOT exception : EXIT smo_lp
4580     Adj_Selection options$
4590     PAPER paph% : INK inkh% : Highlight col%
4600     END REPeat smo_lp
4610   END DEFine
4620 :
4630 DEFine PROCedure Highlight(col%)
4640   AT (ors-rng_min)*2, col% : PRINT options$(ors)
4650   END DEFine
4660 :
4670 DEFine PROCedure Select_Option_Anal(grp_or_head)
4680   exception=0
4690   REPeat loop
4700     Reset_PapInk : Show_Crrt_AnalGrp
4710     Get_Key 1
4720     IF key = ENTER% : EXIT loop
4730     IF grp_or_head = 1
4740       Adj_Selection grup_desc$
4750       ELSE
4760       Adj_Selection anal_desc$
4770       END IF
4780     END REPeat loop
4790   Set_PapInk
4800   IF exception : RETurn
4810   Show_Crrt_AnalGrp
4820   Clear_Line
4830   END DEFine
4840 :
4850 DEFine PROCedure Show_Crrt_AnalGrp
4860   AT 0,35
4870   IF grp_or_head=1
4880     PRINT grup_desc$(rng_sel)
4890     ELSE : PRINT anal_desc$(rng_sel) : END IF
4900   END DEFine
4910 :
4920 DEFine PROCedure Select_Option_Para
4930 LOCal ors,ii
4940   rng_min=1 : rng_max=no_of_paras%
4950   REPeat polloop
4960     ors = rng_sel
4970     PAPER #4,0 : INK #4,7 : Highlight_Para 1
4980     Get_Key 0
4990     IF key = ENTER% : EXIT polloop
5000     Adj_Selection paratxt$
5010     PAPER #4,7 : INK #4,0 : Highlight_Para 1
5020     END REPeat polloop
5030   END DEFine
5040 :
5050 DEFine PROCedure Highlight_Para(col%)
5060   AT #4,vertpos%(ors),1 : PRINT #4,paratxt$(ors)
5070   END DEFine
5080 :
5090 DEFine PROCedure Create_New_Group(grp_or_head, grp_id)
5100 LOCal repg_or_vatc, q$(20), q1$(40), h$(20), ii, x1, xs, head_ptr
5110   repg_or_vatc = 1 : h$="" : xs = 0
5120   REPeat cng_lp
5130     IF grp_or_head <> 1
5140       grp_id = Selected_AnalGrp(1)
5150       IF grp_id = 0 : RETurn
5160       IF grup_popl%(grp_id) >= grup_max_popl%(grp_id)
5170         Complain_Toomany 2 : NEXT cng_lp : END IF
5180       head_ptr = Analysis_Base%((grp_id)) + grup_popl%(grp_id)
5190       Show_Group_Contents grp_id
5200     END IF
5210     IF NOT Got_Grp_Name : RETurn
5220     AT 0,1 : PRINT h$;" "; : CLS 4
5230     IF grp_id <= 3
5240       PRINT "is in ";q1$;" Group           " : repg_or_vatc=4
5250     ELSE
5260       IF NOT Got_Grp_Support_Info : RETurn
5270     END IF
5280     AT 0,60 : PRINT "Correct ?"
5290     Get_YN
5300     IF exception : RETurn
5310     amended = 1
5320     IF rng_sel = fc_yes
5330       last_used_grp% = grp_id
5340       IF grp_id = 1 : h$=(head_ptr-2)&":"&h$
5350       IF grp_or_head <> 1
5360         grup_popl%(grp_id)=grup_popl%(grp_id) + 1
5370         anal_desc$(head_ptr)=h$(1 TO 15) : anal_vtcd%(head_ptr)=repg_or_vatc
5380         IF repg_or_vatc=1:anal_price%(head_ptr) = 100 * q1$
5390       ELSE
5400         grup_rept%(grp_id) = repg_or_vatc
5410         grup_desc$(grp_id) = h$(1 TO 15)
5420         grup_popl%(grp_id) = 0
5430         grup_max_popl%(grp_id) = max_size%
5440         q1$ = Free_AnaHead$((grp_id))
5450         st = Analysis_Base%(grp_id)
5460         nd = st + max_size%-1
5470         FOR ii = st TO nd
5480           anal_desc$(ii) = q1$ : anal_vtcd%(ii) = 0
5490           anal_blnc(ii) = 0 : anal_price%(ii) = 0
5495         END FOR ii
5500       END IF
5510       Clear_Line
5520       IF grp_or_head <> 1
5530         Show_Group_Contents grp_id
5535       ELSE
5540         Show_Categories
5545       END IF
5550     END IF
5560     SELect ON grp_or_head
5570       =1 : grp_id = Active_Groups% + 1
5580            xs = (grp_id > grup_lim_max%)
5590       =2 : xs = (grup_popl%(grp_id) = grup_max_popl%(grp_id))
5600     END SELect
5610     IF xs
5615       Clear_Line:AT 0,5:PRINT "No More Room ";
5617       IF grp_or_head<>1:PRINT "In Current Group":ELSE PRINT
5620       f$ = INKEY$(#14,200)
5625       Clear_Line
5630       IF grp_or_head = 1 : EXIT cng_lp
5645     END IF
5650     AT 0,5 : PRINT "Would you like to enter another NEW ";
5670     IF grp_or_head=1:PRINT "Group ?" : ELSE PRINT "Analysis Head ?"
5680     Get_YN
5690     IF exception OR rng_sel = fc_no : Clear_Line : EXIT cng_lp
5700   END REPeat cng_lp
5710 END DEFine
5720 :
5730 DEFine FuNction Free_AnaHead$(ii)
5740   ii = 1 + (Min_Short%(3,ii-(ii>2))-1)*15
5750   RETurn "FREE MONEY BOX.FREE ACCOUNT...FREE HEAD......"(ii TO ii+14)
5760   END DEFine
5770 :
5780 DEFine FuNction Got_Grp_Name
5790   AT 0,1
5800   Set_PapInk : PRINT "                ";
5810   IF grp_or_head = 1
5820     q1$="Group"
5830     ELSE
5840     SELect ON grp_id
5850       =1 : q1$="Money Box"
5860       =2 : q1$="Purch A/C"
5870       =3 : q1$="Sales A/C"
5880       =REMAINDER : q1$="Analysis"
5890       END SELect
5900     END IF
5910   PRINT "Type in ";q1$;" Name "; : CLS 4
5920   REPeat loop1
5930     q$ = Kbd_String$( 18, '', 2)
5940     IF LEN(q$)>0 OR exception
5950       h$=q$&"................" : h$=h$(1 TO 15)
5960       IF (h$ == Free_AnaHead$((grp_id))) : NEXT loop1
5970       EXIT loop1 : END IF
5980     END REPeat loop1
5990   IF exception : Clear_Line : RETurn 0
6000   RETurn 1
6010   END DEFine
6020 :
6030 DEFine FuNction Got_Grp_Support_Info
6040   IF grp_or_head = 1
6050     PRINT "? Rep. Cat " : rng_min=1 : rng_max=6
6060     ELSE
6070     PRINT "? VAT Rate " : rng_min=0 : rng_max=4
6080     END IF
6090   rng_sel = repg_or_vatc
6100   REPeat loop4
6110     Reset_PapInk : AT 0,29
6120     IF grp_or_head = 1
6130       PRINT rept_grp$(rng_sel);
6140       ELSE
6150       PRINT vatf_desc$(rng_sel);
6160       END IF
6170     Set_PapInk : Get_Key 1
6180     IF key = ENTER% : EXIT loop4
6190     IF grp_or_head = 1
6200       Adj_Selection rept_grp$
6210       ELSE
6220       Adj_Selection vatf_desc$
6230       END IF
6240     END REPeat loop4
6250   repg_or_vatc = rng_sel
6260   AT 0,1
6270   IF exception : Clear_Line : RETurn 0
6280   IF grp_or_head = 1
6290     max_size% = anal_lim_max% - Active_Heads%
6300     REPeat pr_lp
6310       AT 0,45 : PRINT " Grp Size ";
6320       q1$ = Kbd_String$(-2, '10', 3)
6330       IF exception : EXIT pr_lp
6340       IF q1$ <= max_size% : EXIT pr_lp
6350       END REPeat pr_lp
6360     max_size% = q1$
6370     ELSE
6380     IF grup_rept%(grp_id) = 1
6390       REPeat pr_lp
6400         AT 0,33 : PRINT " Unit Price ";
6410         q1$ = Kbd_String$(-1, '0.00', 1)
6420         IF exception : EXIT pr_lp
6430         IF q1$ < 327 : EXIT pr_lp
6440         END REPeat pr_lp
6450       ELSE
6460       q1$='0'
6470       END IF : END IF
6480   AT 0,17 : PRINT "  "
6490   RETurn 1
6500   END DEFine
6510 :
6520 REFERENCE array$(0,0)
6530 DEFine FuNction Displayed_Group%(txt$, array$, previous%, list_size%, list_limit%, list_base%)
6540 LOCal ii, jj, kk, end_range%, all_printed
6550   kk = Max_Short%(1, previous%)
6560   Set_Box_Heading txt$ : Zap_Display_Ptrs 1
6570   jj = Min_Short%(list_limit%,1+list_size%)
6580   end_range% = Min_Short%(jj, kk+wndo_depf%-1)
6590   all_printed = ( kk+wndo_depf%-1 >= jj )
6600   FOR ii = kk+list_base% TO end_range%+list_base%
6610     PRINT #3," ";array$(ii) : END FOR ii
6620   FOR ii = end_range%+1 TO kk+wndo_depf%-1 : PRINT #3
6630   IF all_printed : RETurn 0
6640   Show_Continue 3,wndo_depf%,16
6650   RETurn end_range% + 1
6660   END DEFine
6670 :
6680 DEFine PROCedure Set_Box_Heading(txt$)
6690   BORDER #3,1,0
6700   AT #3,wndo_depf%,12 : PRINT #3
6710   PAPER #3,4 : INK #3,0
6720   AT #3,wndo_depf%,0 : PRINT #3,' ';txt$; : CLS #3,4
6730   PAPER #3,7 : INK #3,0 : LINE #3,0,0 TO 63,0 : PRINT #3
6740   END DEFine
6750 :
6760 DEFine PROCedure Show_Group_Contents (grp%)
6770 LOCal ii, kk
6780   prev_grp_line% = 0
6790   ii = Analysis_Base%((grp%))-1 : kk = grup_popl%(grp%)
6800   prev_anal_line% = Displayed_Group%(grup_desc$(grp%),anal_desc$,prev_anal_line%,kk,grup_max_popl%(grp%),ii)
6810   IF prev_anal_line% <> 0 : prev_anal_grp% = grp%
6820   END DEFine
6830 :
6840 DEFine PROCedure Show_Categories
6850 LOCal ii,jj,kk,x6,x7,st,nd,p1$(12),p2$(90),lin%
6860   p2$ = "Sales.......Cost of SaleOverheads...Fixed AssetsCaptl EmplydCrt Asst/Lib"
6870   CLS #4 : lin% = wndo_depf% : p1$ = 'Crt Asst/Lib'
6880   prev_cat_line% = Max_Short%(1, prev_cat_line%)
6890   prev_cat_grp% = Max_Short%(1, prev_cat_grp%)
6900   FOR ii = prev_cat_grp% TO 7
6910     IF ii < 7 : jj = 12 * (ii-1) +1 : p1$ = p2$(jj TO jj + 11)
6920     x7 = (prev_cat_line% > 1)
6930     FOR jj = prev_cat_line% TO grup_lim_max%
6940       IF grup_rept%(jj) = ii
6950         IF lin% < 1
6960           prev_cat_line% = jj : prev_cat_grp% = ii
6970           EXIT ii : END IF
6980         st = Analysis_Base%((jj)) : nd=st+grup_popl%(jj)-1 : x7 = 1
6990         x6=0 : FOR kk=st TO nd : x6=x6+anal_blnc(kk)
7000         st = 5-LEN(grup_max_popl%(jj))
7010         PRINT #4,"  ";p1$!grup_desc$(jj)!Decimal$(x6);FILL$(" ",st);grup_max_popl%(jj)
7020         lin% = lin%-1
7030         p1$="            "
7040         END IF
7050       END FOR jj
7060     Zap_Display_Ptrs 0
7070     IF x7 = 0
7080       PRINT #4,"  ";p1$;"       Not Used"
7090       lin% = lin%-1
7100       END IF
7110     END FOR ii
7120   IF prev_cat_line% <> 0 : Show_Continue 4,wndo_depf%-1,52
7130   END DEFine
7140 :
7150 DEFine PROCedure Show_Continue(chn%,lin%,col%)
7160   AT #chn%,lin%,col% : PAPER #chn%,2 : INK #chn%,7 : PRINT #chn%,CHR$(191);
7170   PAPER #chn%,7 : INK #chn%,0
7180   END DEFine
7190 :
7200 DEFine PROCedure Zap_Display_Ptrs(screen3)
7210   IF screen3
7220     prev_grp_line% = 0
7230     prev_anal_grp% = 0 : prev_anal_line% = 0
7240     ELSE
7250     prev_cat_grp%  = 0 : prev_cat_line%  = 0
7260     prev_rpt_grp%  = 0 : prev_rpt_line%  = 0 : END IF
7270   END DEFine
7280 :
7290 DEFine FuNction Selected_AnalGrp(rng_min)
7300   rng_sel = Max_Short%(last_used_grp%, rng_min)
7310   rng_max = Active_Groups%
7320   CLS : AT 0,20 : PRINT "Which Group ?"
7330   Select_Option_Anal 1 : IF exception : RETurn 0
7340   RETurn rng_sel
7350   END DEFine
7360 :
7370 DEFine PROCedure Amend(grp_or_head)
7380 LOCal price$(12), head_ptr
7390   REPeat ag_lp
7400     grp_id = Selected_AnalGrp(1+4*(grp_or_head=1))
7410     IF grp_id = 0 : EXIT ag_lp
7420     CLS : Zap_Display_Ptrs 1
7430     IF grp_or_head <> 1
7440       IF grup_popl%(grp_id) = 0 : EXIT ag_lp
7450       Show_Group_Contents grp_id
7460       rng_min = Analysis_Base%((grp_id)) : rng_sel = rng_min
7470       rng_max = rng_min + grup_popl%(grp_id) - 1
7480       AT 0,10 : PRINT "Which Head to change ?" : Select_Option_Anal 2
7490       IF exception : EXIT ag_lp
7500       CLS
7510       head_ptr = rng_sel
7520     END IF
7530     AT 0,20 : PRINT "Type in NEW  ";
7540     IF grp_or_head=1
7550       PRINT "Group   ";
7560       q$ = grup_desc$(grp_id)
7570     ELSE
7580       q$ = anal_desc$(head_ptr)
7590       PRINT "Analysis";
7595     END IF
7600     PRINT " Name ?"
7605     xoff%=42
7610     REPeat pool
7620       q$ = Kbd_String$( 18, q$, 2)
7630       IF LEN(q$) > 0 OR exception : EXIT pool
7640     END REPeat pool
7645     price$='0.00'
7650     IF exception : EXIT ag_lp
7660     q$ = q$ & FILL$(".",15-LEN(q$))
7670     IF grp_or_head <> 1
7680       IF grp_id = 1 AND head_ptr > 2 : q$ = (head_ptr-2)&':'&q$
7690       IF grup_rept%(grp_id) = 1
7700         AT 0,20 : PRINT "      Type in New Price   "; : CLS 4
7705         xoff%=44
7710         REPeat pr_lp
7720           p = anal_price%(head_ptr) : price$ = Decimal$(p/100)
7730           price$=price$(5 TO 10) : price$ = Kbd_String$(-1, price$, 1)
7740           IF exception : EXIT pr_lp
7750           IF price$ < 327 : EXIT pr_lp
7760         END REPeat pr_lp
7770       END IF
7775     END IF
7780     AT 0,20 : PRINT "   is        "
7790     AT 0,xoff% : PRINT "Correct ?"
7800     Get_YN
7810     IF exception : RETurn
7820     IF rng_sel <> fc_yes : EXIT ag_lp
7830     amended = 1
7840     IF grp_or_head=1
7850       grup_desc$(grp_id) = q$ : CLS : Show_Categories
7860     ELSE
7870       anal_desc$(head_ptr) = q$(1 TO 15)
7880       anal_price%(head_ptr) = 100 * price$
7890     END IF
7900     CLS : Show_Group_Contents grp_id
7920     last_used_grp% = grp_id
7930 :
7940     AT 0,5 : PRINT "Would you like to Amend another ";
7960     IF grp_or_head=1:PRINT "Group ?" : ELSE : PRINT "Analysis Head ?"
7970     Get_YN
7980     IF exception OR rng_sel = fc_no : EXIT ag_lp
7990   END REPeat ag_lp
8000 END DEFine
8010 :
8020 DEFine PROCedure Build_Para_Screen
8030 LOCal ii, jj, kk, q$(40)
8040   INK #4,0 : PAPER #4,7 : CLS #4 : PRINT #4
8050   FOR kk = 1 TO no_of_paras%
8060     ii = vertpos%(kk)
8070     IF ii < 14 : PAPER #4,4 : AT #4,ii,25 : PRINT #4,FILL$(" ",28)
8080     PAPER #4,7 : AT #4,ii,1 : PRINT #4,paratxt$(kk)
8090     IF kk < no_of_paras%
8100       q$ = p$(kk)
8110       IF kk = 3 : q$ = q$(1 TO 3)&" "&q$(4 TO 7)&" "&q$(8 TO 9)
8120       jj=LEN(q$) : PAPER #4,4 : AT #4,ii,52-jj : PRINT #4,q$
8130       END IF
8140     END FOR kk
8150   p_screen = 1
8160   END DEFine
8170 :
8180 DEFine PROCedure Amend_Paras
8190 LOCal ii, jj, kk, ors, p$(10,40), p_screen
8200   p$(1)=fullname$ : p$(2)=name$ : p$(3)=vatno$ : p$(4)=vfq$
8210   p$(5)=lastvat$ : p$(6)=nextvat$ : p$(7)=eoy$ : p$(8)=prin$
8220   p$(9)=printlines : p$(10)=CODE(form$)
8230   Build_Para_Screen
8240   jj=1
8250   REPeat kjd
8260     rng_sel = jj : Select_Option_Para
8270     PAPER #4,7 : INK #4,0
8280     AT #4,vertpos%(rng_sel),1 : PRINT #4,paratxt$(rng_sel)
8290     IF exception
8300       jj = Dates_are_Bad  : IF jj = 0 : EXIT kjd
8310       NEXT kjd : END IF
8320     amended = 1
8330     ors = rng_sel : jj = rng_sel
8340     PAPER #4,4 : AT #4,vertpos%(rng_sel),25 : CLS #4,4
8350     SELect ON rng_sel
8360       =5 TO 7    : p$(rng_sel) = Amended_Date$(p$(rng_sel)) : CLS
8370       =11        : p_screen = 0 : Vat_Change
8380                    jj = Dates_are_Bad : IF jj = 0 : EXIT kjd
8390       =REMAINDER : REPeat aqw
8400                      kk = rng_sel : IF kk > 4 : kk = kk-3
8410                      kk = 2 + ("7521634"(kk) < 5)
8420                      p$(rng_sel) = Kbd_String$(rng_sel, p$(rng_sel), kk)
8430                      IF exception : NEXT kjd
8440                      IF Response_Valid : CLS : EXIT aqw
8450                      Complain
8460                      AT #4,vertpos%(rng_sel),25 : CLS #4,4
8470                      END REPeat aqw
8480                    IF rng_sel=3
8490                      Set_Curs_Coord kk : Set_PapInk
8500                      PRINT #4,p$(3,1 TO 3)&" "&p$(3,4 TO 7)&" "&p$(3,8 TO 9)
8510                      END IF
8520       END SELect
8530     END REPeat kjd
8540   ch% = 1 : Copy_Paras
8550   END DEFine
8560 :
8570 DEFine PROCedure Complain
8580   IF NOT p_screen : Build_Para_Screen
8590   PAPER 2 : INK 0 : AT 0,0
8600   PRINT TO 10;'Response out of range';
8610   CLS 4 : PAPER 4 : INK 0
8620   END DEFine
8630 :
8640 DEFine FuNction Response_Valid
8650   SELect ON rng_sel
8660     = 0 TO 2   : RETurn ( LEN(p$(rng_sel)) > 0 )
8670     = 3        : RETurn ( LEN(p$(rng_sel)) = 9 )
8680     = 4        : RETurn ( p$(rng_sel)="1" OR p$(rng_sel)="3" OR p$(rng_sel)="12")
8690     = 8        : RETurn ( p$(rng_sel)="Y" OR p$(rng_sel)="N")
8700     = 9        : RETurn ( p$(rng_sel) > "40" )
8710     = 10       : RETurn ( p$(rng_sel) < "32" )
8720     =REMAINDER : RETurn 0
8730     END SELect
8740   END DEFine
8750 :
8760 DEFine FuNction Dates_are_Bad
8770 LOCal lvatdt,nvatdt,nyedt
8780   lvatdt = Numeric_Date(p$(5))
8790   nvatdt = Numeric_Date(p$(6))
8800   nyedt  = Numeric_Date(p$(7))
8810   IF lvatdt > nvatdt : rng_sel = 5 : Complain : RETurn 5
8820   IF lvatdt > nyedt : rng_sel = 5 : Complain : RETurn 5
8830   RETurn 0
8840   END DEFine
8850 :
8860 DEFine PROCedure Copy_Paras
8870   fullname$=p$(1) : name$=p$(2) : vatno$=p$(3) : vfq$=p$(4)
8880   lastvat$=p$(5) : nextvat$=p$(6) : eoy$=p$(7) : prin$=p$(8)
8890   printlines=p$(9) : x=p$(10) : form$=CHR$(x)
8900   END DEFine
8910 :
8920 DEFine PROCedure Vat_Change
8930 LOCal ii
8940   CLS #4 : OPEN #8,'scr'
8950   WINDOW #8,260,140,50,45 : PAPER #8,0,7 : CLS #8
8960   WINDOW #8,260,140,40,35 : BORDER #8,1,0 : PAPER #8,4 : CLS #8
8970   PAPER #4,4
8980   AT #4,1,21 : PRINT #4,"VAT Table"
8990   AT #4,3,4 : PRINT #4,"Long Name      Short Name         Rate"
9000   FOR ii=0 TO 3
9010     AT #4,(ii*2)+6,4 : PRINT #4,vatf_rate$(ii)
9020     AT #4,(ii*2)+6,21 : PRINT #4,vatf_desc$(ii)
9030     AT #4,(ii*2)+6,32 : PRINT #4,Decimal$(vatf_pcnt(ii))
9040     END FOR ii
9050   ch% = 4 : vatind = 1
9060   FOR ii=0 TO 3
9070     vvv=(ii*2)+6 : hhh=4
9080     q$ = Kbd_String$( 8, vatf_rate$(ii), 2)
9090     IF exception : EXIT ii
9100     vatf_rate$(ii) = q$
9110     hhh=21
9120     q$ = Kbd_String$( 4, vatf_desc$(ii), 2)
9130     IF exception : EXIT ii
9140     vatf_desc$(ii) = q$
9150     hhh=37 : AT #ch%,vvv,32 : PRINT #ch%;"           "
9160     q$ = Decimal$(vatf_pcnt(ii)) : q$ = q$(6 TO 10)
9170     q$ = Kbd_String$( 5, q$, 1)
9180     IF exception : EXIT ii
9190     vatf_pcnt(ii) = q$
9200     END FOR ii
9210   CLOSE #8 : exception = 0 : vatind = 0
9220   END DEFine
9230 :
9240 DEFine PROCedure Build_Menu_Screen
9250 LOCal ii,jj,kk
9260   WINDOW 512,256,0,0 : PAPER 4 : CLS
9270   WINDOW 256,125,20,9
9280   SCALE 110,0,0 : Draw_Logo
9290   INK 7
9300   WINDOW 302,42,166,20 : PAPER 0,4 : CLS
9310   WINDOW 302,42,156,10 : BORDER 1,0
9320   WINDOW 298,40,158,11 : BORDER 3,2 : PAPER 7 : INK 0 : CLS
9330   CSIZE 2,0 : PRINT " Cash Trader  with VAT" : CSIZE 0,0
9340   ii = 47-LEN(fullname$) : jj = ii DIV 2 : kk = ii - jj
9350   PRINT \FILL$(" ",jj);fullname$;FILL$(" ",kk)
9360   Set_Window_3 1 : CLOCK #3
9370   END DEFine
9380 :
9390 DEFine PROCedure Set_Window_3(small)
9400   OPEN #3,'scr_'
9410   WINDOW #3,133,42,65,120 : PAPER #3,0,4 : CLS #3
9420   WINDOW #3,133,42,57,110 : BORDER #3,1,7 : PAPER #3,2,0,1 : CLS #3
9430   WINDOW #3,113,22,67,120 : BORDER #3,1,7 : PAPER #3,0 : INK #3,7
9440   CLS #3
9450   IF small : WINDOW #3, 60,20,97,121
9460   END DEFine
9470 :
9480 DEFine PROCedure Draw_Logo
9490   INK 4,0 : FILL 1 : CIRCLE 35,82,20
9500   INK 4 : FILL 1 : CIRCLE 35,82,13 : INK 4,0
9510   FILL 1 : LINE 53,61 TO 57,66 TO 48,71 TO 44,66 TO 53,61
9520   FILL 1
9530   LINE 60,101 TO 60,62 TO 87,62 TO 87,68 TO 68,68 TO 68,101 TO 60,101
9540   INK 0 : FILL 1 : CIRCLE 30,85,20
9550   INK 4 : FILL 1 : CIRCLE 30,85,13
9560   INK 0 : FILL 1 : LINE 48,64 TO 52,69 TO 43,74 TO 39,69 TO 48,64
9570   FILL 1 : INK 0
9580   LINE 55,104 TO 55,65 TO 82,65 TO 82,71 TO 63,71 TO 63,104 TO 55,104
9590   INK 4,0 : FILL 0 : FILL 1
9600   ARC 22,75 TO 38,95,-2.2;22,75 TO 38,95,-3.2
9610   FILL 0
9620   END DEFine
9630 :
9640 DEFine FuNction Numeric_Date(txt$)
9650 LOCal ii, ans, jj
9660   ii = Month_No%(txt$(4 TO 6))
9670   ans=txt$(8 TO):IF ans<50:ans=ans+100
9675   jj=txt$(1 TO 2) : ans=(ans*10000)+(ii*100)+jj
9680   RETurn ans
9690   END DEFine
9700 :
9710 DEFine PROCedure Set_Curs_Coord (curfld)
9720 LOCal jj
9730   IF curfld=-1 : field_len% = 6 : hhh=45 : vvv=0 : AT 0,45 : RETurn
9740   IF curfld=-2 : field_len% = 3 : hhh=55 : vvv=0 : AT 0,55 : RETurn
9750   IF NOT vatind
9760     IF curfld = 18
9770       ch%=1 : vvv=0 : hhh=1 : field_len%=15
9780       AT 0,1 : RETurn : END IF
9790     ch%=4
9800     vvv = vertpos%(curfld)
9810     jj = 1+(curfld-1)*2
9820     field_len% = "3616 9 2       1 2 2" (jj TO jj+1)
9830     hhh = 52-field_len%
9840     IF curfld = 3 : hhh = hhh - 2
9850     ELSE
9860     field_len% = curfld
9870     END IF
9880   AT #4,vvv,hhh
9890   END DEFine
9900 :
9910 DEFine PROCedure Reset_PapInk
9920   PAPER #ch%,0 : INK #ch%,7
9930 END DEFine
9940 :
9950 DEFine PROCedure Set_PapInk
9960   IF ch%<>1
9970     PAPER #ch%,4 : INK #ch%,0
9980   ELSE
9990     PAPER 2 : INK 7
10000   END IF
10010 END DEFine
10020 :
10030 DEFine PROCedure Get_YN
10040   rng_sel = fc_no : rng_min = fc_yes : rng_max = fc_no
10050   REPeat loop3
10060     AT 0, 69 : Reset_PapInk
10070     PRINT rept_grp$(rng_sel) : Get_Key 0
10080     Set_PapInk
10090     IF key = ENTER% AND NOT exception : EXIT loop3
10100     Adj_Selection rept_grp$
10110   END REPeat loop3
10120   Clear_Line
10130 END DEFine
10140 :
10150 REFERENCE array$(0,0)
10160 DEFine PROCedure Adj_Selection(array$)
10170 LOCal ii, jj
10180   SELect ON key
10190     = lf_arrow%, up_arrow% : rng_sel=rng_sel-1
10200                              IF rng_sel<rng_min : rng_sel=rng_max
10210                              RETurn
10220     = rt_arrow%, dn_arrow% : rng_sel=rng_sel+1
10230                              IF rng_sel>rng_max : rng_sel=rng_min
10240                              RETurn
10250   END SELect
10260   FOR ii = rng_sel+1 TO rng_max
10270     IF Found_Option_Match : rng_sel = ii : RETurn
10280   END FOR ii
10290   FOR ii = rng_min TO rng_sel-1
10300     IF Found_Option_Match : rng_sel = ii : RETurn
10310   END FOR ii
10320 END DEFine
10330 :
10340 DEFine FuNction Found_Option_Match
10350   jj = 0
10360   REPeat fom_lp
10370     jj=jj+1 : IF jj > LEN(array$(ii)) : RETurn 0
10380     IF array$(ii,jj)<>" " : EXIT fom_lp
10390   END REPeat fom_lp
10400   RETurn CHR$(key) == array$(ii,jj)
10410 END DEFine
10420 :
10430 DEFine PROCedure Get_Key(allowed)
10440   exception = 0
10450   REPeat gk_lp
10460     f$=INKEY$(#14,-1) : key = CODE(f$)
10470     SELect ON key
10480       = dn_arrow% : IF NOT allowed : EXIT gk_lp
10490                     IF prev_cat_grp% : Show_Categories
10500                     IF prev_anal_line% : Show_Group_Contents prev_anal_grp%
10510                     EXIT gk_lp
10520       = ESC%      : key = ENTER% : f$=CHR$(ENTER%)
10530                     exception = 1 : EXIT gk_lp
10540       = REMAINDER : EXIT gk_lp
10550     END SELect
10560   END REPeat gk_lp
10570 END DEFine
10580 :
10590 DEFine FuNction Kbd_String$(curfld, stval$, typ%)
10600 LOCal ht, vt, dec_pt_recd, maxf_len%, money, ii, q$(50)
10610   num_text = (typ%=3) : text_fld = (typ%=2) : money = (typ%=1)
10620   Set_Curs_Coord curfld : ht=hhh : vt=vvv
10630   maxf_len% = field_len%
10640   IF money : maxf_len% = 6
10650   dec_pt_recd = 0 : q$ = ""
10660   Reset_PapInk
10670   REPeat ks_lp
10680     IF q$=""
10690       Set_Curs_Coord curfld
10700       q$ = FILL$(" ",field_len%-LEN(stval$))
10720       IF text_fld:PRINT #ch%,q$;stval$: ELSE :PRINT #ch%,stval$;q$
10730       q$ = "" : Set_Curs_Coord curfld
10740     END IF
10750     Get_Key 1
10760     IF key = ENTER%
10770       IF exception : q$=''
10780       IF q$ = '' : q$ = stval$
10790       EXIT ks_lp
10795     END IF
10800     IF money AND q$ = "" AND key = 45
10810       q$="-" : PRINT #ch%,q$; : ht=ht+1
10820     ELSE
10830       Check_Character
10840     END IF
10850     IF stval$ <> "" AND LEN(q$)=1
10860       AT #ch%,vt,ht : PRINT #ch%,FILL$(" ",maxf_len%-1)
10870       AT #ch%,vt,ht
10880     END IF
10890   END REPeat ks_lp
10900   Set_PapInk : Set_Curs_Coord curfld
10910   IF text_fld
10920     q$ = Upper$(q$)
10930   ELSE
10940     IF q$="" : q$="0"
10950     IF money : q$ = Decimal$(q$) : q$ = q$(LEN(q$)-field_len%+1 TO LEN(q$))
10960   END IF
10970   IF curfld = -1
10980     PRINT #ch%,q$;FILL$(' ',maxf_len%-LEN(q$))
10990   ELSE
11000     PRINT #ch%,FILL$(' ',maxf_len%-LEN(q$));q$
11010   END IF
11020   RETurn q$
11030 END DEFine
11040 :
11050 DEFine FuNction Upper$(txt$)
11060 LOCal q$(100), jj, ii
11070   IF txt$ = "" : RETurn ""
11080   q$ = txt$
11090   FOR ii=1 TO LEN(q$)
11100     jj = CODE(q$(ii)) : IF jj>90 : q$(ii)=CHR$(jj-32)
11110   END FOR ii
11120   RETurn q$
11130 END DEFine
11140 :
11150 DEFine PROCedure Check_Character
11160   IF (key = F2_key% OR key = del_lf%)
11170     IF q$ <> "" : Delete_Character
11180     RETurn
11185   END IF
11190   IF money AND NOT dec_pt_recd AND key = 46
11200     dec_pt_recd=1 : PRINT #ch%,".__";FILL$(" ",Free_Places%-LEN(q$));
11210     ht=hhh+1+LEN(q$) : AT #ch%,vt,ht : q$ = q$ & f$
11220   ELSE
11230     IF Acceptable_Character : q$ = q$ & f$ : PRINT #ch%,f$; : ht=ht+1
11240     IF money AND dec_pt_recd = 0 AND LEN(q$)=Free_Places%
11250       PRINT #ch%,"."; : q$=q$&"." : dec_pt_recd=1 : ht=ht+1
11255     END IF
11260   END IF
11270 END DEFine
11280 :
11290 DEFine FuNction Acceptable_Character
11300   IF money
11310     IF dec_pt_recd : IF ("." INSTR q$) = LEN(q$)-2 : RETurn 0
11320     RETurn Within(key,48,57)
11325   END IF
11330   IF text_fld : RETurn Within(key,32,127) AND LEN(q$)<maxf_len%
11340   IF num_text : RETurn Within(key,48,57)  AND LEN(q$)<maxf_len%
11350   RETurn 0
11360 END DEFine
11370 :
11380 DEFine FuNction Free_Places%
11390   IF q$ = '' : RETurn maxf_len%-3
11400   RETurn maxf_len%-3 + (q$(1)='-')
11410 END DEFine
11420 :
11430 DEFine PROCedure Delete_Character
11440   IF money AND CODE(q$(LEN(q$))) = 46
11450     dec_pt_recd=0
11460     IF LEN(q$) = maxf_len%-2 : q$ = Lost_Last$(q$)
11470   END IF
11480   q$ = Lost_Last$(q$)
11490   Set_Curs_Coord curfld : PRINT #ch%,q$&FILL$(" ",maxf_len%-LEN(q$))
11500   Set_Curs_Coord curfld : ht = hhh+LEN(q$) : AT #ch%,vt,ht
11510 END DEFine
11520 :
11530 DEFine FuNction Lost_Last$(q$)
11540   IF LEN(q$) < 2 : RETurn ""
11550   RETurn q$(1 TO LEN(q$)-1)
11560 END DEFine
11570 :
11580 DEFine FuNction Amended_Date$(q$)
11590 LOCal dy,yr,mm,old_date$(20)
11600   ch% = 4 : vvv = vertpos%(rng_sel) : hhh = 43
11610   old_date$ = q$
11620   AT #ch%,vvv,hhh : Reset_PapInk : PRINT #ch%,q$
11630   dy=q$(1 TO 2) : yr=q$(8 TO 9):IF yr<50:yr=yr+2000:ELSE yr=yr+1900
11640   mm = Month_No%(q$(4 TO 6))
11650   REPeat ad_lp
11660     Get_Key 0
11670     IF exception : q$ = old_date$
11680     IF key = ENTER% : EXIT ad_lp
11690     SELect ON key
11700       = lf_arrow%, rt_arrow%, ctrl_lf%, ctrl_rt% : Adj_Date
11710     END SELect
11720   END REPeat ad_lp
11730   Set_PapInk : AT #ch%,vvv,hhh : PRINT #ch%,q$
11740   RETurn q$
11750 END DEFine
11760 :
11770 DEFine PROCedure Adj_Date
11780   SELect ON key
11790     = ctrl_rt% : Check_Month 1
11800     = ctrl_lf% : Check_Month -1
11810     =rt_arrow% : Check_Day 1
11820     =lf_arrow% : Check_Day -1
11830   END SELect
11850   IF dy<10:q$(1 TO 2)=" "&dy : ELSE : q$(1 TO 2)=dy
11855   wk$=yr
11860   q$(4 TO 6) = m$(mm) : q$(8 TO 9)=wk$(3 TO 4)
11870   Reset_PapInk : AT #ch%,vvv,hhh : PRINT #ch%,q$
11880 END DEFine
11890 :
11900 DEFine PROCedure Check_Month(adj%)
11910   mm = mm + adj%
11920   IF mm=13 : mm=1 : yr=yr+1
11930   IF mm=0 : mm=12 : yr=yr-1
11940   dy = Min_Short%(dy, m%(mm)-(mm=2 AND yr MOD 4))
11950 END DEFine
11960 :
11970 DEFine PROCedure Check_Day(adj%)
11980   dy = dy + adj%
11990   IF dy>m%(mm) : dy=1 : Check_Month 1
12000   IF dy=0 : dy=m%(mm-1) : Check_Month -1
12010 END DEFine
12020 :
12030 DEFine FuNction Month_No%(txt$)
12040 LOCal jj
12050   jj = 0
12060   REPeat fmnth : jj=jj+1 : IF txt$ == m$(jj) : EXIT fmnth
12070   RETurn jj
12080 END DEFine
12090 :
12100 DEFine PROCedure Clear_Line
12110 LOCal x,v
12120   x=76 : v=0
12130   AT v,0 : Set_PapInk : PRINT FILL$(" ",x)
12140 END DEFine
12150 :
12160 DEFine FuNction Decimal$(num)
12170 LOCal x$(12), ii, q, p
12180   q = 100 * num
12190   IF ABS(q) >= .5 : q = INT(ABS(q) + .5) : ELSE : q = 0
12200   p = INT(q/100) : ii = q - p * 100
12210   x$ = p
12220   SELect ON ii
12230     = 0         : x$ = x$ & ".00"
12240     = 1 TO 9    : x$ = x$ & ".0" & ii
12250     = REMAINDER : x$ = x$ & "." & ii
12260   END SELect
12270   IF num < 0 : x$ = '-' & x$
12280   x$ = FILL$(" ",money_fieldsize%-LEN(x$)) & x$
12290   RETurn x$
12300 END DEFine
12310 :
12320 DEFine FuNction Max_Short%(a%, b%)
12330   IF a% > b% : RETurn a% : ELSE : RETurn b%
12340 END DEFine
12350 :
12360 DEFine FuNction Min_Short%(a%, b%)
12370   IF a% < b% : RETurn a% : ELSE : RETurn b%
12380 END DEFine
12390 :
12400 DEFine FuNction Within(val, min, max)
12410   RETurn val >= min AND val <= max
12420 END DEFine
12430 :
12440 DEFine FuNction Pull_Up$(off)
12450 LOCal x$(50),lenf%
12460   x$ = '':lenf%=PEEK_W(addr+off)
12470   FOR ii = 1 TO lenf% : x$ = x$ & CHR$(PEEK(addr+off+1+ii))
12480   ii = ' ' INSTR x$ : IF ii = 0 : RETurn x$
12490   RETurn x$(1 TO ii-1)
12500 END DEFine
