1000 REMark CT_ANALYSER - Analysis module for Trading Accounts
1010 REMark Amended 24/3/2002 by Rich Mellor
1020 :
1030 DATA_AREA 25
1040 TURBO_objfil "win2_ct_analyser_exe"
1050 TURBO_taskn  "CTAnalys 3.9"
1060 TURBO_objdat 25
1070 TURBO_repfil
1080 TURBO_diags 'd' : TURBO_struct 's' : TURBO_model '>'
1090 TURBO_optim 'b' : TURBO_locstr 'i' : TURBO_windo 0
1100 :
1110 IMPLICIT%  rng_min, rng_max, rng_sel, control, filno, repno, yr, dy, hr
1120 IMPLICIT%  ht, vt, hhh, vvv, key, hh, ii, jj, kk, tr, te, std, fgd
1130 IMPLICIT%  docsort
1140 DIM vers$(10) : vers$ = "CTver 3.9"
1150 :
1160 REMark   Extra cmds/fns:  BGET, FOP_IN
1170 :
1180 REMark  An EXTRACT file set comprises:
1190 REMark    doc hddr file
1200 REMark    transaction file
1210 REMark    group heads
1220 REMark    analysis heads
1230 REMark    vatfile
1240 REMark    selection parameter set
1250 REMark    (optional) sort order file
1260 :
1270 WHEN ERRor
1280   WINDOW 258,70,120,70 : BORDER 1,0 : PAPER 4 : INK 0
1290   CLS : PRINT \' An error has occurred ... (';ERNUM%!!ERLIN%;')'
1300   PRINT ' Please check correct volumes are loaded'
1310   PRINT ' and ';drive2$;' is write enabled'
1320   PRINT \'    Press ENTER to retry; ESC to quit '
1330   Get_Key : IF exception : STOP
1340   CLS : RETRY
1350   END WHEN
1360 :
1370 Initialise_Tables
1380 Do_Main_Process
1390 STOP
1400 :
1410 DATA "Dec",31,"Jan",31,"Feb",28,"Mar",31,"Apr",30,"May",31,"Jun",30,"Jul",31,"Aug",31,"Sep",30,"Oct",31,"Nov",30,"Dec",31
1420 :
1430 DATA "Unspec. CASH","CHEQUE......","STNDNG ORDER","DIRECT DEBIT"
1440 DATA "TRANSFER....","INTEREST....","BANK CHARGES","UNPAID CHQUE"
1450 DATA "   PAID   ","ADJUSTMENT"," RECEIVED ","BOUGHT  CR"," SOLD  CR "
1460 :
1470 REMark DATA " SALES............ "," COST OF SALES.... "," OVERHEADS........ "
1480 REMark DATA " FIXED ASSETS..... "," CAPITAL EMPLOYED. ","CRNT ASSET/LIABILTY","YES","NO "
1490 :
1500 DATA " Sort Extracted File "," Make Extraction File "
1510 DATA " Print Extracted File "," Respecify Input File "," Exit to Main Menu "
1520 :
1530 DATA " Documents Review "," Profit & Loss A/C Print "
1540 DATA " Balance Sheet Print "," Trial Balance Print "
1550 DATA " Reconciliation Print "," Exit to Analyser Menu "
1560 :
1570 DATA " Sorts Extracted File into Date order    OR Date within Analysis order"
1580 DATA "  Extracts Data using specified          selection criteria."
1590 DATA " Print reports from pre-extracted File"
1600 DATA " Changes back to the Main Files   or     Selects a previous Extracted set"
1610 DATA " Close Down Analyser and return to the   Trading Accounts Main menu"
1620 :
1630 DATA 23,1,12, 25,2,10, 20,3,15, 20,4,15, 27,5,8, 23,6,12, 31,7,4, 15,8,20
1640 DATA 53,1,4, 53,2,4, 53,3,4, 53,7,4, 53,8,4, 46,4,11, 46,5,11, 45,1,12
1650 :
1660 DEFine PROCedure Initialise_Tables
1670   DIM drive3$(42), root$(12), current_source$(12), source_device$(6)
1680   DIM drive1$(42),drive2$(42),cart$(6),prtr$(10)
1690   DIM f$(2),n$(70),used$(12),file$(42)
1700   DIM last_used_doc_date$(12),doc_reftxt$(12)
1710   DIM fullname$(42),example$(4),name$(42),last$(20),create$(20),vatno$(20)
1720   DIM nextvat$(20), eoy$(20), form$(6), extract$(10), vfq$(6)
1730   DIM prin$(6), lastvat$(20), pr_condens$(20), pr_normal$(20)
1740   :
1750   DIM doc_date$(12)
1760   DIM dat$(20), start$(20), finish$(20), reference$(12), comment$(30)
1770   DIM wk$(30), wka$(30), sel_st_date$(30), sel_nd_date$(30)
1780   :
1790   size_of_ramdisc = 290 : REMark Work space size if RAM seleted
1800   :
1810   money_fieldsize% = 10
1820   IF COMPILED:addr=OPTION_CMD$
1830   :
1840   IF COMPILED
1850     drive1$ = Pull_Up$(0)
1860     drive2$ = Pull_Up$(44)
1870     cart$   = Pull_Up$(88)
1880     prtr$   = Pull_Up$(96)
1890     tran_lim_max% = PEEK_W(addr+110)
1900     anal_lim_max% = PEEK_W(addr+112)
1910     grup_lim_max% = PEEK_W(addr+114)
1920     vatf_lim_max% = PEEK_W(addr+116)
1930     lines_per_doc_max% = PEEK_W(addr+118)
1940     baudr% = PEEK_W(addr+120)
1950   ELSE
1960     drive1$ = "ram1_"
1970     drive2$ = "ram1_"
1980     cart$   = "DISK"
1990     prtr$   = "ram1_test"
2000     tran_lim_max% = 4000
2010     anal_lim_max% = 460
2020     grup_lim_max% = 20
2030     vatf_lim_max% = 9
2040     lines_per_doc_max% = 30
2050     baudr% = 9600
2060   END IF
2070 :
2080   OPEN #14,'con' : IF COMPILED : OPEN #1,'scr'
2090   REMark *^*  This stuff should be part of config data ?? ct_sys ??
2100 :
2110   pr_condens$ = CHR$(27) & "M" & CHR$(27) & CHR$(15)
2120   pr_normal$ = CHR$(18)
2130 :
2140   sel_st_date$ = DATE$
2150   sel_nd_date$ = ""
2160   lf_arrow% = 192 : rt_arrow% = 200 : up_arrow% = 208 : dn_arrow% = 216
2170   ctrl_lf%  = 194 : ctrl_rt%  = 202 : del_lf%   = 194
2180   F1_key%   = 232 : F2_key%   = 236 : ENTER%    = 10  : ESC% = 27
2190   report_base = 6
2200   rep_vat    = 1
2210   rep_review = 2
2220   rep_pandl  = 3
2230   rep_balsht = 4
2240   rep_trialb = 5
2250   rep_recon  = 6
2260 :
2270   old_format = 1
2280 :
2290   doc_st_date% = 1  : doc_nd_date% = 9
2300   doc_st_type% = 10 : doc_nd_type% = 11
2310   doc_st_acct% = 12 : doc_nd_acct% = 15
2320   doc_st_ref%  = 16 : doc_nd_ref%  = 16
2330   doc_st_reft% = 17 : doc_nd_reft% = 24
2340   doc_st_no%   = 25 : doc_nd_no%   = 28
2350   doc_st_totv% = 29 : doc_nd_totv% = 38
2360   doc_st_vat%  = 39 : doc_nd_vat%  = 48
2370   doc_st_frst% = 49 : doc_nd_frst% = 52
2380   doc_st_lins% = 53 : doc_nd_lins% = 55
2390 :
2400   dci_st_val%  = 1  : dci_nd_val%  = 10
2410   dci_st_com%  = 11 : dci_nd_com%  = 30
2420   dci_st_anl%  = 31 : dci_nd_anl%  = 34
2430   dci_st_vcd%  = 35 : dci_nd_vcd%  = 36
2440   IF old_format
2450     dci_st_anl%  = 31 : dci_nd_anl%  = 33
2460     dci_st_vcd%  = 34 : dci_nd_vcd%  = 35
2470   END IF
2480 :
2490   grp_st_desc% = 1  : grp_nd_desc% = 15
2500   grp_st_rept% = 16 : grp_nd_rept% = 16
2510   grp_st_popl% = 17 : grp_nd_popl% = 20
2520   grp_st_mpop% = 21 : grp_nd_mpop% = 24
2530   IF old_format
2540     grp_st_popl% = 17 : grp_nd_popl% = 19
2550     grp_st_mpop% = 20 : grp_nd_mpop% = 22
2560   END IF
2570 :
2580   anl_st_desc% = 1  : anl_nd_desc% = 15
2590   anl_st_vtcd% = 16 : anl_nd_vtcd% = 17
2600   anl_st_blnc% = 18 : anl_nd_blnc% = 27
2610   anl_st_pric% = 28 : anl_nd_pric% = 32
2620   IF old_format
2630     anl_st_vtcd% = 16 : anl_nd_vtcd% = 16
2640     anl_st_blnc% = 17 : anl_nd_blnc% = 26
2650     anl_st_pric% = 27 : anl_nd_pric% = 31
2660   END IF
2670 :
2680   vat_st_pcnt% = 1  : vat_nd_pcnt% = 5
2690   vat_st_desc% = 6  : vat_nd_desc% = 9
2700   vat_st_gros% = 10 : vat_nd_gros% = 19
2710   vat_st_vat%  = 20 : vat_nd_vat%  = 29
2720 :
2730   vat_st_ludd% = 1  : vat_nd_ludd% = 9
2740   vat_st_docc% = 10 : vat_nd_docc% = 13
2750   vat_st_tran% = 14 : vat_nd_tran% = 17
2760 :
2770   RETRY_HERE
2780   OPEN_IN #5,drive2$ & 'ct_register'
2790   INPUT #5,fullname$, example$, name$, last$, create$, vatno$
2800   CLOSE #5 : used$=last$(10 TO 12)&last$(6 TO 9)&last$(3 TO 4)
2810   OPEN_IN #5,drive2$ & "ct_paramfile"
2820   INPUT #5,nextvat$, eoy$, printlines%, form$, extract$, vfq$
2830   INPUT #5,prin$, lastvat$, vatclear, vatdoc : CLOSE #5
2840 :
2850   Show_Name 220
2860   Draw_Box 1,284,79,123,92,2,4,0
2870   INK 0
2880   PRINT \"  Analyser will use ";drive1$;" as a work device"
2890   PRINT "  Would you like it to use another (e.g. RAM)"
2900   PRINT \," Press Y or N"
2910   Wait_for_YN
2920   IF f$ == "n"
2930     drive3$ = drive1$
2940     CLS
2950     IF drive2$ <> drive1$
2960       PRINT \"  Take out the Program ";cart$;" from ";drive1$
2970       PRINT " Place your current Data ";cart$;" in ";drive2$
2980     END IF
2990     PRINT \\,"  When ready press ENTER."
3000   ELSE
3010     drive3$ = New_Device_Name$(1,"ram1_")
3020   END IF
3030 :
3040 DIM options$(18,16),m$(12,3),m%(12)
3050 DIM rg(7) : REMark rept_grp$(8,19)
3060 DIM vatf_pcnt(vatf_lim_max%), vatf_desc$(vatf_lim_max%,4)
3070 DIM vatf_gros(vatf_lim_max%), vatf_vat(vatf_lim_max%)
3080 DIM vatf_rate$ (3,8)
3090 DIM anal_blnc(anal_lim_max%), anal_desc$(anal_lim_max%,15)
3100 DIM anal_vtcd%(anal_lim_max%), anal_price%(anal_lim_max%)
3110 DIM grup_desc$(grup_lim_max%,15), grup_max_popl%(grup_lim_max%)
3120 DIM grup_rept%(grup_lim_max%), grup_popl%(grup_lim_max%)
3130 DIM doci_val(lines_per_doc_max%), doci_com$(lines_per_doc_max%,20)
3140 DIM doci_vcd%(lines_per_doc_max%), doci_anl%(lines_per_doc_max%)
3150 DIM doci_vat(lines_per_doc_max%)
3160 DIM op$(11,27),ms$(5,80)
3170 :
3180   param_lim% = 16
3190 DIM ef$(param_lim%,20),lc_col%(param_lim%),lc_lin%(param_lim%),lc_wid%(param_lim%)
3200 DIM p$(param_lim%,20)
3210 DIM select_basis%(7)
3220 DIM grup_total(grup_lim_max%), c(3)
3230 :
3240   RESTORE
3250   FOR ii=0 TO 12 : READ m$(ii),m%(ii)
3260   FOR ii=1 TO 13 : READ options$(ii)
3270   REMark FOR ii=1 TO 8  : READ rept_grp$(ii)
3280   FOR ii=1 TO 11 : READ op$(ii)
3290   FOR ii=1 TO 5  : READ ms$(ii)
3300   FOR ii=1 TO param_lim% : READ lc_col%(ii),lc_lin%(ii),lc_wid%(ii)
3310 :
3320   Wait_for_Enter
3330   RETRY_HERE
3340 :
3350   source_is_extract = 0
3360 :
3370   Setup_Analysis_Tables
3380   Zap_Parameters
3390 :
3400   type_base%  = 8  : REMark Lowest Doc Type in options$ -1
3410   vat_base%   = 13 : REMark Lowest VAT hdng in options$ -1
3420   vat_lim%    = 18 : REMark Highest VAT hdng in options$
3430 :
3440   FOR ii=0 TO 4 : options$(vat_base%+1+ii)=vatf_desc$(ii)
3450 END DEFine
3460 :
3470 DEFine FuNction New_Device_Name$(exclude,dflt$)
3480   REPeat dvc_lp
3490     CLS : PRINT \"  Enter the name of the"\"  Extract device "
3500     IF exclude : PRINT "   [You may not nominate ";drive2$;"]"
3510     wk$ = Kbd_String$(19, 2, 5, 2, dflt$)
3520     IF LEN(wk$) <> 5
3530       wk$ = dflt$ : ELSE
3540       IF (exclude AND wk$ == drive2$)
3550         wk$ = dflt$ : ELSE
3560         IF wk$(5) <> '_' : wk$ = dflt$
3570         END IF : END IF
3580     PAPER 4
3590     IF NOT exclude : RETurn wk$
3600     AT 5,0 : PRINT '   ';wk$;' is OK?  ESC to retry'
3610     Get_Key
3620     IF exception : NEXT dvc_lp
3630     AT 5,0 : PRINT '   Press ENTER to continue   '
3640     RETurn wk$
3650     END REPeat dvc_lp
3660   END DEFine
3670 :
3680 DEFine PROCedure Do_Main_Process
3690   RETRY_HERE
3700   OPEN #9,'scr' : OPEN #3,'scr' : INK #3,2 : Show_Menu
3710   REPeat menuloop
3720     Get_Menu_Choice 5,144,7,1,5,1+(p$(3) < 1)
3730     SELect ON rng_sel
3740       =1 : IF p$(3) > 0 : Sort_by_Date p$(3) : ELSE : Moan
3750       =2 : IF p$(2) > 0 AND (p$(3) > 0 OR NOT source_is_extract)
3760              Specify_Extraction
3770              IF NOT exception : Extract
3780              Show_Menu
3790            ELSE
3795              Moan
3797            END IF
3800       =3 : IF p$(3) > 0 : Print_Report : ELSE : Moan
3810       =4 : Change_Input_Set
3820       =5 : EXIT menuloop
3830       END SELect
3840     END REPeat menuloop
3850   CLS : INK 7
3860   IF drive1$ = drive3$ AND drive1$ <> drive2$
3870     PRINT \" Ensure that the Program ";cart$
3880     PRINT \," is in ";drive1$
3890     PRINT \" Press ENTER when ready."
3900     Wait_for_Enter
3905   END IF
3910 END DEFine
3920 :
3930 DEFine PROCedure Show_Name(paph%)
3940   WINDOW 512,256,0,0 : PAPER paph% : CLS
3950   SCALE 110,0,0
3960   WINDOW 256,125,20,9 : Draw_Logo paph%
3970   Draw_Box 1,298,40,158,11,2,7,0 : INK 2
3980   CURSOR 0,7 : CSIZE 2,1 : PRINT "      CT Analyser"; : CSIZE 0,0
3990 END DEFine
4000 :
4010 DEFine PROCedure Show_Menu
4020   Show_Name 4
4030   Draw_Box 1,200,120,256,65,7,144,0
4040   Draw_Box 3,133,42,57,110,7,0,0
4050   Show_Extract_Summary
4060   Draw_Box 9,250,26,131,200,7,2,0 : INK #9,7
4070   END DEFine
4080 :
4090 DEFine PROCedure Show_Extract_Summary
4100   CLS #3
4110   IF source_is_extract
4120     PRINT #3;" Name: "&p$(1)\" Documents  "&p$(3)
4130     IF p$(4)="NO"
4140       PRINT #3;" Not Date Sorted"
4150       ELSE
4160       IF p$(4) = 'YES'
4170         PRINT #3;" Date Sorted" : ELSE : PRINT #3;" Analysis/Date Sort"
4180         END IF : END IF
4190   ELSE
4200     PRINT #3;\" No Extraction File"\"      present"
4210   END IF
4220 END DEFine
4230 :
4240 DEFine PROCedure Draw_Logo(inkh%)
4250   INK 0 : FILL 1 : CIRCLE 30,85,20
4260   INK inkh% : FILL 1 : CIRCLE 30,85,13
4270   INK 0 : FILL 1 : LINE 48,64 TO 52,69 TO 43,74 TO 39,69 TO 48,64
4280   FILL 1 : INK 0
4290   LINE 55,104 TO 55,65 TO 82,65 TO 82,71 TO 63,71 TO 63,104 TO 55,104
4300   FILL 0
4310   END DEFine
4320 :
4330 DEFine PROCedure Draw_Box(chn%,wdth%,hight%,ht,vt,edge%,top%,side%)
4340 LOCal ii
4350   WINDOW #chn%,512,256,0,0
4360   BLOCK #chn%,wdth%,hight%,ht+20,vt+10, edge%
4370   FOR ii=19 TO 0 STEP -1
4380     BLOCK #chn%,wdth%-8,hight%-8,ht+5+ii,vt+4+(ii/2), side%
4390     END FOR ii
4400   WINDOW #chn%,wdth%,hight%,ht,vt : BORDER #chn%,3,edge%
4410   PAPER #chn%,top% : CLS #chn%
4420   END DEFine
4430 :
4440 DEFine PROCedure Get_Doc_Hddr
4450   INPUT #10,n$
4460   doc_date$   = n$(doc_st_date% TO doc_nd_date%)
4470   doc_type%   = n$(doc_st_type% TO doc_nd_type%)
4480   doc_acct%   = n$(doc_st_acct% TO doc_nd_acct%)
4490   doc_ref%    = n$(doc_st_ref%  TO doc_nd_ref%)
4500   doc_reftxt$ = n$(doc_st_reft% TO doc_nd_reft%)
4510   doc_no%     = n$(doc_st_no%   TO doc_nd_no%)
4520   doc_totvl   = n$(doc_st_totv% TO doc_nd_totv%)
4530   doc_vat     = n$(doc_st_vat%  TO doc_nd_vat%)
4540   doc_first%  = n$(doc_st_frst% TO doc_nd_frst%)
4550   doc_lin_ct% = n$(doc_st_lins% TO doc_nd_lins%)
4560   END DEFine
4570 :
4580 DEFine PROCedure Get_Document
4590 LOCal ii
4600   Get_Doc_Hddr
4610   FOR ii=1 TO doc_lin_ct%
4620     INPUT #11,n$
4630     doci_val(ii)  = n$(dci_st_val% TO dci_nd_val%)
4640     doci_com$(ii) = n$(dci_st_com% TO dci_nd_com%)
4650     doci_anl%(ii) = n$(dci_st_anl% TO dci_nd_anl%)
4660     doci_vcd%(ii) = n$(dci_st_vcd% TO dci_nd_vcd%)
4670     END FOR ii
4680   END DEFine
4690 :
4700 DEFine PROCedure Position_at_Document(begin)
4710 LOCal x
4720   Identify_File 5 : OPEN #10,file$
4722   BGET #10\begin*(rec_lenf%+1)
4730   INPUT #10,n$ : x=n$(doc_st_frst% TO doc_nd_frst%)
4740   BGET #10\begin*(rec_lenf%+1)
4750   Identify_File 1 : OPEN #11,file$ : BGET #11\x*(rec_lenf%+1)
4760   END DEFine
4770 :
4780 DEFine PROCedure Identify_File(filno)
4790   IF source_is_extract
4800     SELect ON filno
4810       =1 : file$=root$ & "_xtrn" : rec_lenf%=36 : IF old_format : rec_lenf% = 35
4820       =2 : file$=root$ & "_xgrp" : rec_lenf%=24 : IF old_format : rec_lenf% = 22
4830       =3 : file$=root$ & "_xanl" : rec_lenf%=32 : IF old_format : rec_lenf% = 31
4840       =4 : file$=root$ & "_xvat" : rec_lenf%=29
4850       =5 : file$=root$ & "_xhdr" : rec_lenf%=60
4860       =6 : file$=root$ & "_xnam" : rec_lenf%= 0
4870       =7 : file$=root$ & "_xsrt" : rec_lenf%= 0
4880       =REMAINDER : CLS : PRINT "wrong filenumber" : STOP
4890       END SELect
4900     IF root$ = current_source$
4910       file$ = source_device$ & file$
4920       ELSE : file$=drive3$ & file$ : END IF
4930     ELSE
4940     SELect ON filno
4950       =1 : file$="ct_transact_dat" : rec_lenf%=36 : IF old_format : rec_lenf% = 35
4960       =2 : file$="ct_group_dat"    : rec_lenf%=24 : IF old_format : rec_lenf% = 22
4970       =3 : file$="ct_analysis_dat" : rec_lenf%=32 : IF old_format : rec_lenf% = 31
4980       =4 : file$="ct_vatfile_dat"  : rec_lenf%=29
4990       =5 : file$="ct_header_dat"   : rec_lenf%=60
5000       =REMAINDER : CLS : PRINT "wrong filenumber" : STOP
5010       END SELect
5020     file$=drive2$ & file$
5030     END IF
5040   END DEFine
5050 :
5060 DEFine PROCedure Change_Input_Set
5070   IF source_is_extract
5080     CLS
5090     PRINT \\\'  Change to Full File'\,' or Extract File'
5100       PRINT \'      Enter F or E' : Get_Key
5110     ELSE : f$ = 'E' : END IF
5120   IF f$ == 'E' : Get_New_Extract : ELSE : Reset_to_Full
5130   END DEFine
5140 :
5150 DEFine PROCedure Get_New_Extract
5160   wk$ = drive3$ : wka$ = ""
5170   REPeat fl_lp
5180     wk$ = New_Device_Name$(0, wk$)
5190     IF exception : RETurn
5200     AT 4,0 : PRINT "  What is the Extract name:"
5210     REPeat fnm_lp
5220       wka$ = Kbd_String$(10, 5, 12, 2, wka$)
5230       IF NOT (wka$ == root$) : EXIT fnm_lp
5240       Moan
5244     END REPeat fnm_lp
5250     PAPER 4 : IF exception : RETurn
5260     x = FOP_IN(#5, wk$ & wka$ & '_xnam')
5270     IF NOT x : CLOSE #5 : EXIT fl_lp
5280     PRINT \\'  Place Extract ';cart$;' in ';wk$\'  & press ENTER'
5290     Get_Key
5300     END REPeat fl_lp
5310   source_is_extract = 1 : root$ = wka$ : source_device$ = wk$
5320   Refresh_Extract
5330   Display_Criteria : Reset_Window_9
5340   PRINT #9,"      Press ENTER to continue"
5350   Wait_for_Enter : Show_Menu
5360   END DEFine
5370 :
5380 DEFine PROCedure Refresh_Extract
5390   current_source$ = root$
5400   Identify_File 6 : OPEN_IN #5, file$
5410   FOR ii=1 TO param_lim% : INPUT #5,p$(ii)
5420   CLOSE #5
5430   Setup_Analysis_Tables
5440   END DEFine
5450 :
5460 DEFine PROCedure Reset_to_Full
5470   REPeat rtf_lp
5480     CLS : PRINT \\'  Put Data ';cart$;' in ';drive2$
5490     PRINT \\'  Press ENTER to continue'
5500     Wait_for_Enter : IF exception : RETurn
5510     source_is_extract = 0 : Identify_File 5
5520     IF NOT FOP_IN(#5,file$) : EXIT rtf_lp
5530     source_is_extract = 1
5540     END REPeat rtf_lp
5550   CLOSE #5
5560   Setup_Analysis_Tables
5570   Zap_Parameters
5580   Show_Extract_Summary
5590   END DEFine
5600 :
5610 DEFine PROCedure Zap_Parameters
5620   root$ = 'System File ' : Reset_Parameters 1,doc_ct%
5630   END DEFine
5640 :
5650 DEFine PROCedure Reset_Parameters(st%, nd%)
5660   FOR ii=1 TO param_lim% : p$(ii)="0"
5670   p$(2) = doc_ct% : p$(4) = "NO" : p$(5)=st% : p$(6)=nd%
5680   p$(14)="NO" : p$(15)="NO" : p$(16) = root$ : current_source$ = root$
5690   END DEFine
5700 :
5710 DEFine PROCedure Setup_Analysis_Tables
5720 LOCal ii
5730   CLS : PRINT \\\'     Reading Files'\\'     Do not disturb'
5740   Identify_File 2 :OPEN_IN #5,file$ : INPUT #5,n$
5750   FOR ii=1 TO grup_lim_max%
5760     INPUT #5,n$ : n$ = n$ & "00000"
5770     grup_desc$(ii)     = n$(grp_st_desc% TO grp_nd_desc%)
5780     grup_rept%(ii)     = n$(grp_st_rept% TO grp_nd_rept%)
5790     grup_popl%(ii)     = n$(grp_st_popl% TO grp_nd_popl%)
5800     grup_max_popl%(ii) = n$(grp_st_mpop% TO grp_nd_mpop%)
5810   END FOR ii
5820   CLOSE #5 : Identify_File 3 : OPEN_IN #5,file$ : INPUT #5,n$
5830   FOR ii=1 TO Active_Heads%
5840     INPUT #5,n$ : n$ = n$ & "00000"
5850     anal_desc$(ii)  = n$(anl_st_desc% TO anl_nd_desc%)
5860     anal_vtcd%(ii)  = n$(anl_st_vtcd% TO anl_nd_vtcd%)
5870     anal_blnc(ii)   = n$(anl_st_blnc% TO anl_nd_blnc%)
5880     anal_price%(ii) = n$(anl_st_pric% TO anl_nd_pric%)
5890     END FOR ii
5900   CLOSE #5 : Identify_File 4 : OPEN_IN #5,file$
5910   FOR ii=0 TO vatf_lim_max%
5920     INPUT #5,n$
5930     vatf_pcnt(ii)  = n$(vat_st_pcnt% TO vat_nd_pcnt%)
5940     vatf_desc$(ii) = n$(vat_st_desc% TO vat_nd_desc%)
5950     vatf_gros(ii)  = n$(vat_st_gros% TO vat_nd_gros%)
5960     vatf_vat(ii)   = n$(vat_st_vat%  TO vat_nd_vat%)
5970     END FOR ii
5980   INPUT #5,n$
5990   last_used_doc_date$ = n$(vat_st_ludd% TO vat_nd_ludd%)
6000   doc_ct%             = n$(vat_st_docc% TO vat_nd_docc%)
6010   tran_ct%            = n$(vat_st_tran% TO vat_nd_tran%)
6020   INPUT #5,n$
6030   FOR ii=0 TO 3 : vatf_rate$(ii)=n$((ii*8)+1 TO (ii*8)+8)
6040   CLOSE #5 : grup_desc$(0) = "COMMENT ONLY..."
6050   END DEFine
6060 :
6070 DEFine FuNction Analysis_Base%(grp%)
6080 LOCal ii, jj
6090   jj = 1
6100   FOR ii=1 TO grp%-1 : jj = jj + grup_max_popl%(ii)
6110   RETurn jj
6120   END DEFine
6130 :
6140 DEFine FuNction Analysis_Group%(analcd%)
6150 LOCal ii, jj
6160   jj = analcd%
6170   FOR ii = 1 TO grup_lim_max%
6180     jj = jj-grup_max_popl%(ii) : IF jj <= 0 : RETurn ii
6190     END FOR ii
6195   RETurn ii
6200 END DEFine
6210 :
6220 DEFine PROCedure Moan
6230   BEEP 5000,1
6240   END DEFine
6250 :
6260 DEFine PROCedure Set_PapInk
6270   PAPER 2 : INK 0
6280   END DEFine
6290 :
6300 DEFine PROCedure Reset_PapInk
6310   PAPER 0 : INK 7
6320   END DEFine
6330 :
6340 DEFine PROCedure Store (filno,rcd)
6350 LOCal x$(10)
6360   Identify_File filno : n$=FILL$(" ",rec_lenf%)
6370   SELect ON filno
6380     =1 : n$(dci_st_val% TO dci_nd_val%) = Decimal$(doci_val(rcd))
6390          n$(dci_st_com% TO dci_nd_com%) = doci_com$(rcd)
6400          n$(dci_st_anl% TO dci_nd_anl%) = doci_anl%(rcd)
6410          n$(dci_st_vcd% TO dci_nd_vcd%) = doci_vcd%(rcd)
6420     =2 : n$(grp_st_desc% TO grp_nd_desc%) = grup_desc$(rcd)
6430          n$(grp_st_rept% TO grp_nd_rept%) = grup_rept%(rcd)
6440          n$(grp_st_popl% TO grp_nd_popl%) = grup_popl%(rcd)
6450          n$(grp_st_mpop% TO grp_nd_mpop%) = grup_max_popl%(rcd)
6460     =3 : n$(anl_st_desc% TO anl_nd_desc%) = anal_desc$(rcd)
6470          n$(anl_st_vtcd% TO anl_nd_vtcd%) = anal_vtcd%(rcd)
6480          n$(anl_st_blnc% TO anl_nd_blnc%) = Decimal$(anal_blnc(rcd))
6490          n$(anl_st_pric% TO anl_nd_pric%) = anal_price%(rcd)
6500     =4 : x$=Decimal$(vatf_pcnt(rcd))
6510          n$(vat_st_pcnt% TO vat_nd_pcnt%) = x$(6 TO)
6520          n$(vat_st_desc% TO vat_nd_desc%) = vatf_desc$(rcd)
6530          n$(vat_st_gros% TO vat_nd_gros%) = Decimal$(vatf_gros(rcd))
6540          n$(vat_st_vat%  TO vat_nd_vat%)  = Decimal$(vatf_vat(rcd))
6550     =5 : n$(doc_st_date% TO doc_nd_date%) = doc_date$
6560          n$(doc_st_type% TO doc_nd_type%) = doc_type%
6570          n$(doc_st_acct% TO doc_nd_acct%) = doc_acct%
6580          n$(doc_st_ref%  TO doc_nd_ref%)  = doc_ref%
6590          n$(doc_st_reft% TO doc_nd_reft%) = doc_reftxt$
6600          n$(doc_st_no%   TO doc_nd_no%)   = doc_no%
6610          n$(doc_st_totv% TO doc_nd_totv%) = Decimal$(doc_totvl)
6620          n$(doc_st_vat%  TO doc_nd_vat%)  = Decimal$(doc_vat)
6630          n$(doc_st_frst% TO doc_nd_frst%) = op_tranct% +1
6640          n$(doc_st_lins% TO doc_nd_lins%) = doc_lin_ct%
6650          n$(doc_nd_lins%+1 TO)            = "00000000"
6660 REMark op_tranct% : Trans no of 1st line of doc
6670     END SELect
6680   END DEFine
6690 :
6700 DEFine PROCedure Storeanal
6710 LOCal ii
6720   Identify_File 3 : DELETE file$ : OPEN_NEW #5, file$
6730   n$ = FILL$(' ',rec_lenf%) : n$(1 TO 6) = anal_lim_max%
6740   PRINT #5,n$
6750   FOR ii=1 TO Active_Heads% : Store 3,ii : PRINT #5,n$
6760   CLOSE #5
6770   Identify_File 2 : DELETE file$ : OPEN_NEW #5, file$
6780   n$ = FILL$(' ',rec_lenf%) : n$(1 TO 6) = grup_lim_max%
6790   PRINT #5,n$
6800   FOR ii=1 TO grup_lim_max% : Store 2,ii : PRINT #5,n$
6810   CLOSE #5
6820   END DEFine
6830 :
6840 DEFine PROCedure Storevat
6850 LOCal ii
6860   Identify_File 4 : DELETE file$ : OPEN_NEW #5, file$
6870   FOR ii=0 TO vatf_lim_max% : Store 4,ii : PRINT #5,n$
6880   n$=FILL$(" ",29)
6890   n$(vat_st_ludd% TO vat_nd_ludd%) = last_used_doc_date$
6900   n$(vat_st_docc% TO vat_nd_docc%) = doc_ct%
6910   n$(vat_st_tran% TO vat_nd_tran%) = tran_ct%
6920   PRINT #5,n$
6930   n$=FILL$(" ",32)
6940   FOR ii=0 TO 3 : n$((ii*8)+1 TO (ii*8)+8)=vatf_rate$(ii)
6950   PRINT #5,n$ : CLOSE #5
6960   END DEFine
6970 :
6980 DEFine FuNction Active_Heads%
6990 LOCal ii, jj
7000   jj = 0
7010   FOR ii=1 TO grup_lim_max% : jj = jj + grup_max_popl%(ii)
7020   RETurn jj
7030   END DEFine
7040 :
7050 DEFine FuNction Using$(wk$,jj)
7060 LOCal kk
7070   kk = jj - LEN(wk$) : IF kk < 0 : kk=0
7080   RETurn FILL$(" ",kk)&wk$
7090   END DEFine
7100 :
7110 DEFine PROCedure Display_Criteria
7120 LOCal ii, ht
7130   Build_Extract_Screen
7140   FOR ii=1 TO 13
7150     ht=lc_col%(ii) : IF ii<9 : ht=35-LEN(ef$(ii))
7160     INK 7 * (ef$(ii)="Not Used")
7170     AT lc_lin%(ii),ht : PRINT ef$(ii)
7180     END FOR ii
7190   Show_Date_Range : INK 7
7200   END DEFine
7210 :
7220 DEFine PROCedure Show_Date_Range
7230   INK 0
7240   IF ef$(14)<>"NO" : AT lc_lin%(14),lc_col%(14) : PRINT ef$(14)
7250   IF ef$(15)<>"NO" : AT lc_lin%(15),lc_col%(15) : PRINT ef$(15)
7260   END DEFine
7270 :
7280 DEFine PROCedure Quick_Zap
7290   WINDOW 512,192,0,64 : PAPER 4 : CLS
7300   Draw_Box 1,360,100,76,100,2,7,0
7310   END DEFine
7320 :
7330 DEFine PROCedure Build_Extract_Screen
7340 LOCal ii, jj
7350   Quick_Zap : PAPER 2 : INK 7 : CLS
7360   ef$(1)=p$(1)
7370   FOR ii=2 TO 8 : ef$(ii)="Not Used"
7380   ef$(9)=p$(2)
7390   ef$(10)=p$(3)
7400   ef$(11)=p$(4)
7410   ef$(12)=p$(5)
7420   ef$(13)=p$(6)
7430   FOR ii=14 TO param_lim% : ef$(ii)=p$(ii)
7440   jj=p$(7) : IF jj<>0 : ef$(2)=options$(jj)
7450   jj=p$(8) : IF jj<>0 : ef$(3)=grup_desc$(jj)
7460   jj=p$(9) : IF jj<>0 : ef$(4)=anal_desc$(jj)
7470   jj=p$(11) : IF jj<>0 : ef$(6)=options$(jj)
7480   IF p$(10)<>"0" AND p$(10)<>"" : ef$(5)=p$(10)
7490   jj=p$(13) : IF jj<>0 : ef$(7)=options$(jj)
7500   IF p$(12)<>"0" AND p$(12)<>"" : ef$(8)=p$(12)
7510   PRINT "    EXTRACTION CRITERIA";FILL$(" ",16);"TOTAL DOCUMENTS"
7520   PRINT " Name of Extract file ";FILL$(".",13);" ";p$(16)
7530   PRINT " Doc. Type";FILL$(".",25);" EXTRACTED ";cart$
7540   PRINT " Analysis Group";FILL$(".",20);" Date Sorted"
7550   PRINT " Analysis Head";FILL$(".",21);
7560   IF p$(14)<>"NO" : PRINT " Start" : ELSE : PRINT
7570   PRINT " Reference";FILL$(".",25);
7580   IF p$(15)<>"NO" : PRINT " Finish" : ELSE : PRINT
7590   PRINT " Payment Type";FILL$(".",22);"    DOCUMENT NUMBERS"
7600   PRINT " VAT Rate";FILL$(".",26);" Starting Doc"
7610   PRINT " Comment";FILL$(".",27);" Finishing Doc"
7620   LINE 185,0 TO 185,120 : LINE 186,0 TO 186,120 : LINE 0,99 TO 320,99
7630   LINE 185,40 TO 320,40 : LINE 185,28 TO 320,28
7640   END DEFine
7650 :
7660 DEFine PROCedure Specify_Extraction
7670 LOCal hh, ii, jj, kk
7680   Quick_Zap
7690   REPeat get_dates
7700     WINDOW 180,100,166,100 : INK 0
7710     PRINT \\"Do you wish to extract by Date " : PRINT "   Y or N ?"
7720     Wait_for_YN
7730     start=0 : finish=0 : start$="NO" : finish$="NO"
7740     IF exception OR f$ == "n" : EXIT get_dates
7750     REPeat try_again
7760       WINDOW 360,100,76,100 : BORDER 3,2 : PAPER 7 : CLS
7770       PRINT \\" Start Date :-" : wk$=sel_st_date$
7780       start$ = Selected_Date$(wk$(1 TO 11))
7790       IF exception : NEXT get_dates
7800       start=Julian_Date(start$)
7810       WINDOW 177,94,256,103 : PRINT \\"Finish Date :-"
7820       IF sel_nd_date$ = "" : sel_nd_date$ = start$
7830       finish$ = Selected_Date$(sel_nd_date$)
7840       IF exception : NEXT get_dates
7850       finish=Julian_Date(finish$)
7860       IF start > finish : Moan : NEXT get_dates
7870       WINDOW 360,100,76,100 : BORDER 3,2
7880       AT 8,4 : PRINT "Correct Y or N ?"
7890       Wait_for_YN
7900       IF f$ == "y"
7910         sel_st_date$ = start$
7920         sel_nd_date$ = finish$
7930         EXIT get_dates : END IF
7940       start=0 : finish=0 : start$="NO" : finish$="NO"
7950       END REPeat try_again
7960     END REPeat get_dates
7970 :
7980   min_docno% = p$(5) : max_docno% = p$(6)
7990   Reset_Parameters min_docno%, max_docno%
8000   p$(14)=start$ : p$(15)=finish$
8010   ef$(10) = "" : ef$(11) = p$(4) : ef$(12)=p$(5) : ef$(13)=p$(6)
8020   Build_Extract_Screen
8030   INK 0
8040   FOR ii=9 TO 13 : AT lc_lin%(ii),lc_col%(ii) : PRINT Using$(ef$(ii),lc_wid%(ii));
8050   Show_Date_Range
8060   control=1
8070   REPeat clp
8080     SELect ON control
8090       =1  : wk$=p$(1) : IF wk$="0" : wk$=""
8100             Help 2 : wk$ = Kbd_String$(23,1,12,2,wk$)
8110             IF wk$ == root$ : Moan : NEXT clp
8120             IF exception
8130               IF source_is_extract : Refresh_Extract
8140               RETurn : END IF
8150             p$(1)=wk$ : control=2 : IF wk$="" : control=1
8160       =2  : rng_sel=p$(7) : rng_min=1 + type_base% : rng_max=vat_base%
8170             Help 1
8180             rng_sel = Chosen_Field_Option%(25,2,options$)
8190             IF exception : control=1 : ELSE : p$(7)=rng_sel : control=3
8200       =3  : rng_max=0 : control=4
8210             FOR ii=1 TO grup_lim_max% : IF grup_rept%(ii)>0 : rng_max=rng_max+1
8220       =4  : rng_sel=p$(8) : rng_min = 1 : group=p$(8)
8230             Help 1
8240             rng_sel = Chosen_Field_Option%(20,3,grup_desc$)
8250             IF exception : control=2 : ELSE : p$(8)=rng_sel : control=5
8260       =5  : control=6
8270             IF rng_sel=0
8280               group=0 : Set_PapInk : AT 4,20 : PRINT "             NO"
8290               control=9 : END IF
8300       =6  : control=7 : jj=rng_sel
8310             IF grup_popl%(jj)=0
8320               Reset_PapInk
8330               AT 3,20 : PRINT grup_desc$(rng_sel)
8340               AT 4,20 : PRINT "   NO  HEADS   "
8350               BEEP 32000,10,100,1,-1,0,0,10000
8360               f$=INKEY$(#14,5000)
8370               Set_PapInk
8380               INK 7 : AT 4,20 : PRINT "..............." : INK 0
8390               p$(8)="0" : control=3
8400               END IF
8410       =7  : control=8 : IF group<>p$(8) : p$(9)='0'
8420       =8  : jj=p$(8)
8430             rng_min = Analysis_Base%((jj))
8440             rng_max = rng_min+grup_popl%(jj)-1
8450             rng_sel = p$(9)
8460             Help 1
8470             rng_sel = Chosen_Field_Option%(20,4,anal_desc$)
8480             IF exception : control=3 : ELSE : p$(9)=rng_sel : control=9
8490       =9  : IF p$(10)="0" : p$(10)=""
8500             Help 3 : p$(10) = Kbd_String$(27,5,8,2,p$(10)) : control=10
8510             IF exception : p$(10)='' : IF group=0 : control=4 : ELSE : control=8
8520       =10 : control=11
8530             IF p$(10)="" : AT 5,27 : PRINT "      NO"
8540       =11 : rng_sel=p$(11) : rng_min=1 : rng_max=type_base%
8550             Help 1
8560             rng_sel = Chosen_Field_Option%(23,6,options$)
8570             IF exception : control=9 : ELSE : p$(11)=rng_sel : control=12
8580       =12 : rng_sel=p$(13) : rng_min=1+vat_base% : rng_max = vat_lim%
8590             Help 1
8600             rng_sel = Chosen_Field_Option%(31,7,options$)
8610             IF exception : control=11 : ELSE : p$(13)=rng_sel : control=13
8620       =13 : IF p$(12)="0" : p$(12)=""
8630             Help 4 : p$(12) = Kbd_String$(15,8,20,2,p$(12)) : control=14
8640             IF exception : p$(12) = '' : control=12
8650       =14 : control=15
8660             IF p$(12)="" : AT 8,15 : PRINT FILL$(" ",18);"NO"
8670       =15 : jj=4-LEN(p$(5)) : p$(5)=FILL$(" ",jj)&p$(5) : jj=p$(5)
8680             Help 5 : hh = Kbd_String$(53,7,4,3,p$(5))
8690             IF exception
8700               control=13
8710               ELSE
8720               control = 16
8730               IF NOT Within(hh,min_docno%,max_docno%)
8740                 p$(5)=jj : control=15
8750                 ELSE
8760                 p$(5)=hh : IF hh > INT(p$(6)) : p$(6)=p$(5)
8770                 END IF : END IF
8780       =16 : jj = 4-LEN(p$(6)) : p$(6)=FILL$(" ",jj)&p$(6) : jj=p$(6)
8790             Help 5 : hh = Kbd_String$(53,8,4,3,p$(6))
8800             IF exception
8810               control=15
8820               ELSE
8830               control = 17
8840               IF NOT Within(hh, p$(5), max_docno%)
8850                 p$(6)=jj : control=16 : ELSE : p$(6)=hh
8860                 END IF : END IF
8870       =17 : CLS #9 : PRINT #9,"Is this Correct Y or N ?"
8880             Wait_for_YN
8890             IF f$=="y" : EXIT clp : ELSE : control=1
8900       END SELect
8910     END REPeat clp
8920   CLS #9
8930   std=p$(5) : fgd=p$(6)
8940   reference$=p$(10) : comment$=p$(12)
8950   IF reference$="NO" : reference$=""
8960   IF comment$="NO" : comment$=""
8970   select_basis%(1) = p$(7)-type_base%   : REMark Doc Type
8980   select_basis%(2) = p$(11)             : REMark Doc Ref Type
8990   select_basis%(3) = (reference$ <> "") : REMark Doc Ref Text
9000   select_basis%(4) = p$(8)              : REMark Analysis Group
9010   select_basis%(5) = p$(9)              : REMark Analysis Head
9020   select_basis%(6) = (comment$ <> "")   : REMark Item Comment
9030   select_basis%(7) = p$(13)-vat_base%   : REMark VAT Code
9040   sel_min% = 9 : sel_max% = 0
9050   FOR ii=1 TO 7
9060     IF select_basis%(ii) <= 0
9070       select_basis%(ii)=0
9080       ELSE
9090       IF ii < sel_min% : sel_min% = ii-1
9100       IF ii > sel_max% : sel_max% = ii
9110       END IF : END FOR ii
9120   IF select_basis%(5)<>0 : select_basis%(4)=0
9130   END DEFine
9140 :
9150 DEFine PROCedure Extract
9160 LOCal hh, ii, jj, kk, control, anl_min%, anl_max%
9170   PAPER 4
9180   IF (drive3$ <> drive2$) AND NOT source_is_extract
9190     CLS : AT 3,10 : PRINT 'Do you want to format ';drive3$
9200     AT 5,15 : PRINT 'Press Y or N' : Wait_for_YN
9210     IF f$ == 'y'
9220       IF ('ram' INSTR drive3$) <> 1
9230         CLS : AT 3,10 : PRINT "Place a Blank ";cart$;" in ";drive3$
9240         AT 5,15 : PRINT "Press ENTER when ready."
9250         Wait_for_Enter
9260         CLS : AT 4,10 : PRINT "Formatting ";drive3$;" - Do not Disturb."
9270         FORMAT drive3$ & 'EXTRACT'
9280         ELSE
9290         CLS : PRINT \\'      What size for ';drive3$
9300         wk$ = size_of_ramdisc
9310         wk$ = Kbd_String$(27,2,4,3,wk$)
9320         IF exception : wk$ = size_of_ramdisc
9330         FORMAT drive3$ & wk$ : PAPER 4
9340         END IF : END IF : END IF
9350   op_docct%=0 : op_tranct%=0
9360   FOR ii=1 TO anal_lim_max% : anal_blnc(ii)=0
9370   FOR ii=0 TO vatf_lim_max% : vatf_gros(ii)=0 : vatf_vat(ii)=0
9380   CLS : AT 2,10 : PRINT "Making Extraction - Do not Disturb"
9390   IF source_is_extract
9400     Position_at_Document 1 : ELSE : Position_at_Document std
9410     END IF
9420 :
9430   source_is_extract = 1 : root$ = p$(1) : source_device$ = drive3$
9440   Identify_File 5 : DELETE file$ : OPEN_NEW #6, file$
9450   n$ = FILL$('*',rec_lenf%) : PRINT #6,n$
9460   Identify_File 1 : DELETE file$ : OPEN_NEW #7, file$
9470   n$ = FILL$('*',rec_lenf%) : PRINT #7,n$
9480   AT 5,10 : PRINT "Reading Document ........ "
9490   IF select_basis%(4) <> 0
9500     anl_min% = Analysis_Base%((select_basis%(4)))
9510     anl_max% = anl_min% + grup_popl%(select_basis%(4))-1
9520     ELSE
9530     anl_min% = select_basis%(5) : anl_max% = anl_min%
9540     END IF
9550   doc_no% = 0
9560   REPeat scn_lp
9570     IF EOF(#10) : EXIT scn_lp
9580     IF doc_no% = fgd : EXIT scn_lp
9590     Get_Document
9600     AT 5,37 : PRINT doc_no%
9610     IF doc_no% < std : NEXT scn_lp
9620     IF doc_no% > fgd : EXIT scn_lp
9630     accept=1
9640     IF start > 0
9650       x=Julian_Date("19"& doc_date$(8 TO 9)& doc_date$(3 TO 7)& doc_date$(1 TO 2))
9660       accept = (x >= start AND x <= finish)
9670       END IF
9680     IF accept
9690       control = sel_min%
9700       REPeat con_loop
9710         control = control + 1
9720         IF NOT accept  : EXIT con_loop
9730         IF control > sel_max%
9740           Store_Document : Recalc_Doc_Stats 1
9750           EXIT con_loop : END IF
9760         IF select_basis%(control)<>0
9770           SELect ON control
9780             =1      : IF (select_basis%(1)-2)<>doc_type% : accept=0
9790             =2      : IF select_basis%(2)<>doc_ref%+1 : accept=0
9800             =3      : IF 0 = (reference$ INSTR doc_reftxt$) : accept=0
9810             =4, 5   : accept=0
9820                       IF Within(doc_acct%, anl_min%, anl_max%) : accept=1 : NEXT con_loop
9830                       FOR jj=1 TO doc_lin_ct%
9840                         IF Within(doci_anl%(jj), anl_min%, anl_max%) : accept=1 : EXIT jj
9850                         END FOR jj
9860             =6      : accept=0
9870                       FOR jj=1 TO doc_lin_ct%
9880                         IF 0<>(comment$ INSTR doci_com$(jj)) : accept=1 : EXIT jj
9890                         END FOR jj
9900             =7      : accept=0
9910                       FOR jj=1 TO doc_lin_ct%
9920                         IF select_basis%(7)=doci_vcd%(jj)+1 : accept=1 : EXIT jj
9930                         END FOR jj
9940             END SELect
9950           END IF
9960         END REPeat con_loop
9970       END IF
9980     END REPeat scn_lp
9990   CLOSE #10 : CLOSE #11 : CLOSE #6 : CLOSE #7
10000   doc_ct%=op_docct% : tran_ct%=op_tranct% : p$(3)=op_docct% : p$(4)="NO"
10010   Storeanal : Storevat : Store_Params
10020   END DEFine
10030 :
10040 DEFine PROCedure Store_Params
10050   Identify_File 6 : DELETE file$ : OPEN_NEW #5, file$
10060   FOR ii=1 TO param_lim% : PRINT #5,p$(ii)
10070   CLOSE #5
10080   END DEFine
10090 :
10100 DEFine PROCedure Store_Document
10110 LOCal ii
10120   Store 5,doc_no% : PRINT #6,n$ : op_docct%=op_docct%+1
10130   FOR ii=1 TO doc_lin_ct% : op_tranct%=op_tranct%+1 : Store 1,ii : PRINT #7,n$
10140   END DEFine
10150 :
10160 DEFine PROCedure Recalc_Doc_Stats(vat_to_be_added)
10170 LOCal ii, jj, kk
10180   doc_cred_deb%=-1 : IF doc_type%=1 OR doc_type%=3 : doc_cred_deb%=1
10190   doc_vat_adjmt=0 : item_value=0
10200   FOR ii=1 TO doc_lin_ct%
10210       REMark IF vat_to_be_added
10220     doci_vat(ii) = Decimal$(doci_val(ii)*vatf_pcnt(doci_vcd%(ii))/100)
10230       REMark ELSE
10240       REMark doci_vat(ii) = Decimal$(doci_val(ii)-((100*doci_val(ii))/(100+vatf_pcnt(doci_vcd%(ii)))))
10250       REMark doci_val(ii) = Decimal$(doci_val(ii)-doci_vat(ii))
10260       REMark END IF
10270     kk = Analysis_Group%(doci_anl%(ii))
10280     IF grup_rept%(kk)=1 OR grup_rept%(kk)=5 : kk=-1 : ELSE : kk=1
10290     anal_blnc(doci_anl%(ii)) = Decimal$(anal_blnc(doci_anl%(ii))-doci_val(ii)*kk*doc_cred_deb%)
10300     item_value = Decimal$(item_value+doci_val(ii))
10310     jj = doci_vcd%(ii)+5*(doc_cred_deb%=-1)
10320     vatf_gros(jj) = Decimal$(vatf_gros(jj)+doci_val(ii))
10330     doc_vat_adjmt = doc_vat_adjmt-vatf_vat(jj)
10340     vatf_vat(jj)  = Decimal$(vatf_vat(jj)+doci_vat(ii))
10350     doc_vat_adjmt = doc_vat_adjmt+vatf_vat(jj)
10360     END FOR ii
10370   IF jj < 5 : jj=1 : ELSE : jj=6
10380   doc_vat_adjmt = doc_vat-doc_vat_adjmt
10390   vatf_vat(jj) = Decimal$(vatf_vat(jj)+doc_vat_adjmt)
10400 REMark  doc_totvl = Decimal$(item_value+doc_vat+doc_vat_adjmt)
10410   anal_blnc(doc_acct%) = Decimal$(anal_blnc(doc_acct%)+(doc_totvl*doc_cred_deb%))
10420   END DEFine
10430 :
10440 DEFine PROCedure Sort_by_Date(doc_ct%)
10450 LOCal ii, jj, lenf, compound_srt
10460 LOCal srt$(doc_ct%, 17), wk$(20), wka$(20)
10470   PAPER 2 : INK 7 : CLS
10480   PRINT \\"  Number of Docs. to sort ";doc_ct%\\"      Continue Y or N "
10490   Wait_for_YN
10500   IF f$=="n" : PAPER 144 : CLS : RETurn
10510   IF p$(9) = "0"
10520     CLS : PRINT \" Sort by Date              (D)"\\,"OR"
10530     PRINT \" Sort by Analysis AND Date (A)"\\,"Enter D or A"
10540     Get_Key
10550     compound_srt = (f$ == "A")
10560     ELSE : compound_srt = 0 : END IF
10570   Position_at_Document 1 : lenf = rec_lenf% + 1
10580   FOR ii=1 TO doc_ct%
10590     Get_Doc_Hddr
10600     jj = Month_No%(doc_date$(4 TO 6))
10610     wka$ = 100 + doc_date$(1 TO 2)
10620     wka$ = (100 + jj) & wka$(2 TO 3)
10630     IF doc_date$(8 TO 9)<50
10640       wk$ = "20" & doc_date$(8 TO 9) & wka$(2 TO 5)
10650     ELSE
10660       wk$ = "19" & doc_date$(8 TO 9) & wka$(2 TO 5)
10670     END IF
10680     IF compound_srt
10690       BGET #11\lenf * doc_first% : INPUT #11,n$
10700       wka$ = 10000 + n$(dci_st_anl% TO dci_nd_anl%)
10710       wka$ = wka$(2 TO 5)
10720       ELSE
10730       wka$ = "" : END IF
10740     srt$(ii) = wka$ & wk$ & ' ' & ii
10750     END FOR ii
10760   CLOSE #10 : CLOSE #11
10770   Sort_Selected_Docs doc_ct%, srt$
10780 :
10790   Identify_File 7 : DELETE file$ : OPEN_NEW #5, file$
10800   jj = 9 + 4 * compound_srt
10810   FOR ii=1 TO doc_ct% : PRINT #5,srt$(ii,jj TO)
10820   CLOSE #5
10830   IF compound_srt : p$(4)="ANL" : ELSE : p$(4)="YES"
10840   Store_Params
10850   CLS #3 : Show_Extract_Summary
10860   PAPER 144 : CLS
10870   END DEFine
10880 :
10890 REFERENCE srt$(0,0)
10900 DEFine PROCedure Sort_Selected_Docs(doc_ct%, srt$)
10910 LOCal ii, jj, kk, x%, y%, wk$(20)
10920   ii = INT(.99+LN(doc_ct%)/LN(2))
10930   CLS : PRINT \\,"Sorting Files "
10940   PRINT \,"Do not Disturb"
10950   PRINT \,FILL$(".",ii)\TO 8;
10960 :
10970   ii = doc_ct%
10980   REPeat sortloop
10990     ii = ii DIV 2 : IF ii = 0 : EXIT sortloop
11000     jj = doc_ct% - ii : kk = 1 : PRINT "";
11010     REPeat midloop
11020       x% = kk
11030       REPeat inloop
11040         y% = x% + ii
11050         IF srt$(x%) <= srt$(y%) : EXIT inloop
11060         wk$      = srt$(x%)
11070         srt$(x%) = srt$(y%)
11080         srt$(y%) = wk$
11090         x% = x% - ii : IF x% < 1 : EXIT inloop
11100         END REPeat inloop
11110       kk = kk + 1 : IF kk > jj : EXIT midloop
11120       END REPeat midloop
11130     END REPeat sortloop
11140   END DEFine
11150 :
11160 DEFine FuNction Month_No%(txt$)
11170 LOCal jj
11180   jj = 0
11190   REPeat fmnth : jj=jj+1 : IF txt$ == m$(jj) : EXIT fmnth
11200   RETurn jj
11210   END DEFine
11220 :
11230 DEFine FuNction Julian_Date(txt$)
11240 LOCal x
11250   x = txt$(1 TO 4)
11260   IF x<1950 THEN x=x+100
11270   x = x * 10000 + 100 * Month_No%(txt$(6 TO 8)) +txt$(10 TO 11)
11280   RETurn x
11290   END DEFine
11300 :
11310 DEFine PROCedure Print_Report
11320 LOCal repno
11330   BAUD baudr%
11340   REPeat reploop
11350     Get_Menu_Choice 5,144,7,6,11,6
11360     prtr_op = 1 : repno = rng_sel - report_base + 2
11370     SELect ON repno
11380       =rep_review : xsort=0
11390                     IF p$(4)<>"NO"
11400                       CLS : PRINT \\\"  Use Sorted Order... Y or N ?"
11410                       Wait_for_YN
11420                       IF f$=="y" : xsort=1
11430                       END IF
11440                     Review_Docs
11450       =rep_pandl  : Print_Profit_Loss
11460       =rep_balsht : Print_Bal_Sheet
11470       =rep_trialb : Print_Trial_Bal
11480       =rep_recon  : Print_Recon
11490       =REMAINDER  : EXIT reploop
11500       END SELect
11510     END REPeat reploop
11520   END DEFine
11530 :
11540 DEFine PROCedure Review_Docs
11550 LOCal d1$(60), d2$(60), ii, jj
11560   Reset_PapInk : CLS
11570   d1$="are" : d2$="Documents"
11580   IF doc_ct% = 1 : d1$="is" : d2$="Document"
11590   d1$="There "&d1$&" "&doc_ct% : d2$ = d2$&" on File."
11600   ii = LEN(d1$) : jj = INT((31-ii)/2) : d1$=FILL$(" ",jj)&d1$
11610   ii = LEN(d2$) : jj = INT((31-ii)/2) : d2$=FILL$(" ",jj)&d2$
11620   Reset_PapInk : PRINT d1$\d2$ : Set_PapInk : CLS 2 : INK 7
11630   AT 2,0 : PRINT "Start at which Document "
11640   REPeat kl
11650     Reset_PapInk : AT 2,24 : PRINT "    "
11660     tr = Kbd_String$(24,2,4,3,p$(5))
11670     Set_PapInk : INK 7
11680     IF exception : RETurn
11690     IF Within(tr, 0, p$(6)) : EXIT kl
11700     END REPeat kl
11710   IF tr=0 : RETurn
11720   AT 3,0 : PRINT "End at which Document "
11730   REPeat km
11740     Reset_PapInk : AT 3,24 : PRINT "    " : d1$='    '&p$(6)
11750     d1$ = d1$(LEN(d1$)-3 TO LEN(d1$))
11760     te = Kbd_String$(24,3,4,3,d1$)
11770     Set_PapInk : INK 7
11780     IF exception : RETurn
11790     IF Within(te, tr, p$(6)) : EXIT km
11800     END REPeat km
11810   AT 5,0 : PRINT "Screen or Printer (S or P)"
11820   Get_Key : IF exception : RETurn
11830   prtr_op = (f$ == 'p')
11840   IF prtr_op : d1$="PRINTER " : ELSE : d1$ = "SCREEN   "
11850   AT 5,18 : PRINT d1$\\"Correct Y or N ?"
11860   Wait_for_YN : IF exception : RETurn
11870   IF f$=="n" : Review_Docs : RETurn
11880   IF prtr_op
11890     OPEN_OVER #7,prtr$ : AT 7,0 : PRINT "PRINTING DOCUMENTS"
11900     ELSE
11910     WINDOW 512,256,0,0 : PAPER 4 : CLS
11920     OPEN #4,'scr' : WINDOW #4,426,50,44,5 : BORDER #4,3,7
11930     PAPER #4,0 : INK #4,7 : CLS #4
11940     PRINT #4,FILL$(" ",20);"PRINTING DOCUMENTS"
11950     OPEN #7,'scr' : WINDOW #7,426,200,44,55 : BORDER #7,3,2
11960     PAPER #7,2 : INK #7,7
11970     PRINT #7,"Doc                     Date             Type" : CLS #7,4
11980     PRINT #7,"Comment                 Analysis Head    VAT Code   Debit     Credit " : CLS #7,4
11990     PAPER #7,7 : INK #7,0 : WINDOW #7,426,179,44,77 : BORDER #7,3,2
12000     CLS #7
12010     END IF
12020   Print_Review (p$(3))
12030   IF exception
12040     exception=0
12050     IF prtr_op
12060       PRINT #7,\\"********************** PRINTING ABORTED *****************"
12070       PRINT #7,form$ : CLOSE #7
12080       END IF
12090     END IF
12100   IF prtr_op:CLOSE #7
12110   END DEFine
12120 :
12130 DEFine PROCedure Print_Review(doc_ct%)
12140 LOCal ii, jj, kk, txt$(50)
12150 LOCal srt_doc%(doc_ct%)
12160   Show_Message "     Press <ESC> to abort"
12170   page% = 0
12180   IF prtr_op : Print_Header rep_review, 0, 0
12190   IF xsort
12200     Identify_File 7 : OPEN_IN #5, file$
12210     FOR ii=1 TO doc_ct% : INPUT #5,srt_doc%(ii)
12220     CLOSE #5
12230   END IF
12240   Position_at_Document 1 : jj = 0 : exception = 0
12250   plin_ct%=0
12260   REPeat scn_lp
12270     jj = jj + 1 : IF jj > doc_ct% : EXIT scn_lp
12280     IF xsort : Position_at_Document srt_doc%(jj)
12290     Get_Document
12300     IF doc_no% < tr : NEXT scn_lp
12310     IF doc_no% > te : IF xsort : NEXT scn_lp : ELSE : EXIT scn_lp
12320     IF prtr_op : Check_Page doc_lin_ct%+2, rep_review, 0, 0
12330     txt$="PaidAdjtRcvdB/CRS/CR"((doc_type%+1)*4+1 TO (doc_type%+1)*4+4)
12340     REMark txt$ = "Paid      AdjustmentReceived  Purchase  Sale      "((doc_type%+1)*10+1 TO (doc_type%+1)*10+10)
12350     cr = (doc_type% = -1 OR doc_type% = 2)
12360     PRINT #7,doc_no%;FILL$(" ",4-LEN(doc_no%));"                   ";doc_date$;"         ";txt$
12370     plin_ct%=plin_ct%+1
12380     kk=Check_Screen
12390     FOR kk=1 TO doc_lin_ct%
12400       PRINT #7,doci_com$(kk);"  ";
12410       IF doci_anl%(kk)<>0
12420         PRINT #7,"  ";anal_desc$(doci_anl%(kk));"  ";vatf_desc$(doci_vcd%(kk));"  ";
12430         IF doc_type% = 0
12440           cr = ( doci_val(kk) >= 0 )
12450           doci_val(kk)=ABS(doci_val(kk))
12460         END IF
12470         IF cr=0 : PRINT #7,"           ";
12480         PRINT #7,Decimal$(doci_val(kk));
12490       END IF
12500       PRINT #7 : plin_ct% = plin_ct%+1
12510       IF NOT Check_Screen:exception=1:EXIT scn_lp
12600     END FOR kk
12610     IF doc_type%=0
12620       cr = (doc_vat >= 0) : doc_vat=ABS(doc_vat)
12630     ELSE
12640       PRINT #7,options$(doc_ref%+1);"  ";doc_reftxt$;"  ";anal_desc$(doc_acct%);"        ";
12650       IF cr=1 : PRINT #7,"           ";
12660       PRINT #7,Decimal$(doc_totvl) : IF prtr_op : lin_ct% = lin_ct% - 1
12670       plin_ct%=plin_ct%+1
12680       IF NOT Check_Screen:exception=1:EXIT scn_lp
12690     END IF
12700     PRINT #7;,,,," V.A.T.";FILL$(" ",8);
12710     IF cr=0 : PRINT #7,"           ";
12720     PRINT #7,Decimal$(doc_vat) : plin_ct%=plin_ct%+1
12725     IF NOT Check_Screen:excepton=1:EXIT scn_lp
12730     PRINT #7,FILL$("-",68+11*(prtr_op=1)) : plin_ct%=plin_ct%+1
12735     IF NOT Check_Screen:excepton=1:EXIT scn_lp
12740     IF prtr_op : lin_ct% = lin_ct% - 2
12750   END REPeat scn_lp
12760   CLOSE #10 : CLOSE #11
12770   IF NOT prtr_op
12780     WINDOW #7,426,179,44,77 : BORDER #7,3,2
12790     AT #7,16,0:CLS #7,2
12800     PRINT #7;TO 20;"Press ENTER to Return to Menu      "
12810     Wait_for_Enter : Show_Menu
12820   ELSE
12830     Print_Footer xsort
12840   END IF
12850 END DEFine
12860 :
12870 DEFine PROCedure Show_Message(txt$)
12880   IF prtr_op
12890     AT 10,0 : PRINT txt$ : ELSE : AT #4,2,15 : PRINT #4,txt$
12900     END IF
12910   END DEFine
12920 :
12930 DEFine FuNction Check_Screen
12940 LOCal f$(1)
12950 IF prtr_op=0 AND plin_ct%>=15
12960   REPeat Next_Page
12970     WINDOW #7,426,179,44,77 : BORDER #7,3,2
12980     AT #7,16,0:PRINT #7;TO 15;'PRESS  FOR LINE OR <ALT> FOR PAGE'
12990     WINDOW #7,426,162,44,77 : BORDER #7,3,2
13000     f$=INKEY$(#14,-1)
13010     IF f$=CHR$(216) OR f$=' ':SCROLL #7,-10:AT #7,14,0:RETurn 1
13020     IF f$=CHR$(217) OR f$=CHR$(10):CLS #7:plin_ct%=0:RETurn 1
13025     IF f$=CHR$(27):RETurn 0
13030   END REPeat Next_Page
13040 END IF
13045 RETurn 1
13050 END DEFine
13060 :
13070 DEFine PROCedure Print_Trial_Bal
13080 LOCal cumcrd, cumdeb, x%, ii, jj, kk, st%, nd%
13090   Set_up_Report rep_trialb
13100   Calc_Total_Stats : cumcrd = 0 : cumdeb = 0
13110   FOR jj=1 TO grup_lim_max%
13120     IF grup_popl%(jj) = 0 : NEXT jj : EXIT jj
13130     Check_Page 2, rep_trialb, cumdeb, cumcrd
13140     PRINT #7,\grup_desc$(jj)
13150     st% = Analysis_Base%((jj))-1 : nd% = st%+grup_popl%(jj)
13160     FOR ii = 1+st% TO nd%
13170       IF suppress_zero : IF anal_blnc(ii) = 0 : NEXT ii : EXIT ii
13180       Check_Page 1, rep_trialb, cumdeb, cumcrd
13190       PRINT #7,FILL$(" ",17);anal_desc$(ii);"  ";
13200       IF anal_vtcd%(ii) <> 4
13210         PRINT #7;"(";vatf_desc$(anal_vtcd%(ii));")   ";
13220         ELSE : PRINT #7;"         "; : END IF
13230       kk = 1
13240       IF grup_rept%(jj) = 1 OR grup_rept%(jj) = 5 :  kk = -1
13250       IF kk * anal_blnc(ii) < 0
13260         PRINT #7,FILL$(" ",14);
13270         cumcrd = cumcrd + ABS(anal_blnc(ii))
13280         ELSE
13290         cumdeb = cumdeb + ABS(anal_blnc(ii)) : END IF
13300       PRINT #7,Decimal$(ABS(anal_blnc(ii)))
13310       END FOR ii
13320     END FOR jj
13330   PRINT #7,\FILL$(" ",17);"V.A.T.";FILL$(" ",20);Decimal$(grp_inpvat);"    ";Decimal$(grp_outvat)
13340   PRINT #7,FILL$("-",79)
13350   PRINT #7,FILL$(" ",43);Decimal$(cumdeb+grp_inpvat);"    ";Decimal$(cumcrd+grp_outvat)
13360   Print_Footer 2 : CLOSE #7
13370   END DEFine
13380 :
13390 DEFine PROCedure Print_Profit_Loss
13400 LOCal ii, jj, kk, w, base%
13410   Set_up_Report rep_pandl
13420   FOR ii = 1 TO 3 : c(ii) = 0
13430   FOR ii = 1 TO grup_lim_max% : grup_total(ii) = 0
13440   FOR ii = 1 TO 3
13450     Check_Page 1, rep_pandl, 0, 0
13460     jj = (ii-1)*13
13470     PRINT #7,"SALES        COST OF SALESOVERHEADS    "(jj+1 TO jj+13)
13480     FOR jj=1 TO grup_lim_max%
13490       IF grup_rept%(jj)=ii
13500         base% = Analysis_Base%((jj))-1
13510         FOR kk=1 TO grup_popl%(jj)
13520           qq = base% + kk
13530           IF suppress_zero : IF anal_blnc(qq) = 0 : NEXT kk : EXIT kk
13540           Check_Page 1, rep_pandl, 0, 0
13550           PRINT #7,"         ";anal_desc$(qq);"      ";
13560           IF ii=1 : PRINT #7,FILL$(" ",36);
13570           w = anal_blnc(qq)
13580           grup_total(jj) = grup_total(jj)+w : PRINT #7,Decimal$(w)
13590           END FOR kk
13600         Check_Page 1, rep_pandl, 0, 0
13610         IF ii=1 : PRINT #7,FILL$(" ",36);
13620         PRINT #7,FILL$(" ",27);"-------------"
13630         Check_Page 2, rep_pandl, 0, 0
13640         PRINT #7,"     Group:-";grup_desc$(jj);FILL$(" ",18);
13650         IF ii<3 : PRINT #7,FILL$(" ",21);
13660         w = grup_total(jj) : c(ii)=c(ii)+w : PRINT #7,Decimal$(w)
13670         PRINT #7
13680         END IF
13690       END FOR jj
13700     SELect ON ii
13710       = 2 : Print_Divider
13720             w=c(1)-c(2) : PRINT #7,"GROSS ";
13730             IF w < 0
13740               PRINT #7,"Loss   "; : ELSE : PRINT #7,"Profit "; : END IF
13750             PRINT #7,FILL$(".",19);"  ";Decimal$(ABS(w))\\\
13760             Check_Page 3, rep_pandl, 0, 0
13770       = 3 : Check_Page 1, rep_pandl, 0, 0
13780             PRINT #7,FILL$(" ",65);Decimal$(c(ii))
13790             Print_Divider
13800             Check_Page 1, rep_pandl, 0, 0
13810             w=c(1)-c(2)-c(3) : PRINT #7," NET ";
13820             IF w<0
13830               PRINT #7,"Loss    "; : ELSE : PRINT #7,"Profit  "; : END IF
13840             PRINT #7,FILL$(".",18);"  ";Decimal$(ABS(w))
13850       END SELect
13860     END FOR ii
13870   Print_Footer 2 : CLOSE #7
13880   END DEFine
13890 :
13900 DEFine PROCedure Print_Divider
13910   Check_Page 2, rep_pandl, 0, 0
13920   PRINT #7,FILL$(" ",61);"---------------"\\FILL$(" ",32);
13930   END DEFine
13940 :
13950 DEFine PROCedure Print_Bal_Sheet
13960 LOCal w, ii, jj, kk, np, qq, q$(20)
13970   Set_up_Report rep_balsht : Calc_Total_Stats
13980   FOR ii = 4, 6, 7, 5
13990     IF ii<>7
14000       Check_Page 2, rep_balsht, 0, 0
14010       SELect ON ii
14020         = 4 : PRINT #7,"FIXED ASSETS"
14030         = 6 : PRINT #7,"CURRENT.................  ASSETS / LIABILITIES"
14040         = 5 : PRINT #7,"CAPITAL EMPLOYED"
14050         END SELect
14060       PRINT #7 : END IF
14070 :
14080     REMark *** Reporting Categories  4 = Fixed Assets
14090     REMark                           6 = Current Assets
14100     REMark                           7 = Current Liabilities
14110     REMark                           5 = Capital
14120 :
14130     FOR jj = 1 TO grup_lim_max%
14140       IF grup_rept%(jj)=ii
14150         FOR kk = 1 TO grup_popl%(jj)
14160           qq = Analysis_Base%((jj)) - 1 + kk
14170           IF suppress_zero : IF anal_blnc(qq) = 0 : NEXT kk : EXIT kk
14180           Check_Page 1, rep_balsht, 0, 0
14190           PRINT #7,"     ";anal_desc$(qq);" ";
14200           IF ii=6
14210             IF anal_blnc(qq)<0 : PRINT #7,FILL$(" ",14);
14220             PRINT #7,Decimal$(ABS(anal_blnc(qq)))
14240           ELSE
14250             IF NOT(ii=7 AND anal_blnc(qq)>0):PRINT #7;FILL$(" ",14);
14260             IF ii=4 : PRINT #7,FILL$(" ",22);
14270             PRINT #7,Decimal$(ABS(anal_blnc(qq)))
14280           END IF
14290         END FOR kk
14300       END IF
14310     END FOR jj
14320     IF ii=7
14330       Check_Page 4, rep_balsht, 0, 0
14340       IF balvat_cat%=7 : q$="VAT Payable    " : ELSE : q$="VAT Repayable  "
14350       PRINT #7,\"     ";q$;" ";
14360       IF balvat_cat%=7 : PRINT #7,"              ";
14365       IF suppress_zero
14370         IF balvat<>0 : PRINT #7,Decimal$(ABS(balvat));
14375       ELSE
14376         PRINT #7,Decimal$(ABS(balvat));
14377       END IF
14380       PRINT #7,\FILL$(" ",21);FILL$("-",25)
14390       PRINT #7,"     TOTAL.......... ";Decimal$(ABS(rg(6)));"    ";Decimal$(ABS(rg(7)))
14400       Check_Page 6, rep_balsht, 0, 0
14410       PRINT #7,\\"NET CURRENT "; : w=rg(6)+rg(7)
14420       kk = (w<0)*17
14430       PRINT #7,"ASSETS...........LIABILTIES......."(kk+1 TO kk+17);FILL$(" ",39);Decimal$(w)
14440       PRINT #7,FILL$(" ",68);"-----------"
14450       PRINT #7,FILL$(" ",68);Decimal$(rg(4)+w)
14460       PRINT #7,FILL$(" ",68);"-----------" : PRINT #7 : PRINT #7
14470       ELSE
14480       IF ii<>6
14490         Check_Page 4, rep_balsht, 0, 0
14500         PRINT #7,FILL$(" ",34);
14510         IF ii=4 : PRINT #7,FILL$(" ",22);
14520         PRINT #7,FILL$("-",23)
14530         PRINT #7,FILL$(" ",46);
14540         IF ii=4 : PRINT #7,FILL$(" ",22);
14550         w=ABS(rg(ii)) : PRINT #7,Decimal$(w) : PRINT #7 : PRINT #7
14560         END IF
14570       END IF
14580     END FOR ii
14590   Check_Page 4, rep_balsht, 0, 0
14600   np = rg(1)-rg(2)-rg(3) : w = rg(4)+rg(6)+rg(7)
14610   IF np < 0 : q$="NET LOSS  " : ELSE : q$="NET PROFIT"
14620   PRINT #7,\q$&"     From Profit & Loss Account     ";Decimal$(np)
14630   PRINT #7,FILL$(" ",46);FILL$("-",33)
14640   PRINT #7,\FILL$(" ",46);Decimal$(rg(5)+np);FILL$(" ",12);Decimal$(w)
14650   PRINT #7,FILL$(" ",46);FILL$("-",33)
14660   Print_Footer 2 : CLOSE #7
14670   END DEFine
14680 :
14690 DEFine PROCedure Print_Recon
14700 LOCal ii, jj, kk, srt$(doc_ct%+doc_ct%+tran_ct%,17)
14710 LOCal doc_item$(6), doc_commt$(24), wka$(12), wk$(61), txt$(10)
14720   Set_up_Report rep_recon
14730   DELETE drive3$ & 'recon_wk'
14740   OPEN_NEW #5,drive3$ & 'recon_wk'
14750   Position_at_Document 1 : kk = 0 : ii = 0
14760   wk$ = FILL$(' ',61)
14770   AT 9,4 : PRINT 'Work rec: '
14780   REPeat lp
14790     kk = kk + 1 : IF kk > doc_ct% : EXIT lp
14800     Get_Document
14810     wka$ = 10000 + doc_acct%
14820     wk$(1 TO 4)   = wka$(2 TO 5)
14830     wka$ = (100 + Month_No%(doc_date$(4 TO 6)))
14840     txt$ = 100 + doc_date$(1 TO 2)
14850     IF doc_date$(8 TO 9)<50
14860       wk$(5 TO 12)  = "20" & doc_date$(8 TO 9) & wka$(2 TO 3) & txt$ (2 TO 3)
14870     ELSE
14880       wk$(5 TO 12)  = "19" & doc_date$(8 TO 9) & wka$(2 TO 3) & txt$ (2 TO 3)
14890     END IF
14900     wk$(13 TO 14) = doc_type%
14910     wk$(15 TO 18) = doc_no%
14920     wk$(19 TO 22) = "    "
14930     wk$(23)       = doc_ref%
14940     wk$(24 TO 31) = doc_reftxt$
14950     wk$(32 TO 51) = "                    "
14960     wk$(52 TO 61) = Decimal$(doc_totvl)
14970     IF doc_type% <> 0
14980       PRINT #5;wk$ : ii = ii + 1 : srt$(ii) = wk$(1 TO 12) & ' ' & ii
14990       END IF
15000     IF doc_vat <> 0
15010       wk$(1 TO 4)   = "0001"
15020       wk$(52 TO 61) = Decimal$(doc_vat)
15030       PRINT #5;wk$ : ii = ii + 1 : srt$(ii) = wk$(1 TO 12) & ' ' & ii
15040       END IF
15050     AT 9,14 : PRINT ii
15060     FOR jj = 1 TO doc_lin_ct%
15070       IF doci_anl%(jj) <> 0
15080         wka$ = 10000 + doci_anl%(jj)
15090         wk$(1 TO 4)   = wka$(2 TO 5)
15100         wk$(19 TO 22) = jj
15110         wk$(32 TO 51) = doci_com$(jj)
15120         wk$(52 TO 61) = Decimal$(doci_val(jj))
15130         PRINT #5;wk$ : ii = ii + 1 : srt$(ii) = wk$(1 TO 12) & ' ' & ii
15140         END IF
15150       END FOR jj
15160     END REPeat lp
15170   wk_max = ii
15180   CLOSE #10 : CLOSE #11
15190   CLOSE #5
15200   Sort_Selected_Docs wk_max, srt$
15210   CLS : AT 4,1 : PRINT "PRINTING RECONCILIATION REPORT"
15220   AT 6,4 : PRINT "Approx. ";1+INT(wk_max/50);" pages"
15230   AT 8,6 : PRINT "Page: ";page%
15240   OPEN #5,drive3$ & "recon_wk"
15250   currt_grp% = 0 : currt_anl% = 0
15260   ii = 0 : rec_lenf% = 61
15270   REPeat lp
15280     ii = ii + 1 : IF ii > wk_max : EXIT lp
15290     begin = srt$(ii,13 TO)
15300     BGET #5\(begin-1)*(rec_lenf%+1) : INPUT #5,wk$
15310     doc_acct%   = wk$(1 TO 4)
15320     doc_date$   = wk$(5 TO 12)
15330     doc_type%   = wk$(13 TO 14)
15340     doc_no%     = wk$(15 TO 18)
15350     doc_item$   = wk$(19 TO 22)
15360     doc_ref%    = wk$(23)
15370     doc_reftxt$ = wk$(24 TO 31)
15380     doc_commt$  = wk$(32 TO 51)
15390     doc_totvl   = wk$(52 TO 61)
15400     jj = doc_date$(5 TO 6)
15410     doc_date$   = doc_date$(7 TO 8) & " " & m$(jj) & " " & doc_date$(3 TO 4)
15420     IF doc_acct% <> currt_anl%
15430       IF currt_anl% <> 0 : PRINT #7 : lin_ct% = lin_ct% - 1
15440       currt_anl% = doc_acct% : curr_bal = 0
15450       jj = Analysis_Group%(doc_acct%)
15460       rept_cat% = grup_rept%(jj)
15470       IF jj <> currt_grp%
15480         currt_grp% = jj
15490         IF lin_ct% < 3 : Print_Header rep_recon, 0, 0
15500         PRINT #7;"Group: ";grup_desc$(currt_grp%);'    ';FILL$('*',60)\\
15510         lin_ct% = lin_ct% - 2
15520         END IF
15530       END IF
15540     Check_Page 1, rep_recon, currt_grp%, 0
15550     AT 8,12 : PRINT page%
15560     txt$="PaidAdjtRcvdB/CRS/CR"((doc_type%+1)*4+1 TO (doc_type%+1)*4+4)
15570     PRINT #7;anal_desc$(doc_acct%);"  ";doc_date$;" ";txt$;" ";doc_no%;
15580     PRINT #7;TO 37;doc_item$;" ";options$(doc_ref%+1);" ";doc_reftxt$;" ";doc_commt$;
15590     IF doc_type% = 0
15600       cr = 1
15610       ELSE
15620       typdeb = (doc_type% = -1 OR doc_type% = 2)
15630       IF doc_item$ = "    "
15640         IF doc_acct% = 1 : cr = typdeb : ELSE : cr = 1 - typdeb
15650         ELSE
15660         IF currt_grp% > 3
15670           IF rept_cat% = 1 : cr = 1 - typdeb : ELSE : cr = typdeb
15680           ELSE
15690           cr = typdeb : END IF
15700       END IF : END IF
15710     IF doc_totvl <> ABS(doc_totvl)
15720       cr = 1 - cr : doc_totvl = ABS(doc_totvl) : END IF
15730     IF cr
15740       PRINT #7,"           ";Decimal$(doc_totvl);
15750       curr_bal = curr_bal + doc_totvl
15760       ELSE
15770       PRINT #7,Decimal$(doc_totvl);"           ";
15780       curr_bal = curr_bal - doc_totvl
15790       END IF
15800     PRINT #7;Decimal$(curr_bal)
15810     END REPeat lp
15820   CLOSE #5
15830   DELETE drive3$ & 'recon_wk'
15840   PRINT #7;pr_normal$;
15850   Print_Footer 2 : CLOSE #7
15860   END DEFine
15870 :
15880 DEFine PROCedure Set_up_Report (repno)
15890 LOCal wk$(30)
15900   Set_PapInk : CLS
15910   IF repno <> rep_review AND repno <> rep_recon
15920     AT 2,0 : PRINT "Suppress ZERO items Y or N"
15930     Wait_for_YN
15940     suppress_zero = (f$ == 'y')
15950     END IF
15960   AT 4,10 : PRINT "PLEASE WAIT"
15970   AT 6, 1 + (21-LEN(Report_Name$(repno)))/2
15980   PRINT "PRINTING ";Report_Name$(repno)
15990   AT 8,1 : PRINT "Print device: "
16000   wk$ = Kbd_String$(15,8,24,2,prtr$)
16010   AT 7,0 : CLS 2
16020   page% = 0 : OPEN_OVER #7,wk$
16030   IF repno = rep_recon : PRINT #7;pr_condens$;
16040   Print_Header repno, 0, 0
16050   END DEFine
16060 :
16070 DEFine FuNction Report_Name$(repno)
16080   SELect ON repno
16090     =rep_vat    : RETurn "VAT REPORT"
16100     =rep_review : RETurn "DOCUMENT REPORT"
16110     =rep_pandl  : RETurn "PROFIT & LOSS ACCOUNT"
16120     =rep_balsht : RETurn "BALANCE SHEET"
16130     =rep_trialb : RETurn "TRIAL BALANCE"
16140     =rep_recon  : RETurn "RECONCILIATION REPORT"
16150     END SELect
16160   END DEFine
16170 :
16180 DEFine PROCedure Check_Page(add%, repno, cumdeb, cumcrd)
16190   lin_ct% = lin_ct% - add%
16200   IF lin_ct% < 0
16210     Print_Header repno, cumdeb, cumcrd : lin_ct% = lin_ct%-add%
16220     END IF
16230   END DEFine
16240 :
16250 DEFine PROCedure Print_Header(repno, cumdeb, cumcrd)
16260 LOCal ii, yr, dy, hr
16270 LOCal z$(20), dayth$(4), part$(6), rep_type$(40)
16280   IF page% <> 0
16290     SELect ON repno
16300       = rep_trialb
16310             PRINT #7,FILL$("-",79)
16320             PRINT #7,"Carried Forward  ";FILL$(" ",26);Decimal$(cumdeb);"    ";Decimal$(cumcrd)
16330       END SELect
16340     PRINT #7; form$;
16350     END IF
16360   rep_type$ = "EXTRACTED " & Report_Name$(repno)
16370   ii=INT((75-LEN(rep_type$)-LEN(fullname$))/2)
16380   PRINT #7,FILL$(" ",ii);rep_type$;" for ";fullname$
16390   PRINT #7,\"Printed on ";
16400   z$ = DATE$ : yr=z$(1 TO 4) : hr=z$(13 TO 14)
16410   part$="a.m." : IF hr>12 : hr=hr-12 : part$="p.m."
16420   IF hr=12:part$="p.m."
16430   ii = z$(11)
16440   dy = z$(10 TO 11)
16450   SELect ON ii
16460     =1 : dayth$="st." : IF dy=11 : dayth$="th."
16470     =2 : dayth$="nd." : IF dy=12 : dayth$="th."
16480     =3 : dayth$="rd." : IF dy=13 : dayth$="th."
16490     =REMAINDER : dayth$="th."
16500     END SELect
16510   PRINT #7,dy;dayth$;" ";z$(6 TO 8);" ";yr;FILL$(" ",33);"Time ";hr;":";z$(16 TO 17);" ";part$;
16520   page% = page% + 1
16530   SELect ON repno
16540     =rep_review : PRINT #7,\FILL$(" ",69);"Page ";page%
16550                   PRINT #7,FILL$("-",79)
16560                   PRINT #7,"Doc                     Date             Type"
16570                   PRINT #7,"Comment                 Analysis Head    VAT Code   Debit     Credit "
16580                   PRINT #7,FILL$("-",79)
16590                   lin_ct% = printlines%-13
16600     =rep_trialb : PRINT #7,\FILL$(" ",69);"Page ";page%
16610                   PRINT #7,FILL$("-",79)
16620                   PRINT #7,"Group            Analysis         (VAT)       Debit         Credit"
16630                   PRINT #7,"Brought Forward  ";FILL$(" ",26);Decimal$(cumdeb);"    ";Decimal$(cumcrd)
16640                   PRINT #7,FILL$("-",79)
16650                   lin_ct% = printlines%-15
16660     =rep_recon  : PRINT #7;FILL$(' ',25);"Page: ";page%
16670                   PRINT #7;\"Account          Date      Type Doc  Item Payment Mthd Ref      Comment              Debit      Credit     Balance"
16680                   PRINT #7;FILL$('-',116)
16690                   IF cumdeb
16700                     PRINT #7;"Group: ";grup_desc$(cumdeb);" - Continued"\\
16710                     END IF
16720                   lin_ct% = printlines%-13
16730     =REMAINDER  : PRINT #7;\\
16740                   PRINT #7,FILL$("-",79)
16750                   lin_ct% = printlines%-10
16760     END SELect
16770   END DEFine
16780 :
16790 DEFine PROCedure Print_Footer(docsort)
16800 LOCal ii, kk, z$(14), q$(50), qp$(100)
16810   PRINT #7;form$;
16820   z$=FILL$(" ",12)
16830   PRINT #7,\\" The above Report was produced from the EXTRACTED information on the ";cart$;\"   called ";p$(1)
16840   q$ = p$(16) & ' ' & FILL$('.',30)
16850   PRINT #7,\\z$;"Number of Documents on ";q$(1 TO 27);" ";
16860   q$="     "&p$(2) : PRINT #7,q$(LEN(q$)-4 TO)
16870   PRINT #7,z$;"Number of Documents on EXTRACTED ";cart$;" ............ ";
16880   q$="     "&p$(3) : PRINT #7,q$(LEN(q$)-4 TO)
16890   PRINT #7,z$;"Starting from Document number .................... ";
16900   q$="     "&p$(5) : PRINT #7,q$(LEN(q$)-4 TO)
16910   PRINT #7,z$;"Finishing at Document number ..................... ";
16920   q$="     "&p$(6) : PRINT #7,q$(LEN(q$)-4 TO)
16930   PRINT #7,z$;"Starting from Date .......................... ";
16940   IF p$(14) = "NO" : PRINT #7,"      Any" : ELSE : PRINT #7,p$(14)
16950   PRINT #7,z$;"Finishing at Date ........................... ";
16960   IF p$(15) = "NO" : PRINT #7,"      Any" : ELSE : PRINT #7,p$(15)
16970   PRINT #7,\\
16980   IF docsort < 2
16990     PRINT #7," Printed from Document number ";tr;" to ";te;" in ";
17000     SELect ON docsort
17010       =1 : IF p$(4) = 'YES'
17020              PRINT #7,"DATE order "
17030              ELSE
17040              PRINT #7,"DATE within ANALYSIS order "
17050              END IF
17060       =0 : PRINT #7,"DOCUMENT order "
17070       END SELect
17080     PRINT #7,\\
17090     END IF
17100   qp$="Type .....Group ....Analysis .Reference Bank Type Comment ..VAT ......"
17110   FOR ii=7 TO 11,13,12
17120     q$=p$(ii) : kk = 1 + (ii-7)*10
17130     IF q$="0" OR q$=""
17140       q$="Any"
17150       ELSE
17160       SELect ON ii
17170         = 10, 12    :
17180         = 8         : q$ = grup_desc$(q$)
17190         = 9         : q$ = anal_desc$(q$)
17200         = REMAINDER : q$ = options$(q$)
17210         END SELect : END IF
17220     PRINT #7,z$;qp$(kk TO kk + 9);"...... ";q$
17230     END FOR ii
17240   PRINT #7,form$
17250   END DEFine
17260 :
17270 DEFine PROCedure Calc_Total_Stats
17280 LOCal x%, x1%, kk, ii, jj
17290   grp_inpgrs = 0 : grp_outvat = 0 : grp_inpvat = 0 : grp_outgrs = 0
17300   FOR ii = 0 TO 3
17310     grp_outgrs = grp_outgrs+vatf_gros(ii)
17320     grp_outvat = grp_outvat+vatf_vat(ii)
17330     grp_inpgrs = grp_inpgrs+vatf_gros(ii+5)
17340     grp_inpvat = grp_inpvat+vatf_vat(ii+5)
17350   END FOR ii
17360 REMark  ntp = grp_outvat - grp_inpvat
17370   FOR ii = 1 TO 7 : rg(ii) = 0
17380   FOR ii = 1 TO grup_lim_max%
17390     IF grup_popl%(ii)<>0
17400       x% = Analysis_Base%((ii))-1 : x1% = x%+grup_popl%(ii)
17410       FOR jj = 1+x% TO x1%
17420         kk = grup_rept%(ii)
17430         REMark Check for where current liabilites owe you money
17440         IF kk = 6 AND anal_blnc(jj)<0 : kk = 7
17450         REMark Check for where you owe current assets money
17460         IF kk = 7 AND anal_blnc(jj)>0 : kk = 6
17470         rg(kk) = rg(kk)+anal_blnc(jj)
17480       END FOR jj
17490     END IF
17500   END FOR ii
17510   balvat = grp_inpvat-grp_outvat
17520   kk = 6 + (balvat < 0)
17530   rg(kk) = rg(kk) + balvat : balvat_cat% = kk
17540 END DEFine
17550 :
17560 DEFine PROCedure Get_Key
17570   exception = 0
17580   f$=INKEY$(#14,-1) : key = CODE(f$)
17590   IF key = ESC% : key = ENTER% : f$=CHR$(ENTER%) : exception = 1
17600   END DEFine
17610 :
17620 DEFine PROCedure Wait_for_Enter
17630   REPeat loop : Get_Key : IF key = ENTER% : EXIT loop
17640   END DEFine
17650 :
17660 DEFine PROCedure Wait_for_YN
17670   REPeat loop : Get_Key : IF exception OR f$=='y' OR f$=='n' : RETurn
17680   END DEFine
17690 :
17700 REFERENCE array$(0,0)
17710 DEFine PROCedure Adj_Selection(array$)
17720 LOCal ii, jj
17730   SELect ON key
17740     = lf_arrow%, up_arrow% : rng_sel=rng_sel-1
17750                              IF rng_sel<rng_min : rng_sel=rng_max
17760                              RETurn
17770     = rt_arrow%, dn_arrow% : rng_sel=rng_sel+1
17780                              IF rng_sel>rng_max : rng_sel=rng_min
17790                              RETurn
17800     END SELect
17810   FOR ii = rng_sel+1 TO rng_max
17820     IF Found_Option_Match : rng_sel = ii : RETurn
17830     END FOR ii
17840   FOR ii = rng_min TO rng_sel-1
17850     IF Found_Option_Match : rng_sel = ii : RETurn
17860     END FOR ii
17870   END DEFine
17880 :
17890 DEFine FuNction Found_Option_Match
17900   jj = 0
17910   REPeat fom_lp
17920     jj=jj+1 : IF jj > LEN(array$(ii)) : RETurn 0
17930     IF array$(ii,jj)<>" " : EXIT fom_lp
17940     END REPeat fom_lp
17950   RETurn CHR$(key) == array$(ii,jj)
17960   END DEFine
17970 :
17980 DEFine PROCedure Get_Menu_Choice(col%, paph%, inkh%, rng_min, rng_max, st%)
17990   INK inkh% : PAPER paph% : CLS
18000   FOR ors=rng_min TO rng_max : Highlight col%
18010   IF rng_min <> 1
18020     CLS #9 : PRINT #9,TO 13;"PRINT FROM"\TO 12;"EXTRACT ";cart$
18030     END IF
18040   OPEN #10,'scr'
18050   WINDOW #10,312,15,106,239 : PAPER #10,4 : INK #10,0
18060   PRINT #10,"  Use  &  to move indicator:Hit ENTER to accept."
18070   rng_sel = st% : Select_Menu_Option col%,paph%,inkh%
18080   CLS #10
18090   END DEFine
18100 :
18110 DEFine PROCedure Select_Menu_Option(col%,paph%,inkh%)
18120 LOCal ors
18130   REPeat smo_lp
18140     ors = rng_sel
18150     PAPER 4 : INK 0 : Highlight col%
18160     IF rng_min=1 : CLS #9 : PRINT #9,ms$(rng_sel)
18170     Get_Key
18180     IF key=ENTER% AND NOT exception : EXIT smo_lp
18190     Adj_Selection op$
18200     PAPER paph% : INK inkh% : Highlight col%
18210     END REPeat smo_lp
18220   END DEFine
18230 :
18240 DEFine PROCedure Highlight (col%)
18250   AT ((ors-rng_min)*2),col% : PRINT op$(ors)
18260   END DEFine
18270 :
18280 DEFine FuNction Selected_Date$(dt$)
18290 LOCal dat$(20), ii, jj, kk
18300   dat$=dt$
18310   REPeat date_loop
18320     kk=dat$(1 TO 4) : ii=dat$(10 TO 11)
18330     jj = Month_No%(dat$(6 TO 8))
18340     AT 3,5 : PAPER 7 : INK 0
18350     PRINT " ";dat$;" "
18360     PAPER 7 : INK 0 : AT 5,1 : PRINT "Is this Correct Y or N ?     "
18370     Wait_for_YN : IF f$=="y" : EXIT date_loop
18380     AT 5,1 : PRINT FILL$(" ",29) : Set_Time
18390     wk$="00"&ii : wk$=wk$(LEN(wk$)-1 TO LEN(wk$))
18400     dat$=kk&" "&m$(jj)&" "&wk$
18410     END REPeat date_loop
18420   PAPER 7 : AT 5,1 : PRINT FILL$(" ",28)
18430   RETurn dat$
18440   END DEFine
18450 :
18460 DEFine PROCedure Set_Time
18470 LOCal control
18480   Help 10
18490   control=1
18500   REPeat conloop
18510     SELect ON control
18520       =1 : rng_min=1980 : rng_max=2500 : rng_sel=kk
18530            Adj_Date 6 : kk=rng_sel : control=2 : IF exception : control=1
18540       =2 : rng_min=1 : rng_max=12 : rng_sel=jj
18550            Adj_Date 11 : control=3 : jj=rng_sel : IF exception : control=1
18560       =3 : rng_min=1 : rng_max=m%(jj) : rng_sel=ii
18570            IF (kk MOD 4)=0 AND jj=2 : rng_max=29
18580            IF rng_sel>rng_max : rng_sel=rng_max
18590            Adj_Date 15 : ii=rng_sel : control=7
18600            IF exception : control=2
18610       END SELect
18620     IF control=7 : EXIT conloop
18630     END REPeat conloop
18640   CLS #9
18650   END DEFine
18660 :
18670 DEFine PROCedure Adj_Date(ht)
18680   PAPER 7 : INK 0 : AT 5,6 : PRINT FILL$(" ",20)
18690   AT 5,6 : exception=0
18700   SELect ON ht
18710     =6 : PRINT "Year"
18720     =11 : PRINT"     Month"
18730     =15 : PRINT "         Day"
18740     END SELect
18750   REPeat lop
18760     Set_PapInk : AT 3,ht : Show_Date_Selection
18770     AT 3,ht
18780     REPeat so_lp
18790       Get_Key
18800       SELect ON key
18810         = ENTER% : EXIT lop
18820         = lf_arrow%, rt_arrow%, up_arrow%, dn_arrow% : EXIT so_lp
18830         END SELect
18840       END REPeat so_lp
18850     Adj_Selection m$
18860     END REPeat lop
18870   PAPER 7 : INK 0 : AT 3,ht : Show_Date_Selection
18880   END DEFine
18890 :
18900 DEFine PROCedure Show_Date_Selection
18910   SELect ON ht
18920     =6 : PRINT rng_sel
18930     =11 : PRINT m$(rng_sel)
18940     =REMAINDER : PRINT FILL$("0",2-LEN(rng_sel));rng_sel
18950     END SELect
18960   END DEFine
18970 :
18980 REFERENCE array$(0,0)
18990 DEFine FuNction Chosen_Field_Option%(ht, vt, array$)
19000 LOCal jj,k$(40)
19010   IF NOT Within(rng_sel,rng_min,rng_max) : rng_sel = rng_min
19020   rng_min = rng_min -1
19030   jj=33-ht : k$ = array$(rng_min) : array$(rng_min)=FILL$(" ",jj)&"NO"
19040   REPeat cfo_lp
19050     Reset_PapInk : Show_Currt_Selection
19060     Get_Key
19070     Set_PapInk
19080     IF key=ENTER% : EXIT cfo_lp
19090     Adj_Selection array$
19100     END REPeat cfo_lp
19110   Show_Currt_Selection
19120   array$(rng_min)=k$
19130   IF rng_sel = rng_min OR exception : rng_sel = 0
19140   rng_min = rng_min + 1
19150   RETurn rng_sel
19160   END DEFine
19170 :
19180 DEFine PROCedure Show_Currt_Selection
19190   AT vt,ht : PRINT array$(rng_sel)
19200   END DEFine
19210 :
19220 DEFine PROCedure Reset_Window_9
19230   WINDOW #9,300,40,136,210 : PAPER #9,4 : INK #9,0 : CLS #9
19240   END DEFine
19250 :
19260 DEFine PROCedure Help(kk)
19270   Reset_Window_9
19280   IF kk=1
19290     PRINT #9,"  Use  &  to move indicator:Hit ENTER to accept."
19300     ELSE
19310     IF kk = 10
19320       PRINT #9,"Use  &  to rollover the year, month & day"
19330       PRINT #9,"         Hit ENTER to accept."
19340       ELSE
19350       PRINT #9,"  Type in ";
19360       SELect ON kk
19370         =2 : PRINT #9,"Name of Extraction File."
19380         =3 : PRINT #9,"Reference."
19390         =4 : PRINT #9,"Comment."
19400         =5 : PRINT #9,"Document Number."
19410         END SELect
19420       PRINT #9,"  Use CTRL/ or F2 Key to correct."
19430       END IF : END IF
19440   PRINT #9,"  Press 'ESC' to go back";
19450   IF kk=2
19460     PRINT #9," to Menu." : ELSE : PRINT #9," to previous field."
19470     END IF
19480   END DEFine
19490 :
19500 DEFine FuNction Kbd_String$(hhh, vvv, field_len%, typ%, stval$)
19510 LOCal ht, vt, dec_pt_recd, maxf_len%, ii, q$(50)
19520   ht=hhh : vt=vvv
19530   money = (typ%=1) : text_fld = (typ%=2) : num_text = (typ%=3)
19540   maxf_len%=field_len% : IF money : maxf_len% = money_fieldsize%
19550   dec_pt_recd=0 : q$=""
19560   Reset_PapInk : AT vt,ht
19570   REPeat loop
19580     IF q$=""
19590       AT vvv,hhh
19600       q$ = FILL$(" ",field_len%-LEN(stval$))
19610       IF text_fld
19620         PRINT q$;stval$ : ELSE : PRINT stval$;q$ : END IF
19630       q$ = "" : AT vvv,hhh : END IF
19640     Get_Key
19650     IF key = ENTER%
19660       IF exception : q$ = ''
19670       IF q$="" : q$=stval$
19680       EXIT loop : END IF
19690     IF money AND q$="" AND key=45
19700       q$="-" : PRINT q$; : ht=ht+1
19710       ELSE
19720       Check_Character
19730       END IF
19740     IF stval$ <> "" AND LEN(q$)=1
19750       AT vt,ht : PRINT FILL$(" ",maxf_len%-1)
19760       AT vt,ht
19770       END IF
19780     END REPeat loop
19790   Set_PapInk : AT vvv,hhh
19800   IF text_fld
19810     q$ = Upper$(q$)
19820     ELSE
19830     IF q$="" : q$="0"
19840     END IF
19850   IF money
19860     PRINT Decimal$(q$) : ELSE
19870     PRINT FILL$(" ",field_len%-LEN(q$))&q$ : END IF
19880   RETurn q$
19890   END DEFine
19900 :
19910 DEFine FuNction Upper$(txt$)
19920 LOCal q$(100), jj, ii
19930   IF txt$ = "" : RETurn ""
19940   q$ = txt$
19950   FOR ii=1 TO LEN(q$)
19960     jj = CODE(q$(ii)) : IF jj > 96 : q$(ii)=CHR$(jj-32)
19970     END FOR ii
19980   RETurn q$
19990   END DEFine
20000 :
20010 DEFine PROCedure Check_Character
20020   IF (key = F2_key% OR key = del_lf%)
20030     IF q$ <> "" : Delete_Character
20040     RETurn : END IF
20050   IF money AND NOT dec_pt_recd AND key = 46
20060     dec_pt_recd=1 : PRINT ".__";FILL$(" ",Free_Places%-LEN(q$));
20070     ht = hhh+1+LEN(q$) : AT vt,ht : q$ = q$&f$
20080     ELSE
20090     IF Acceptable_Character : PRINT f$; : q$ = q$ & f$ : ht = ht + 1
20100     IF money AND dec_pt_recd = 0 AND LEN(q$) = Free_Places%
20110       PRINT "."; : q$=q$&"." : dec_pt_recd=1 : ht=ht+1 : END IF
20120     END IF
20130   END DEFine
20140 :
20150 DEFine FuNction Acceptable_Character
20160   IF money
20170     IF dec_pt_recd : IF ("." INSTR q$) = LEN(q$)-2 : RETurn 0
20180     RETurn Within(key,48,57) : END IF
20190   IF text_fld : RETurn Within(key,32,127) AND LEN(q$) < maxf_len%
20200   IF num_text : RETurn Within(key,48,57)  AND LEN(q$) < maxf_len%
20210   RETurn 0
20220   END DEFine
20230 :
20240 DEFine FuNction Free_Places%
20250   IF q$ = '' : RETurn maxf_len%-3
20260   RETurn maxf_len%-3 + (q$(1)='-')
20270   END DEFine
20280 :
20290 DEFine PROCedure Delete_Character
20300   IF money AND CODE(q$(LEN(q$))) = 46
20310     dec_pt_recd=0
20320     IF LEN(q$) = maxf_len%-2 : q$ = Lost_Last$(q$)
20330     END IF
20340   q$ = Lost_Last$(q$)
20350   AT vvv,hhh : PRINT q$&FILL$(" ",maxf_len%-LEN(q$))
20360   ht = hhh+LEN(q$) : AT vt,ht
20370   END DEFine
20380 :
20390 DEFine FuNction Lost_Last$(q$)
20400   IF LEN(q$) < 2 : RETurn ""
20410   RETurn q$(1 TO LEN(q$)-1)
20420   END DEFine
20430 :
20440 DEFine FuNction Within(a%,min%,max%)
20450   RETurn a% >= min% AND a% <= max%
20460   END DEFine
20470 :
20480 DEFine FuNction Pull_Up$(off)
20490 LOCal x$(50),lenf%
20500   x$ = '':lenf%=PEEK_W(addr+off)
20510   FOR ii = 1 TO lenf% : x$ = x$ & CHR$(PEEK(addr+off+1+ii))
20520   ii = ' ' INSTR x$ : IF ii = 0 : RETurn x$
20530   RETurn x$(1 TO ii-1)
20540 END DEFine
20550 :
20560 DEFine FuNction Decimal$(num)
20570 LOCal x$(12), ii, q, p
20580   q = 100 * num
20590   IF ABS(q) >= .5 : q = INT(ABS(q) + .5) : ELSE : q = 0
20600   p = INT(q/100) : ii = q - p * 100
20610   x$ = p
20620   SELect ON ii
20630     = 0         : x$ = x$ & ".00"
20640     = 1 TO 9    : x$ = x$ & ".0" & ii
20650     = REMAINDER : x$ = x$ & "." & ii
20660     END SELect
20670   IF num < 0 : x$ = '-' & x$
20680   x$ = FILL$(" ",money_fieldsize%-LEN(x$)) & x$
20690   RETurn x$
20700 END DEFine
