100 REMark CT_REPORT - Main Reporting module for Cash Trader
110 REMark Updated 24/3/2002 Rich Mellor
120 :
130 REMark         Chas Dillon, Apr 87
140 TURBO_objfil "win2_ct_report_exe"
150 TURBO_taskn  "CTReport 3.9"
160 TURBO_repfil
170 TURBO_diags 'd' : TURBO_struct 's' : TURBO_model '<'
180 TURBO_optim 'b' : TURBO_locstr 'i' : TURBO_windo 0
190 :
200 DATA_AREA 20
210 :
220 IMPLICIT% ii, jj, kk, qq, rng_min, rng_max, rng_sel, st, nd
230 IMPLICIT% yr, dy, hr, repno, ors, key, filno, offset
240 :
250 WHEN ERRor
260   WINDOW 258,70,120,70 : BORDER 1,0 : PAPER 4 : INK 0
270   CLS : PRINT \' An error has occurred ... (';ERNUM%!!ERLIN%;')'
280   PRINT ' Please check correct volumes are loaded'
290   PRINT ' and ';drive2$;' is write enabled'
300   PRINT \'   Press ENTER to retry; ESC to quit'
310   Get_Key : IF exception : STOP
320   RETRY
330   END WHEN
340 :
350 DIM vers$(10) : vers$ = "CTver 3.8"
360 :
370 DIM drive1$(42), drive2$(42), cart$(6), prtr$(10), file$(42)
380 DIM f$(2),n$(70),z$(70)
390 DIM fullname$(42),example$(4),name$(42),last$(20),create$(20),vatno$(20)
400 DIM nextvat$(20), eoy$(20), form$(6), extract$(10), vfq$(6)
410 DIM prin$(6), lastvat$(20), doc_date$(12), doc_reftxt$(12)
420 DIM last_used_doc_date$(12)
430 :
440 money_fieldsize% = 10
450 :
460 IF COMPILED
470   addr=OPTION_CMD$
480   drive1$ = Pull_Up$(0)
490   drive2$ = Pull_Up$(44)
500   cart$   = Pull_Up$(88)
510   prtr$   = Pull_Up$(96)
520   tran_lim_max% = PEEK_W(addr+110)
530   anal_lim_max% = PEEK_W(addr+112)
540   grup_lim_max% = PEEK_W(addr+114)
550   vatf_lim_max% = PEEK_W(addr+116)
560   lines_per_doc_max% = PEEK_W(addr+118)
570 ELSE
580   drive1$ = "win2_CTTE_"
590   drive2$ = "win2_CTTE_"
600   cart$   = "DISK"
610   prtr$   = "ram1_test"
620   tran_lim_max% = 4000
630   anal_lim_max% = 460
640   grup_lim_max% = 20
650   vatf_lim_max% = 9
660   lines_per_doc_max% = 30
670   baudr% = 9600
680 END IF
690 :
700 REMark >>> _______________  Figurative Constants  ___________________
710 :
720 lf_arrow% = 192 : rt_arrow% = 200 : up_arrow% = 208 : dn_arrow% = 216
730 ctrl_lf%  = 194 : ctrl_rt%  = 202 : del_lf%   = 194
740 F1_key%   = 232 : F2_key%   = 236 : ENTER%    = 10  : ESC%      = 27
750 :
760 REMark >>> __________________________________________________________
770 :
780 DIM rept_grp$(6,19),rg(7),op$(15,16),m$(12,9)
790 DIM options$(5,25)
800 DIM grup_desc$(grup_lim_max%,15)
810 DIM grup_rept%(grup_lim_max%), grup_popl%(grup_lim_max%)
820 DIM grup_max_popl%(grup_lim_max%), grup_total(grup_lim_max%)
830 DIM anal_blnc(anal_lim_max%), anal_desc$(anal_lim_max%,15)
840 DIM anal_vtcd%(anal_lim_max%), anal_price%(anal_lim_max%)
850 DIM vatf_pcnt(vatf_lim_max%), vatf_desc$(vatf_lim_max%,4)
860 DIM vatf_gros(vatf_lim_max%), vatf_vat(vatf_lim_max%)
870 DIM vatf_rate$(3,8)
880 DIM doci_val(lines_per_doc_max%),doci_com$(lines_per_doc_max%,20)
890 DIM doci_anl%(lines_per_doc_max%),doci_vcd%(lines_per_doc_max%)
900 :
910 OPEN #14,'con' : IF COMPILED : OPEN #1,'scr'
920 :
930 RETRY_HERE
940 :
950 OPEN_IN #5,drive2$&"ct_register"
960 INPUT #5,fullname$, example$, name$, last$, create$, vatno$
970 CLOSE #5
980 :
990 DATA "Unspec. CASH","CHEQUE......","STNDNG ORDER","DIRECT DEBIT","TRANSFER....","INTEREST....","BANK CHARGES","UNPAID CHQUE","   PAID   ","ADJUSTMENT"," RECEIVED ","BOUGHT  CR"," SOLD  CR ","ACCEPT THIS LINE","DELETE THIS LINE","ENTER MORE LINES"
1000 DATA "SALES..............","COST OF SALES......","OVERHEADS..........","FIXED ASSETS.......","CAPITAL EMPLOYED...","CRNT ASSET/LIABILITY"
1010 DATA "January","February","March","April","May","June","July","August","September","October","November","December"
1020 DATA " VAT Report Print "," Documents Review "," Profit & Loss A/C Print "," Balance Sheet Print "," Trial Balance Print "," Exit to Main Menu"
1030 :
1040 RESTORE
1050 FOR ii=0 TO 15 : READ op$(ii)
1060 FOR ii=1 TO 6  : READ rept_grp$(ii)
1070 FOR ii=1 TO 12 : READ m$(ii)
1080 FOR ii=0 TO 5  : READ options$(ii)
1090 :
1100 Setup_Analysis_Tables
1110 Show_Menu
1120 Produce_Report
1130 :
1140 Set_PapInk : CLS
1150 CLOSE #3 : CLOSE #9 : IF COMPILED : CLOSE #1
1160 STOP
1170 :
1180 DEFine PROCedure Setup_Analysis_Tables
1190 LOCal ii
1200   OPEN_IN #5,drive2$&"ct_paramfile"
1210   INPUT #5,nextvat$, eoy$, printlines, form$, extract$, vfq$
1220   INPUT #5,prin$, lastvat$, vatclear, vatdoc : CLOSE #5
1230   Identify_File 2 : OPEN_IN #5,file$ : INPUT #5,n$
1240   FOR ii=1 TO grup_lim_max%
1250     INPUT #5,n$ : n$ = n$ & "0000"
1260     grup_desc$(ii)=n$(1 TO 15) : grup_rept%(ii)=n$(16)
1270     grup_popl%(ii)=n$(17 TO 19) : grup_max_popl%(ii) = n$(20 TO 22)
1280     END FOR ii : CLOSE #5
1290   Identify_File 3 : OPEN_IN #5,file$ : INPUT #5,n$
1300   FOR ii=1 TO Active_Heads%
1310     INPUT #5,n$ : n$ = n$ & "0000"
1320     anal_desc$(ii)=n$(1 TO 15) : anal_vtcd%(ii)=n$(16)
1330     anal_blnc(ii)=n$(17 TO 26) : anal_price%(ii) = n$(27 TO 31)
1340     END FOR ii : CLOSE #5
1350   Identify_File 4 : OPEN_IN #5,file$
1360   FOR ii=0 TO vatf_lim_max%
1370     INPUT #5,n$
1380     vatf_pcnt(ii)=n$(1 TO 5) : vatf_desc$(ii)=n$(6 TO 9)
1390     vatf_gros(ii)=n$(10 TO 19) : vatf_vat(ii)=n$(20 TO)
1400     END FOR ii
1410   INPUT #5,n$
1420   last_used_doc_date$=n$(1 TO 9) : doc_ct%=n$(10 TO 13) : tran_ct%=n$(14 TO 17)
1430   INPUT #5,n$
1440   FOR ii=0 TO 3 : vatf_rate$(ii)=n$((ii*8)+1 TO (ii*8)+8)
1450   CLOSE #5 : grup_desc$(0)="COMMENT ONLY..."
1460   END DEFine
1470 :
1480 DEFine PROCedure Identify_File(filno)
1490   SELect ON filno
1500     =1 : file$="ct_transact_dat" : rec_lenf%=35
1510     =2 : file$="ct_group_dat"    : rec_lenf%=22
1520     =3 : file$="ct_analysis_dat" : rec_lenf%=31
1530     =4 : file$="ct_vatfile_dat"  : rec_lenf%=29
1540     =5 : file$="ct_header_dat"   : rec_lenf%=60
1550     =REMAINDER : CLS : PRINT "wrong filenumber" : STOP
1560     END SELect
1570   file$=drive2$&file$
1580   END DEFine
1590 :
1600 DEFine FuNction Analysis_Base%(grp%)
1610 LOCal ii, jj
1620   jj = 1
1630   FOR ii=1 TO grp%-1 : jj = jj + grup_max_popl%(ii)
1640   RETurn jj
1650   END DEFine
1660 :
1670 DEFine FuNction Active_Heads%
1680 LOCal ii, jj
1690   jj = 0
1700   FOR ii=1 TO grup_lim_max% : jj = jj + grup_max_popl%(ii)
1710   RETurn jj
1720   END DEFine
1730 :
1740 DEFine PROCedure Reset_PapInk
1750   PAPER 0 : INK 7
1760   END DEFine
1770 :
1780 DEFine PROCedure Set_PapInk
1790   PAPER 2 : INK 7
1800   END DEFine
1810 :
1820 DEFine PROCedure Produce_Report
1830   OPEN #9,'scr' : WINDOW #9,312,20,106,236 : PAPER #9,4 : INK #9,0
1840   REPeat reploop
1850     WINDOW 204,124,214,89 : PAPER 0,4 : CLS
1860     WINDOW 204,124,204,79 : BORDER 1,0
1870     WINDOW 200,122,206,80 : BORDER 3,7 : PAPER 2 : INK 0 : CLS
1880     PRINT #9,"  Use  &  to move indicator.Hit ENTER to accept."
1890     rng_min=0 : rng_max=5 : rng_sel=0
1900     FOR ors=rng_min TO rng_max : Highlight 5
1910     Select_Menu_Option 5,2,0
1920     CLS #9
1930     SELect ON rng_sel
1940       =0 : Report_on_VAT
1950       =1 : Review_Docs
1960       =2 : Print_Profit_Loss
1970       =3 : Print_Bal_Sheet
1980       =4 : Print_Trial_Balance
1990       =5 : EXIT reploop
2000       END SELect
2010     END REPeat reploop
2020   END DEFine
2030 :
2040 DEFine PROCedure Review_Docs
2050 LOCal d1$(60), d2$(60), ii, jj, prtr_op
2060   Reset_PapInk : CLS
2070   d1$="are" : d2$="Documents"
2080   IF doc_ct% = 1 : d1$="is" : d2$="Document"
2090   d1$="There "&d1$&" "&doc_ct% : d2$ = d2$&" on File."
2100   ii=LEN(d1$) : jj=INT((31-ii)/2) : d1$=FILL$(" ",jj)&d1$
2110   ii=LEN(d2$) : jj=INT((31-ii)/2) : d2$=FILL$(" ",jj)&d2$
2120   Reset_PapInk : PRINT d1$\d2$; : Set_PapInk : CLS 2
2130   AT 3,0 : PRINT "Start at which Document "
2140   tr = Input_Value(3, 1, 1, doc_ct%)
2150   IF tr=0 : RETurn
2160   AT 5,0 : PRINT "End at which Document "
2170   te = Input_Value(5, doc_ct%, tr, doc_ct%)
2180   AT 7,0 : PRINT "Screen or Printer (S or P)"
2190   REPeat kn : Get_Key : IF f$ == "S" OR f$ == "P" : EXIT kn
2200   prtr_op=0 : d1$="SCREEN   "
2210   IF f$ == "P" : prtr_op=1 : d1$="PRINTER "
2220   AT 7,18 : PRINT d1$
2230   AT 9,0 : PRINT "Correct Y or N ?"
2240   Wait_for_YN
2250   IF f$ == "N" : Review_Docs : RETurn
2260   d1$ = "       Press <ESC> to abort"
2270   IF prtr_op
2280     OPEN_OVER #7,prtr$
2290     AT 9,0 : PRINT "PRINTING DOCUMENTS" : AT 10,0
2300     PRINT d1$
2310   ELSE
2320     CLOSE #3
2330     WINDOW 512,256,0,0 : PAPER 4 : CLS : OPEN #4,'scr_'
2340     WINDOW #4,426,50,44,5 : BORDER #4,3,7 : PAPER #4,0 : INK #4,7
2350     CLS #4 : PRINT #4,FILL$(" ",20);"PRINTING DOCUMENTS"
2360     AT #4,2,15 : PRINT #4,d1$
2370     OPEN #7,'scr_' : WINDOW #7,426,200,44,55 : BORDER #7,3,2 : PAPER #7,7
2380     PAPER #7,2 : INK #7,7 : CLS #7
2390     PRINT #7,"Doc                     Date             Type"
2400     PRINT #7,"Comment                 Analysis Head    VAT Code   Debit     Credit "
2410     WINDOW #7,426,179,44,77 : BORDER #7,3,2
2420     PAPER #7,7 : INK #7,0 : CLS #7
2430   END IF
2440   Print_Review
2450   IF exception
2460     exception=0
2470     IF prtr_op
2480       PRINT #7,\\"********************** PRINTING ABORTED *****************"
2490       PRINT #7,form$
2500     END IF
2510   END IF
2520   CLOSE #7
2530 END DEFine
2540 :
2550 DEFine PROCedure Print_Review
2560 LOCal jj, kk, tx$(20)
2570   lin_ct% = 0 : page% = 0
2580   IF prtr_op : Print_Header 2
2590   Position_at_Document tr
2600   FOR jj=tr TO te
2610     Get_Document
2620     IF prtr_op : Checklines
2630     tx$ = "Paid      AdjustmentReceived  Purchase  Sale      "((doc_type%+1)*10+1 TO (doc_type%+1)*10+10)
2640     cr = (doc_type% = -1 OR doc_type% = 2)
2650     PRINT #7,doc_no%;FILL$(" ",4-LEN(doc_no%));"                   ";doc_date$;"         ";tx$
2660     lin_ct% = lin_ct%+1 : exception = 0
2670     IF NOT Check_Screen:EXIT jj
2680     FOR kk=1 TO doc_lin_ct%
2690       IF doc_type% = 0 : cr = ( doci_val(kk) >= 0 ) : doci_val(kk)=ABS(doci_val(kk))
2700       PRINT #7,doci_com$(kk);"  ";
2710       IF doci_anl%(kk)<>0
2720         PRINT #7,"  ";anal_desc$(doci_anl%(kk));"  ";vatf_desc$(doci_vcd%(kk));"  ";
2730         IF cr=0 : PRINT #7,"           ";
2740         PRINT #7,Decimal$(doci_val(kk));
2750       END IF
2760         PRINT #7 : lin_ct% = lin_ct%+1
2770       IF NOT Check_Screen:EXIT jj
2870     END FOR kk
2880     IF NOT exception
2890       IF doc_type%<>0
2900         PRINT #7,op$(doc_ref%);"  ";doc_reftxt$;"  ";anal_desc$(doc_acct%);"        ";
2910         IF cr=1 : PRINT #7,"           ";
2920       ELSE
2930         PRINT #7,FILL$("  ",18);doc_reftxt$;FILL$(" ",25);
2940         cr=1 : IF doc_vat<0 : cr=0 : doc_vat=ABS(doc_vat)
2950       END IF
2960       PRINT #7,Decimal$(doc_totvl) : lin_ct% = lin_ct%+1
2970       IF NOT Check_Screen:EXIT jj
2980       PRINT #7,FILL$(" ",33);"V.A.T.";FILL$(" ",8);
2990       IF cr=0 : PRINT #7,"           ";
3000       PRINT #7,Decimal$(doc_vat) : lin_ct% = lin_ct%+1
3010       IF NOT Check_Screen:EXIT jj
3020       PRINT #7,FILL$("-",68+11*(prtr_op<>0)) : lin_ct% = lin_ct%+1
3030       IF NOT Check_Screen:EXIT jj
3040     END IF
3050   END FOR jj
3060   CLOSE #10 : CLOSE #11
3070   IF NOT prtr_op
3080    WINDOW #7,426,179,44,77 : BORDER #7,3,2
3090     AT #7,16,0:CLS #7,2
3100     PRINT #7,TO 20;"Press ENTER to Return to Menu     "
3110     Wait_for_ENTER : Show_Menu
3120   ELSE
3130     PRINT #7,form$
3140   END IF
3150 END DEFine
3160 :
3170 DEFine PROCedure Show_Message (z$)
3180 IF prtr_op
3190   AT 10,0 : PRINT z$
3200 ELSE
3210   AT #4,2,15 : PRINT #4,z$
3220 END IF
3230 END DEFine
3240 :
3250 DEFine FuNction Check_Screen
3260 LOCal f$(1)
3270 IF prtr_op=0 AND lin_ct%>=15
3280   REPeat Next_Page
3290     WINDOW #7,426,179,44,77 : BORDER #7,3,2
3300     AT #7,16,0:PRINT #7;TO 15;'PRESS  FOR LINE OR <ALT> FOR PAGE'
3310     WINDOW #7,426,162,44,77 : BORDER #7,3,2
3320     f$=INKEY$(#14,-1)
3330     IF f$=CHR$(216) OR f$=' ':SCROLL #7,-10:AT #7,14,0:RETurn 1
3340     IF f$=CHR$(217) OR f$=CHR$(10):CLS #7:lin_ct%=0:RETurn 1
3350     IF f$=CHR$(27):RETurn 0
3360   END REPeat Next_Page
3370 END IF
3372 IF INKEY$(#14)=CHR$(27):RETurn 0
3375 RETurn 1
3380 END DEFine
3390 :
3400 DEFine PROCedure Print_Trial_Balance
3410 LOCal x1, x4, offset, ii, st, nd
3420   Set_up_Report 5
3430   Calc_Total_Stats : x1 = 0 : x4 = 0
3440   FOR jj=1 TO grup_lim_max%
3450     IF grup_popl%(jj) = 0 : NEXT jj : EXIT jj
3460     PRINT #7,\grup_desc$(jj) : lin_ct% = lin_ct%+2
3470     st = Analysis_Base%((jj)) : nd = st+grup_popl%(jj)-1
3480     FOR ii = st TO nd
3490       IF suppress_zero : IF anal_blnc(ii) = 0 : NEXT ii : EXIT ii
3500       PRINT #7,TO 17;anal_desc$(ii);"  ";
3510       IF anal_vtcd%(ii) <> 4
3520         PRINT #7;"(";vatf_desc$(anal_vtcd%(ii));")   ";
3530         ELSE : PRINT #7;"         "; : END IF
3540       offset = 1
3550       IF grup_rept%(jj) = 1 OR grup_rept%(jj) = 5 :  offset = -1
3560       IF (offset * anal_blnc(ii)) < 0
3570         PRINT #7,FILL$(" ",14);
3580         x1 = x1 + ABS(anal_blnc(ii))
3590         ELSE
3600         x4 = x4 + ABS(anal_blnc(ii)) : END IF
3610       PRINT #7,Decimal$(ABS(anal_blnc(ii)))
3620       lin_ct% = lin_ct%+1
3630       IF lin_ct% > printlines-15
3640         PRINT #7,FILL$("-",79)
3650         PRINT #7,"Carried Forward  ";FILL$(" ",26);Decimal$(x4);"    ";Decimal$(x1)
3660         PRINT #7,form$ : Print_Header 5
3670         PRINT #7,"Brought Forward  ";FILL$(" ",26);Decimal$(x4);"    ";Decimal$(x1)
3680         END IF
3690       END FOR ii
3700     END FOR jj
3710   PRINT #7,\FILL$(" ",17);"V.A.T.";FILL$(" ",20);Decimal$(grp_inpvat);"    ";Decimal$(grp_outvat)
3720   PRINT #7,FILL$("-",79)
3730   PRINT #7,FILL$(" ",43);Decimal$(x4+grp_inpvat);"    ";Decimal$(x1+grp_outvat)
3740   PRINT #7,form$ : CLOSE #7
3750   END DEFine
3760 :
3770 DEFine PROCedure Print_Profit_Loss
3780 LOCal ii, jj, kk, qq, w, base%, c(3)
3790   Set_up_Report 3
3800   FOR ii = 1 TO 3 : c(ii) = 0
3810   FOR ii = 1 TO grup_lim_max% : grup_total(ii) = 0
3820   FOR ii = 1 TO 3
3830     Check_Page 1,10,3
3840     PRINT #7,"SALES        COST OF SALESOVERHEADS    "(((ii-1)*13)+1 TO ((ii-1)*13)+13)
3850     FOR jj=1 TO grup_lim_max%
3860       IF grup_rept%(jj)=ii
3870         base% = Analysis_Base%((jj))-1
3880         FOR kk=1 TO grup_popl%(jj)
3890           qq= base% + kk
3900           IF suppress_zero : IF anal_blnc(qq) = 0 : NEXT kk : EXIT kk
3910           Check_Page 1,10,3
3920           PRINT #7,"         ";anal_desc$(qq);"      ";
3930           IF ii=1 : PRINT #7,FILL$(" ",36);
3940           w = anal_blnc(qq)
3950           grup_total(jj) = grup_total(jj)+w : PRINT #7,Decimal$(w)
3960           END FOR kk
3970         Check_Page 1,10,3
3980         IF ii=1 : PRINT #7,FILL$(" ",36);
3990         PRINT #7,FILL$(" ",27);"-------------"
4000         Check_Page 2,10,3
4010         PRINT #7,"     Group:-";grup_desc$(jj);FILL$(" ",18);
4020         IF ii<3 : PRINT #7,FILL$(" ",21);
4030         w = grup_total(jj) : c(ii)=c(ii)+w : PRINT #7,Decimal$(w)
4040         PRINT #7
4050         END IF
4060       END FOR jj
4070     IF ii=3 : Check_Page 1,10,3 : PRINT #7,FILL$(" ",65);Decimal$(c(ii))
4080     IF ii>1
4090       Check_Page 2,10,3
4100       PRINT #7,FILL$(" ",61);"---------------"\\FILL$(" ",32);
4110       END IF
4120     IF ii=2
4130       w=c(1)-c(2) : PRINT #7,"GROSS ";
4140       IF w < 0
4150         PRINT #7,"Loss   "; : ELSE : PRINT #7,"Profit "; : END IF
4160       PRINT #7,FILL$(".",19);"  ";Decimal$(ABS(w))\\\
4170       Check_Page 3,10,3
4180       END IF
4190     IF ii=3
4200       Check_Page 1,10,3
4210       w=c(1)-c(2)-c(3) : PRINT #7," NET ";
4220       IF w<0
4230         PRINT #7,"Loss    "; : ELSE : PRINT #7,"Profit  "; : END IF
4240       PRINT #7,FILL$(".",18);"  ";Decimal$(ABS(w))
4250       END IF
4260     END FOR ii
4270   PRINT #7,\form$ : CLOSE #7
4280   END DEFine
4290 :
4300 DEFine PROCedure Print_Bal_Sheet
4310 LOCal w, ii, jj, kk, offset, np, qq, q$(20)
4320   Set_up_Report 4 : Calc_Total_Stats
4330   FOR ii = 4, 6, 7, 5
4340     SELect ON ii
4350       = 4 : PRINT #7,"FIXED ASSETS"
4360       = 6 : PRINT #7,"CURRENT.................  ASSETS / LIABILITIES"
4370       = 5 : PRINT #7,"CAPITAL EMPLOYED"
4380       END SELect
4390     IF ii<>7 : PRINT #7 : Check_Page 2,10,4
4400 :
4410     REMark *** Reporting Categories  4 = Fixed Assets
4420     REMark                           6 = Current Assets
4430     REMark                           7 = Current Liabilities
4440     REMark                           5 = Capital
4450 :
4460     FOR jj = 1 TO grup_lim_max%
4470       IF grup_rept%(jj)=ii
4480         base% = Analysis_Base%((jj))-1
4490         FOR kk = 1 TO grup_popl%(jj)
4500           qq = base% + kk
4510           IF suppress_zero : IF anal_blnc(qq) = 0 : NEXT kk : EXIT kk
4520           Check_Page 1,10,4
4530           PRINT #7,"     ";anal_desc$(qq);" ";
4540           offset = 1
4550           IF ii = 5 : offset = -1
4560           IF (offset * anal_blnc(qq)) < 0 : PRINT #7,FILL$(" ",14);
4570           IF ii=6
4580             PRINT #7,Decimal$(ABS(anal_blnc(qq)))
4600           ELSE
4610             IF ii=4 : PRINT #7,FILL$(" ",22);
4620             PRINT #7,Decimal$(ABS(anal_blnc(qq)))
4630           END IF
4640           END FOR kk
4650         END IF
4660       END FOR jj
4670     IF ii=7
4680       Check_Page 4,10,4
4690       IF balvat_cat%=7 : q$="VAT Payable    " : ELSE : q$="VAT Repayable  "
4700       PRINT #7,\"     ";q$;" ";
4710       IF balvat_cat%=7 : PRINT #7,"              ";
4715       IF suppress_zero
4720         IF balvat<>0 : PRINT #7,Decimal$(ABS(balvat));
4725       ELSE
4726         PRINT #7,Decimal$(ABS(balvat));
4727       END IF
4730       PRINT #7,\FILL$(" ",21);FILL$("-",25)
4740       PRINT #7,"     TOTAL.......... ";Decimal$(ABS(rg(6)));"    ";Decimal$(ABS(rg(7)))
4750       Check_Page 6,10,4
4760       PRINT #7,\\"NET CURRENT "; : w=rg(6)+rg(7)
4770       kk = (w<0)*17
4780       PRINT #7,"ASSETS...........LIABILTIES......."(kk+1 TO kk+17);FILL$(" ",39);Decimal$(w)
4790       PRINT #7,FILL$(" ",68);"-----------"
4800       PRINT #7,FILL$(" ",68);Decimal$(rg(4)+w)
4810       PRINT #7,FILL$(" ",68);"-----------" : PRINT #7 : PRINT #7
4820     ELSE
4830       IF ii<>6
4840         Check_Page 4,10,4
4850         PRINT #7,FILL$(" ",34);
4860         IF ii=4 : PRINT #7,FILL$(" ",22);
4870         PRINT #7,FILL$("-",23)
4880         PRINT #7,FILL$(" ",46);
4890         IF ii=4 : PRINT #7,FILL$(" ",22);
4900         w=ABS(rg(ii)) : PRINT #7,Decimal$(w) : PRINT #7 : PRINT #7
4910       END IF
4920     END IF
4930   END FOR ii
4940   Check_Page 4,10,4
4950   np = rg(1)-rg(2)-rg(3) : w = rg(4) + rg(6) + rg(7)
4960   IF np < 0 : q$="NET LOSS  " : ELSE : q$="NET PROFIT"
4970   PRINT #7,\q$&"     From Profit & Loss Account     ";Decimal$(np)
4980   PRINT #7,FILL$(" ",46);FILL$("-",33)
4990   PRINT #7,\FILL$(" ",46);Decimal$(rg(5)+np);FILL$(" ",12);Decimal$(w)
5000   PRINT #7,FILL$(" ",46);FILL$("-",33)
5010   PRINT #7,\form$ : CLOSE #7
5020   END DEFine
5030 :
5040 DEFine PROCedure Report_on_VAT
5050 LOCal kp,ii,x
5060   Set_up_Report 1 : Calc_Total_Stats
5070   PRINT #7,FILL$(" ",24);"|";FILL$(" ",12);"OUTPUTS         |             INPUTS"
5080   Print_Mask
5090   PRINT #7,FILL$(" ",17);"Rate   |      Goods           VAT   |      Goods           VAT"
5100   PRINT #7,FILL$("-",24);"+";FILL$("-",28);"+";FILL$("-",25)
5110   FOR ii=0,1,3,2
5120     Print_Mask
5130     PRINT #7,FILL$(" ",8-LEN(vatf_rate$(ii)));vatf_rate$(ii);
5140     PRINT #7,"   ";Decimal$(vatf_pcnt(ii));"%  | ";
5150     PRINT #7,Decimal$(vatf_gros(ii));"    ";Decimal$(vatf_vat(ii));"   | ";
5160     PRINT #7,Decimal$(vatf_gros(ii+5));"    ";Decimal$(vatf_vat(ii+5))
5170     Print_Mask
5180     IF ii<>2
5190       PRINT #7,FILL$("-",24);"+";FILL$("-",28);"+";FILL$("-",25) : ELSE
5200       PRINT #7,FILL$("=",79) : END IF
5210     END FOR ii
5220   Print_Mask
5230   PRINT #7,"Value of Outputs";FILL$(" ",8);"| ";Decimal$(grp_outgrs);FILL$(" ",17);"|"
5240   PRINT #7,"Value of Output Tax";FILL$(" ",5);"|               ";Decimal$(grp_outvat);"   |"
5250   Print_Mask
5260   PRINT #7,"Value of Inputs";FILL$(" ",9);"|";FILL$(" ",28);"| ";Decimal$(grp_inpgrs)
5270   PRINT #7,"Value of Input Tax";FILL$(" ",6);"|";FILL$(" ",28);"|               ";Decimal$(grp_inpvat)
5280   Print_Mask
5290   kp=ABS(ntp)
5300   IF ntp<0 : PRINT #7;"Net Tax Repayable"; : ELSE : PRINT #7;"Net Tax Payable  ";
5310   z$ = "       |"&FILL$(" ",28)&"|"&FILL$(" ",25)
5320   x=24 : IF ntp<0 : x=53
5330   z$(x TO x+9)=Decimal$(kp) : PRINT #7,z$
5340   Print_Mask
5350   PRINT #7,FILL$("-",79)
5360   PRINT #7,\\\"These figures could include Documents that do not relate to this current VAT    Period."
5370   PRINT #7,"DO NOT use these figures for completing your VAT Return !!"
5380   PRINT #7,\"To obtain VAT Return Information, select SECURITIES from the Main Menu."
5390   PRINT #7,\FILL$("-",79)
5400   PRINT #7,\"Previous Period Balance Owed ";
5410   IF anal_blnc(1)<0 : PRINT #7,"to "; : ELSE : PRINT #7,"from "; : END IF
5420   PRINT #7,"Customs & Excise is ";Decimal$(ABS(anal_blnc(1)))
5430   PRINT #7,\FILL$("-",79) : PRINT #7,form$
5440   CLOSE #7
5450   END DEFine
5460 :
5470 DEFine PROCedure Print_Mask
5480   PRINT #7,FILL$(" ",24);"|";FILL$(" ",28);"|"
5490   END DEFine
5500 :
5510 DEFine PROCedure Set_up_Report (repno)
5520   Set_PapInk : CLS
5530   IF repno <> 1
5540     AT 3,0 : PRINT "Suppress ZERO items Y or N"
5550     Wait_for_YN
5560     suppress_zero = (f$ == 'y')
5570     END IF
5580   AT 5,10 : PRINT "PLEASE WAIT"
5590   AT 7, 1 + (21-LEN(Report_Name$(repno)))/2
5600   PRINT "PRINTING ";Report_Name$(repno) : page% = 0
5610   OPEN_OVER #7,prtr$ : Print_Header repno
5620 END DEFine
5630 :
5640 DEFine FuNction Report_Name$(repno)
5650   SELect ON repno
5660     =1 : RETurn "VAT REPORT"
5670     =2 : RETurn "DOCUMENT REPORT"
5680     =3 : RETurn "PROFIT & LOSS ACCOUNT"
5690     =4 : RETurn "BALANCE SHEET"
5700     =5 : RETurn "TRIAL BALANCE"
5710     END SELect
5720   END DEFine
5730 :
5740 DEFine PROCedure Checklines
5750   IF (lin_ct%+doc_lin_ct%+2)<printlines-13 : RETurn
5760   PRINT #7,form$ : Print_Header 2
5770   END DEFine
5780 :
5790 DEFine PROCedure Check_Page(add%, subt%, repno)
5800   lin_ct% = lin_ct% + add%
5810   IF lin_ct% > (printlines - subt%)
5820     PRINT #7; form$;
5830     Print_Header repno : lin_ct% = add%
5840     END IF
5850   END DEFine
5860 :
5870 DEFine PROCedure Print_Header(repno)
5880 LOCal ii, yr, dy, hr
5890 LOCal z$(20), dayth$(4), part$(6), rep_type$(24)
5900   rep_type$ = Report_Name$(repno)
5910   ii=INT((75-LEN(rep_type$)-LEN(fullname$))/2)
5920   z$=DATE$ : PRINT #7,FILL$(" ",ii);rep_type$;" for ";fullname$
5930   PRINT #7,\"Printed on ";
5940   yr=z$(1 TO 4) : : hr=z$(13 TO 14)
5950   part$="a.m." : IF hr>12 : hr=hr-12 : part$="p.m."
5960   IF hr=12 : part$="p.m."
5970   ii = z$(11)
5980   dy = z$(10 TO 11)
5990   SELect ON ii
6000     =1 : dayth$="st." : IF dy=11 : dayth$="th."
6010     =2 : dayth$="nd." : IF dy=12 : dayth$="th."
6020     =3 : dayth$="rd." : IF dy=13 : dayth$="th."
6030     =REMAINDER : dayth$="th."
6040     END SELect
6050   PRINT #7,dy;dayth$;" ";z$(6 TO 8);" ";yr;FILL$(" ",33);"Time ";hr;":";z$(16 TO 17);" ";part$
6060   PRINT #7 : page% = page% + 1
6070   SELect ON repno
6080     =2 : PRINT #7,"From Document Number ";tr;" to ";te;FILL$(" ",40);"Page ";page%
6090          PRINT #7,FILL$("-",79)
6100          PRINT #7,"Doc                     Date             Type"
6110          PRINT #7,"Comment                 Analysis Head    VAT Code   Debit     Credit "
6120     =1 : PRINT #7,\"VAT Number .... ";vatno$(1 TO 3);" ";vatno$(4 TO 7);" ";vatno$(8 TO)
6130          PRINT #7,\"Up to Document Number ";doc_ct%;FILL$(" ",34);"Period - ";nextvat$
6140     =5 : PRINT #7,"Up to Document Number ";doc_ct%;FILL$(" ",44);"Page ";page%
6150          PRINT #7,FILL$("-",79)
6160          PRINT #7,"Group            Analysis         (VAT)       Debit         Credit"
6170     =REMAINDER : PRINT #7,"Up to Document Number ";doc_ct%;FILL$(" ",44);"Page ";page%
6180     END SELect
6190   PRINT #7,FILL$("-",79)
6200   lin_ct%=0
6210   END DEFine
6220 :
6230 DEFine PROCedure Calc_Total_Stats
6240 LOCal st, nd, kk, ii, jj
6250   grp_inpgrs = 0 : grp_outvat = 0 : grp_inpvat = 0 : grp_outgrs = 0
6260   FOR ii = 0 TO 3
6270     grp_outgrs = grp_outgrs+vatf_gros(ii)
6280     grp_outvat = grp_outvat+vatf_vat(ii)
6290     grp_inpgrs = grp_inpgrs+vatf_gros(ii+5)
6300     grp_inpvat = grp_inpvat+vatf_vat(ii+5)
6310     END FOR ii
6320   ntp = grp_outvat - grp_inpvat
6330   FOR ii = 1 TO 7 : rg(ii) = 0
6340   FOR ii = 1 TO grup_lim_max%
6350     IF grup_popl%(ii)<>0
6360       st = Analysis_Base%((ii)) : nd = st+grup_popl%(ii)-1
6370       FOR jj = st TO nd
6380         kk = grup_rept%(ii)
6390         REMark Check for where current liabilities owe you money
6400         IF kk = 6 AND anal_blnc(jj)<0 : kk = 7
6410         REMark Check for where you owe money to current assets!
6420         IF kk = 7 AND anal_blnc(jj)>0 : kk = 6
6430         rg(kk) = rg(kk)+anal_blnc(jj)
6440       END FOR jj
6450     END IF
6460     END FOR ii
6470   balvat = grp_inpvat-grp_outvat
6480   kk = 6 + (balvat < 0)
6490   rg(kk) = rg(kk) + balvat : balvat_cat% = kk
6500   END DEFine
6510 :
6520 DEFine PROCedure Get_Document
6530 LOCal ii
6540   INPUT #10,n$
6550   doc_date$=n$(1 TO 9) : doc_type%=n$(10 TO 11) : doc_acct%=n$(12 TO 15)
6560   doc_ref%=n$(16) : doc_reftxt$=n$(17 TO 24) : doc_no%=n$(25 TO 28)
6570   doc_totvl=n$(29 TO 38) : doc_vat=n$(39 TO 48) : doc_first%=n$(49 TO 52)
6580   doc_lin_ct%=n$(53 TO 55)
6590   FOR ii=1 TO doc_lin_ct%
6600     INPUT #11,n$
6610     doci_val(ii)  =n$(1 TO 10)  : doci_com$(ii)=n$(11 TO 30)
6620     doci_anl%(ii) =n$(31 TO 33) : doci_vcd%(ii)=n$(34 TO 35)
6630     END FOR ii
6640   END DEFine
6650 :
6660 DEFine PROCedure Position_at_Document(begin)
6670 LOCal x
6680   Identify_File 5 : OPEN #10,file$
6690   BGET #10\(begin*(rec_lenf%+1)) : INPUT #10,n$ : x=n$(49 TO 52)
6700   BGET #10\(begin*(rec_lenf%+1))
6710   Identify_File 1 : OPEN #11,file$ : BGET #11\(x*(rec_lenf%+1))
6720   END DEFine
6730 :
6740 DEFine PROCedure Select_Menu_Option(col%,paph%,inkh%)
6750 LOCal ors
6760   REPeat smo_lp
6770     ors = rng_sel
6780     Reset_PapInk : Highlight col%
6790     Get_Key
6800     IF key = ENTER% AND NOT exception : EXIT smo_lp
6810     Adj_Selection options$
6820     PAPER paph% : INK inkh% : Highlight col%
6830     END REPeat smo_lp
6840   END DEFine
6850 :
6860 DEFine PROCedure Highlight(col%)
6870   AT ((ors-rng_min)*2),col% : PRINT options$(ors)
6880   END DEFine
6890 :
6900 REFERENCE array$(0,0)
6910 DEFine PROCedure Adj_Selection(array$)
6920 LOCal ii, jj
6930   SELect ON key
6940     = lf_arrow%, up_arrow% : rng_sel=rng_sel-1
6950                              IF rng_sel<rng_min : rng_sel=rng_max
6960                              RETurn
6970     = rt_arrow%, dn_arrow% : rng_sel=rng_sel+1
6980                              IF rng_sel>rng_max : rng_sel=rng_min
6990                              RETurn
7000     END SELect
7010   FOR ii = rng_sel+1 TO rng_max
7020     IF Found_Option_Match : rng_sel = ii : RETurn
7030     END FOR ii
7040   FOR ii = rng_min TO rng_sel-1
7050     IF Found_Option_Match : rng_sel = ii : RETurn
7060     END FOR ii
7070   END DEFine
7080 :
7090 DEFine FuNction Found_Option_Match
7100   jj = 0
7110   REPeat fom_lp
7120     jj=jj+1 : IF jj > LEN(array$(ii)) : RETurn 0
7130     IF array$(ii,jj)<>" " : EXIT fom_lp
7140     END REPeat fom_lp
7150   RETurn CHR$(key) == array$(ii,jj)
7160   END DEFine
7170 :
7180 DEFine FuNction Input_Value(lin%,dflt%,minvl%,maxvl%)
7190   REPeat kl
7200     Reset_PapInk
7210     AT lin%,24 : PRINT "    "
7220     AT lin%,24 : Get_String 1,4
7230     x=LEN(z$) : IF x<4 : x=4
7240     Set_PapInk : AT lin%,24 : PRINT FILL$(" ",x) : x = z$
7250     IF x = 0 : x = dflt%
7260     IF Within( x, minvl%, maxvl% ) : EXIT kl
7270     END REPeat kl
7280   AT lin%, 24 : PRINT x : RETurn x
7290   END DEFine
7300 :
7310 DEFine PROCedure Get_String(type,lenf%)
7320   z$=""
7330   REPeat oblp
7340     Get_Kbd_Char type
7350     IF key = ENTER% : EXIT oblp
7360     IF LEN(z$) < lenf% : z$=z$&f$ : PRINT f$;
7370     END REPeat oblp
7380   IF z$=""
7390     IF type=1 : z$="0" : ELSE : z$=" " : END IF
7400     END IF
7410   END DEFine
7420 :
7430 DEFine PROCedure Get_Key
7440   exception = 0
7450   f$ = INKEY$(#14,-1) : key = CODE(f$)
7460   IF key = ESC% : key = ENTER% : f$=CHR$(ENTER%) : exception=1
7470   END DEFine
7480 :
7490 DEFine PROCedure Wait_for_YN
7500   REPeat wyn : Get_Key : IF f$ INSTR "YN" : EXIT wyn
7510   END DEFine
7520 :
7530 DEFine PROCedure Wait_for_ENTER
7540   REPeat wfe : Get_Key : IF key = ENTER% : EXIT wfe
7550   END DEFine
7560 :
7570 DEFine PROCedure Get_Kbd_Char(ii)
7580   REPeat meyloop
7590     Get_Key : IF key = ENTER% : EXIT meyloop
7600     SELect ON ii
7610       =1 : IF Within(key, 48, 57)  : EXIT meyloop
7620       =2 : IF Within(key, 32, 127) : EXIT meyloop
7630       END SELect
7640     END REPeat meyloop
7650   END DEFine
7660 :
7670 DEFine PROCedure Show_Menu
7680 LOCal ii, jj, x$(60)
7690   WINDOW 512,256,0,0 : PAPER 4 : CLS
7700   SCALE 110,0,0 : WINDOW 256,125,20,9 : Draw_Logo
7710   INK 7
7720   WINDOW 302,42,166,20 : PAPER 0,4 : CLS
7730   WINDOW 302,42,156,10 : BORDER 1,0
7740   WINDOW 298,40,158,11 : BORDER 3,2 : PAPER 7 : INK 0 : CLS
7750   CSIZE 2,0 : PRINT " Cash Trader  with VAT" : CSIZE 0,0
7760   ii=47-LEN(fullname$) : jj=INT(ii/2)
7770   x$=FILL$(" ",jj)&fullname$&FILL$(" ",ii-jj)
7780   PRINT \x$
7790   Set_Window_3 1 : CLOCK #3
7800   END DEFine
7810 :
7820 DEFine PROCedure Set_Window_3 (small)
7830   OPEN #3,'scr_'
7840   WINDOW #3,139,42,59,120 : PAPER #3,0,4 : CLS #3
7850   WINDOW #3,139,42,51,110 : BORDER #3,1,7 : PAPER #3,2,0,1 : CLS #3
7860   WINDOW #3,119,22,61,120 : BORDER #3,1,7 : PAPER #3,0 : INK #3,7
7870   CLS #3
7880   IF small : WINDOW #3,60,20,91,121
7890   END DEFine
7900 :
7910 DEFine PROCedure Draw_Logo
7920   INK 4,0 : FILL 1 : CIRCLE 35,82,20
7930   INK 4 : FILL 1 : CIRCLE 35,82,13 : INK 4,0
7940   FILL 1 : LINE 53,61 TO 57,66 TO 48,71 TO 44,66 TO 53,61
7950   FILL 1
7960   LINE 60,101 TO 60,62 TO 87,62 TO 87,68 TO 68,68 TO 68,101 TO 60,101
7970   INK 0 : FILL 1 : CIRCLE 30,85,20
7980   INK 4 : FILL 1 : CIRCLE 30,85,13
7990   INK 0 : FILL 1 : LINE 48,64 TO 52,69 TO 43,74 TO 39,69 TO 48,64
8000   FILL 1 : INK 0
8010   LINE 55,104 TO 55,65 TO 82,65 TO 82,71 TO 63,71 TO 63,104 TO 55,104
8020   INK 4,0 : FILL 0 : FILL 1
8030   ARC 22,75 TO 38,95,-2.2;22,75 TO 38,95,-3.2
8040   FILL 0
8050   END DEFine
8060 :
8070 DEFine FuNction Decimal$(num)
8080 LOCal x$(12), ii, q, p
8090   q = 100 * num
8100   IF ABS(q) >= .5 : q = INT(ABS(q) + .5) : ELSE : q = 0
8110   p = INT(q/100) : ii = q - p * 100
8120   x$ = p
8130   SELect ON ii
8140     = 0         : x$ = x$ & ".00"
8150     = 1 TO 9    : x$ = x$ & ".0" & ii
8160     = REMAINDER : x$ = x$ & "." & ii
8170     END SELect
8180   IF num < 0 : x$ = '-' & x$
8190   x$ = FILL$(" ",money_fieldsize%-LEN(x$)) & x$
8200   RETurn x$
8210   END DEFine
8220 :
8230 DEFine FuNction Within(val, min, max)
8240   RETurn val >= min AND val <= max
8250   END DEFine
8260 :
8270 DEFine FuNction Pull_Up$(off)
8280 LOCal x$(50),lenf%
8290   x$ = '':lenf%=PEEK_W(addr+off)
8300   FOR ii = 1 TO lenf% : x$ = x$ & CHR$(PEEK(addr+off+1+ii))
8310   ii = ' ' INSTR x$ : IF ii = 0 : RETurn x$
8320   RETurn x$(1 TO ii-1)
8330 END DEFine
