1000 REMark CT_SECURITY - Backup module for Cash Trader
1005 REMark Updated 24/3/2002 Rich Mellor
1010 :
1020 REMark    Chas Dillon, Apr 87
1021 TURBO_objfil "win2_ct_security_exe"
1022 TURBO_taskn  "CTSecure 3.11"
1023 TURBO_objdat 16
1024 TURBO_repfil
1025 TURBO_diags 'd' : TURBO_struct 's' : TURBO_model '<'
1026 TURBO_optim 'b' : TURBO_locstr 'i' : TURBO_windo 0
1030 :
1040 REMark  Extra cmds/fns:   BGET, FOP_DIR, FOP_IN
1050 :
1060 DATA_AREA 16   : DIM vers$(10)  : vers$ = "CTver 3.9"
1065 OPEN #14,'con' : IF COMPILED : OPEN #0,'scr' : OPEN #1,'scr'
1070 :
1080 IMPLICIT% rng_sel, rng_min, rng_max, ii, jj, kk, cur_doc
1090 IMPLICIT% filno, rcd, key, ors, yr, dy, hr, ppos
1100 :
1110 DIM drive1$(42),drive2$(42),cart$(6),prtr$(10)
1120 DIM f$(2),n$(70),file$(42),doc_date$(12),doc_reftxt$(12),last_used_doc_date$(12)
1130 DIM fullname$(42),example$(4),name$(42),last$(20),create$(20),vatno$(20)
1140 DIM nextvat$(20), eoy$(20), form$(6), extract$(10), vfq$(6)
1150 DIM prin$(6), lastvat$(20)
1160 :
1170 WHEN ERRor
1180   WINDOW 258,70,120,70 : BORDER 1,0 : PAPER 4 : INK 0
1190   CLS : PRINT \' An error has occurred ... (';ERNUM%!!ERLIN%;')'
1200   PRINT ' Please check correct volumes are loaded'
1210   PRINT ' and ';drive2$;' is write enabled'
1220   PRINT \'   Press ENTER to retry; ESC to quit'
1230   Get_Key : IF exception : STOP
1240   RETRY
1250 END WHEN
1260 :
1261 money_fieldsize% = 10
1265 IF COMPILED
1280   addr = OPTION_CMD$
1300   drive1$ = Pull_Up$(0)
1310   drive2$ = Pull_Up$(44)
1320   cart$   = Pull_Up$(88)
1330   prtr$   = Pull_Up$(96)
1340   tran_lim_max% = PEEK_W(addr+110)
1350   anal_lim_max% = PEEK_W(addr+112)
1360   grup_lim_max% = PEEK_W(addr+114)
1370   vatf_lim_max% = PEEK_W(addr+116)
1380   lines_per_doc_max% = PEEK_W(addr+118)
1385 ELSE
1386   drive1$ = 'win2_CTTe_'
1387   drive2$ = 'win2_CTTe_'
1388   cart$   = 'DISK'
1389   prtr$   = 'ram1_test'
1390   tran_lim_max% = 4000
1391   anal_lim_max% = 460
1392   grup_lim_max% = 20
1393   vatf_lim_max% = 9
1394   lines_per_doc_max% = 30
1397 END IF
1400 :
1410 REMark >>>--<<<   Figurative Constants -------------------------------
1420 :
1430 lf_arrow% = 192 : rt_arrow% = 200 : up_arrow% = 208 : dn_arrow% = 216
1440 ctrl_lf%  = 194 : ctrl_rt%  = 202 : del_lf%   = 194
1450 F1_key%   = 232 : F2_key%   = 236 : ENTER%    = 10  : ESC% = 27
1460 :
1470 REMark >>>++<<<   ----------------------------------------------------
1480 :
1490 DIM m$(12,3),m%(12)
1500 :
1510 DIM vatf_pcnt(vatf_lim_max%),vatf_desc$(vatf_lim_max%,4)
1520 DIM vatf_gros(vatf_lim_max%),vatf_vat(vatf_lim_max%)
1530 DIM vatf_rate$(3,8)
1540 DIM anal_blnc(anal_lim_max%),anal_desc$(anal_lim_max%,15)
1550 DIM anal_vtcd%(anal_lim_max%), anal_price%(anal_lim_max%)
1560 DIM grup_desc$(grup_lim_max%,15), grup_rept%(grup_lim_max%)
1570 DIM grup_popl%(grup_lim_max%), grup_max_popl%(grup_lim_max%)
1580 DIM doci_val(lines_per_doc_max%), doci_com$(lines_per_doc_max%,20)
1590 DIM doci_vcd%(lines_per_doc_max%), doci_anl%(lines_per_doc_max%)
1600 DIM doci_vat(lines_per_doc_max%)
1610 DIM options$(5,25)
1620 DIM vat$(11,32)
1630 :
1660 DATA " Copy to/from Work "," Do VAT Return "," Carry Forward "," Year End "," Clear Down "," Return to Main Menu "
1670 DATA "Dec",31,"Jan",31,"Feb",28,"Mar",31,"Apr",30,"May",31,"Jun",30,"Jul",31,"Aug",31,"Sep",30,"Oct",31,"Nov",30,"Dec",31
1680 RESTORE
1690 FOR ii=0 TO 5 : READ options$(ii)
1700 options$(0) = options$(0)&cart$&' '
1710 FOR ii=0 TO 12 : READ m$(ii),m%(ii)
1720 :
1730 RETRY_HERE
1740 :
1750 Read_Register : Setup_Analysis_Tables
1760 bf_profit_anl% = Analysis_Base%(4)
1770 Build_Menu_Screen : Do_Main_Process
1780 :
1790 CLOSE #3 : Set_Window_3 0 : CLS #3
1800 PRINT #3,"   Returning to       Main Menu."
1810 Writeparam
1820 IF COMPILED : CLOSE #0 : CLOSE #1
1830 CLOSE #3
1840 STOP
1850 :
1860 DEFine PROCedure Read_Register
1870   OPEN_IN #5,drive2$&"ct_register"
1880   INPUT #5,fullname$, example$, name$, last$, create$, vatno$
1890   CLOSE #5
1900 END DEFine
1910 :
1920 DEFine PROCedure Read_Param
1930   OPEN_IN #5,drive2$&"ct_paramfile"
1940   INPUT #5,nextvat$, eoy$, printlines, form$, extract$, vfq$
1950   INPUT #5,prin$, lastvat$, vatclear, vatdoc : CLOSE #5
1960 END DEFine
1970 :
1980 DEFine PROCedure Setup_Analysis_Tables
1990 LOCal ii
2000   Read_Param
2010   Identify_File 2 : OPEN_IN #5,file$ : INPUT #5,n$
2020   FOR ii=1 TO grup_lim_max%
2030     INPUT #5,n$ : n$ = n$ & "0000"
2040     grup_desc$(ii)=n$(1 TO 15) : grup_rept%(ii)=n$(16)
2050     grup_popl%(ii)=n$(17 TO 19) : grup_max_popl%(ii) = n$(20 TO 22)
2060   END FOR ii
2070   CLOSE #5 : Identify_File 3 : OPEN_IN #5,file$ : INPUT #5,n$
2080   FOR ii=1 TO Active_Heads%
2090     INPUT #5,n$ : n$ = n$ & "0000"
2100     anal_desc$(ii)=n$(1 TO 15) : anal_vtcd%(ii)=n$(16)
2110     anal_blnc(ii)=n$(17 TO 26) : anal_price%(ii) = n$(27 TO 31)
2120   END FOR ii
2130   CLOSE #5 : Identify_File 4 : OPEN_IN #5,file$
2140   FOR ii=0 TO vatf_lim_max%
2150     INPUT #5,n$
2160     vatf_pcnt(ii)=n$(1 TO 5) : vatf_desc$(ii)=n$(6 TO 9)
2170     vatf_gros(ii)=n$(10 TO 19) : vatf_vat(ii)=n$(20 TO)
2180   END FOR ii
2190   INPUT #5,n$
2200   last_used_doc_date$=n$(1 TO 9) : doc_ct%=n$(10 TO 13) : tran_ct%=n$(14 TO 17)
2210   INPUT #5,n$
2220   FOR ii=0 TO 3 : vatf_rate$(ii)=n$((ii*8)+1 TO (ii*8)+8)
2230   CLOSE #5 : grup_desc$(0)="COMMENT ONLY..."
2240 END DEFine
2250 :
2260 DEFine FuNction Analysis_Base%(grp%)
2270 LOCal ii, jj
2280   jj = 1
2290   FOR ii=1 TO grp%-1 : jj = jj + grup_max_popl%(ii)
2300   RETurn jj
2310 END DEFine
2320 :
2330 DEFine FuNction Active_Heads%
2340 LOCal ii, jj
2350   jj = 0
2360   FOR ii=1 TO grup_lim_max% : jj = jj + grup_max_popl%(ii)
2370   RETurn jj
2380 END DEFine
2390 :
2400 DEFine PROCedure Do_Main_Process
2410   REPeat reploop
2420     PAPER #0,4 : INK #0,0 : WINDOW #0,312,20,106,236
2430     PRINT #0,"  Use  &  to move indicator:Hit ENTER to accept."
2440     rng_min=0 : rng_max=5 : rng_sel=0
2450     FOR ors = rng_min TO rng_max : Highlight 5
2460     Select_Menu_Option 5,2,0
2470     CLS #0 : mucky = 1
2480     IF rng_sel < 4 : CLOSE #3 : Set_Window_3 0
2490     SELect ON rng_sel
2500       =0 : Backup_Files 0
2510       =1 : Do_VAT_Return 0
2520       =2 : Do_Year_End 1
2530       =3 : Do_Year_End 0
2540       =4 : Clean_Down : mucky = 0
2550       =5 : EXIT reploop
2560     END SELect
2570     IF mucky : Build_Menu_Screen
2580   END REPeat reploop
2590 END DEFine
2600 :
2610 DEFine PROCedure Do_VAT_Return(clearing_out)
2620 LOCal stth$(10), ii, jj, kk, docs_beyond_period
2630 LOCal jg(vatf_lim_max%), jv(vatf_lim_max%)
2640   REPeat dvr_lp
2650     IF NOT clearing_out : Backup_Files 0
2660     WINDOW 512,177,0,79   : PAPER 4 : CLS
2670     WINDOW 204,102,164,89 : PAPER 0,4 : CLS
2680     WINDOW 204,102,154,79 : BORDER 1,0
2690     WINDOW 200,100,156,80 : BORDER 3,7 : PAPER 2 : INK 0 : CLS
2700     PRINT \\"      Printing VAT Return"\\\\"         Do Not Disturb"
2710     first_unreported_doc = 0
2720     FOR ii = 0 TO vatf_lim_max%
2730       jg(ii) = vatf_gros(ii) : jv(ii) = vatf_vat(ii)
2740       vatf_gros(ii) = 0 : vatf_vat(ii) = 0
2750     END FOR ii
2760     prev_vatdt = Numeric_Date(lastvat$)
2770     next_vatdt = Numeric_Date(nextvat$)
2780     Position_at_Document vatclear
2785     IF not_found%
2787       CLS:PRINT \\"  No Documents Present"\\"    Return to Main Menu"
2788       PAUSE
2789       CLOSE #10:RETurn
2790     END IF
2792     docs_beyond_period = 0
2800     OPEN_OVER #7, prtr$
2810     PRINT #7,"Documents Numbers included in VAT Return for ";nextvat$
2820     PRINT #7,FILL$("-",79)
2830     ppos = 0
2840     FOR cur_doc = vatclear TO doc_ct%
2850       Get_Doc_Hddr
2860       doc_vatdt = Numeric_Date(doc_date$)
2870       IF doc_vatdt > next_vatdt : docs_beyond_period = 1
2880       wanted = Doc_in_Date_Range
2890       Get_Doc_Items
2900       IF wanted=1
2910         PRINT #7; FILL$(" ",8-LEN(cur_doc));cur_doc;
2920         ppos = ppos + 1 : IF (ppos MOD 10) = 0 : PRINT #7
2930         cred_or_deb = -1 : IF doc_type%=1 OR doc_type%=3 : cred_or_deb = 1
2940         Calc_Doc_Stats
2950       ELSE
2960         IF wanted=2
2970           PRINT #7; FILL$(" ",6-LEN(cur_doc));'(';cur_doc;')';
2980           ppos = ppos + 1 : IF (ppos MOD 10) = 0 : PRINT #7
2985         END IF
2990       END IF
3000     END FOR cur_doc
3010     CLOSE #10 : CLOSE #11
3020     IF first_unreported_doc = 0 : first_unreported_doc = doc_ct%
3030     Calc_Total_Stats
3040     PRINT #7,\form$
3050     Print_VAT_Return
3060     lastvat$ = nextvat$ : vatclear = first_unreported_doc : vatdoc = doc_ct%
3070     jj = 0 : ii = Month_No%(nextvat$(4 TO 6)) + vfq$
3080     IF ii > 12 : ii = ii - 12 : jj = 1
3090     yy = 1900+nextvat$(8 TO 9) : yy = yy + jj : tp$=yy : nextvat$(8 TO 9) = tp$(3 TO 4)
3100     nextvat$(4 TO 6)=m$(ii) : nextvat$(1 TO 2)=m%(ii)
3110     IF (yy MOD 4) = 0 AND ii=2 : nextvat$(1 TO 2)="29"
3120     FOR ii = 0 TO vatf_lim_max%
3130       vatf_gros(ii)=jg(ii)-vatf_gros(ii) : vatf_vat(ii)=jv(ii)-vatf_vat(ii)
3140     END FOR ii
3150     anal_blnc(1) = anal_blnc(1) - ntp
3160     PAPER 2 : INK 7 : CLS
3170     Storeanal : Storevat : Writeparam
3180     IF NOT (clearing_out AND docs_beyond_period) : EXIT dvr_lp
3190   END REPeat dvr_lp
3200 END DEFine
3210 :
3220 DEFine PROCedure Print_VAT_Return
3230 LOCal reprint, z$(90), part$(6), p1$(40)
3240   reprint = 1 : tv1=0
3250   REPeat oy
3260     IF NOT reprint : EXIT oy
3270     jj=INT((65-LEN(fullname$))/2)
3280     PRINT #7,FILL$(" ",jj);"VAT Return for ";fullname$
3290     PRINT #7,\"Printed on ";
3300     z$ = DATE$ : yr=z$(1 TO 4) : hr=z$(13 TO 14)
3310     part$="a.m." : IF hr>12 : hr=hr-12 : part$="p.m."
3315     IF hr=12 : part$="p.m."
3320     jj = z$(11)
3330     dy = z$(10 TO 11)
3340     SELect ON jj
3350       =1 : stth$="st." : IF dy=11 : stth$="th."
3360       =2 : stth$="nd." : IF dy=12 : stth$="th."
3370       =3 : stth$="rd." : IF dy=13 : stth$="th."
3380       =REMAINDER : stth$="th."
3390     END SELect
3400     PRINT #7,dy;stth$;" ";z$(6 TO 8);" ";yr;FILL$(" ",33);"Time ";hr;":";z$(16 TO 17) ;" ";part$
3410     PRINT #7,"VAT Number ..... ";vatno$(1 TO 3);" ";vatno$(4 TO 7);" ";vatno$(8 TO )
3420     PRINT #7,\\"Up to Document Number ";doc_ct%;FILL$(" ",34);"Period - ";nextvat$
3430     PRINT #7,FILL$("-",79)
3440     PRINT #7,FILL$(" ",24);"|";FILL$(" ",12);"OUTPUTS         |             INPUTS"
3450     Print_Mask
3460     PRINT #7,FILL$(" ",17);"Rate   |      Goods           VAT   |      Goods           VAT"
3470     PRINT #7,FILL$("-",24);"+";FILL$("-",28);"+";FILL$("-",25)
3480     FOR ii=0,1,3,2
3490       Print_Mask
3500       PRINT #7,FILL$(" ",8-LEN(vatf_rate$(ii)));vatf_rate$(ii);
3510       PRINT #7,"   ";Decimal$(vatf_pcnt(ii));"%  | ";
3520       PRINT #7,Decimal$(vatf_gros(ii));"    ";Decimal$(vatf_vat(ii));"   | ";
3530       PRINT #7,Decimal$(vatf_gros(ii+5));"    ";Decimal$(vatf_vat(ii+5))
3540       Print_Mask
3550       IF ii<>2
3560         PRINT #7,FILL$("-",24);"+";FILL$("-",28);"+";FILL$("-",25)
3565       ELSE
3570         PRINT #7,FILL$("=",79)
3575       END IF
3580     END FOR ii
3590     Print_Mask
3600     PRINT #7,"Value of Outputs";FILL$(" ",8);"| ";Decimal$(grp_outgrs);FILL$(" ",17);"|"
3610     PRINT #7,"Value of Output Tax";FILL$(" ",5);"|               ";Decimal$(grp_outvat);"   |"
3620     Print_Mask
3630     PRINT #7,"Value of Inputs";FILL$(" ",9);"|";FILL$(" ",28);"| ";Decimal$(grp_inpgrs)
3640     PRINT #7,"Value of Input Tax";FILL$(" ",6);"|";FILL$(" ",28);"|               ";Decimal$(grp_inpvat)
3650     Print_Mask
3660     p1$ = "Net Tax Payable  "
3670     IF ntp < 0 : p1$ = "Net Tax Repayable"
3680     z$=p1$&"       |"&FILL$(" ",28)&"|"&FILL$(" ",25)
3690     ii = 41 : IF ntp < 0 : ii = 70
3700     z$(ii TO ii+9) = Decimal$(ABS(ntp)) : PRINT #7,z$
3710     Print_Mask
3720     PRINT #7,FILL$("-",79)
3730     PRINT #7,\\\\FILL$("-",79)
3740     IF NOT clearing_out
3750       PRINT #7,\"Previous Period Balance Owed ";
3760       IF anal_blnc(1) < 0
3770         PRINT #7,"to ";
3772       ELSE
3774         PRINT #7,"from ";
3775       END IF
3780       PRINT #7,"Customs & Excise is ";Decimal$(ABS(anal_blnc(1)))
3790     ELSE
3800       PRINT #7,\"This VAT Return should be added to the one you will eventually do "
3810     END IF
3820     PRINT #7,\FILL$("-",79)\ form$
3830     IF NOT clearing_out
3840       PAPER 2 : INK 7 : CLS : PRINT
3850       IF tv1 = 0
3860         PRINT "This is the only copy ";
3865       ELSE
3870         PRINT " These are the only copies ";
3875       END IF
3880       PRINT "you have of this VAT Return."
3890       PRINT \"   Would you like a Reprint ?";
3900       Wait_for_YN
3910       reprint = (f$=="Y") : tv1 = 2
3920     ELSE
3930       reprint = 0
3940     END IF
3950   END REPeat oy
3960   CLOSE #7
3970 END DEFine
3980 :
3990 DEFine FuNction Doc_in_Date_Range
4000   IF doc_vatdt <= next_vatdt
4010     IF doc_vatdt > prev_vatdt : RETurn 1
4020     IF cur_doc > vatdoc : RETurn 1
4030     IF doc_vatdt <= prev_vatdt : RETurn 2
4040   END IF
4050   IF first_unreported_doc = 0 : first_unreported_doc = cur_doc
4060   RETurn 0
4070 END DEFine
4080 :
4090 DEFine PROCedure Print_Mask
4100   PRINT #7,FILL$(" ",24);"|";FILL$(" ",28);"|"
4110 END DEFine
4120 :
4130 DEFine PROCedure Get_Doc_Hddr
4140   INPUT #10,n$
4150   doc_date$=n$(1 TO 9) : doc_type%=n$(10 TO 11) : doc_acct%=n$(12 TO 15)
4160   doc_ref%=n$(16) : doc_reftxt$=n$(17 TO 24) : doc_no%=n$(25 TO 28)
4170   doc_totvl=n$(29 TO 38) : doc_vat=n$(39 TO 48) : doc_first%=n$(49 TO 52)
4180   doc_lin_ct%=n$(53 TO 55)
4190 END DEFine
4200 :
4210 DEFine PROCedure Get_Doc_Items
4220 LOCal ii
4230   FOR ii=1 TO doc_lin_ct%
4240     INPUT #11,n$
4250     doci_val(ii)=n$(1 TO 10) : doci_com$(ii)=n$(11 TO 30)
4260     doci_anl%(ii)=n$(31 TO 33) : doci_vcd%(ii)=n$(34 TO 35)
4270   END FOR ii
4280 END DEFine
4290 :
4300 DEFine PROCedure Position_at_Document(begin)
4310 LOCal x
4320   Identify_File 5 : OPEN #10,file$
4330   BGET #10\begin*(rec_lenf%+1) : INPUT #10,n$: IF n$(49 TO 52)='****':not_found%=1:RETurn
4332   not_found%=0
4335   x=n$(49 TO 52)
4340   BGET #10\begin*(rec_lenf%+1)
4350   Identify_File 1 : OPEN #11,file$ : BGET #11\x*(rec_lenf%+1)
4360 END DEFine
4370 :
4380 DEFine PROCedure Calc_Doc_Stats
4390 LOCal ii, jj, vat_adjmt
4400   vat_adjmt = 0
4410   FOR ii=1 TO doc_lin_ct%
4420     doci_vat(ii) = Decimal$(doci_val(ii)*vatf_pcnt(doci_vcd%(ii))/100)
4430     jj = doci_vcd%(ii) +5*(cred_or_deb=-1)
4440     vatf_gros(jj) = Decimal$(vatf_gros(jj)+doci_val(ii))
4450     vatf_vat(jj)  = Decimal$(vatf_vat(jj)+doci_vat(ii))
4460     vat_adjmt = vat_adjmt + doci_vat(ii)
4470   END FOR ii
4480   IF jj < 5 : jj=1 : ELSE : jj=6
4490   vatf_vat(jj) = Decimal$(vatf_vat(jj) +doc_vat -vat_adjmt)
4500 END DEFine
4510 :
4520 DEFine PROCedure Do_Year_End(carrying_fwd)
4530 LOCal ii, jj, kk , oldnext$(12), oldlast$(12), wkdt$(20), file_blnc
4540   WINDOW 512,177,0,79 : PAPER 4 : CLS
4550   WINDOW 401,148,65,89 : PAPER 4,0 : CLS
4560   WINDOW 401,148,55,79 : BORDER 1,7
4570   WINDOW 397,146,56,80 : BORDER 3,2 : PAPER 0 : CLS
4580   PAPER 7 : INK 0
4590   PRINT FILL$(" ",17);"Year End Date set at ";eoy$;FILL$(" ",17)
4600   FOR ii=1 TO 10 : PRINT
4610   PAPER 4 : INK 0
4620   PRINT "        Press ENTER to go back to Menu or F1 to Continue.       "
4630   REPeat hp : Get_Key : IF key = F1_key% OR key = ENTER% : EXIT hp
4640   IF key = ENTER% : RETurn
4650   Backup_Files 1 : IF exception : RETurn
4660   PAPER 7 : INK 0 : oldnext$=nextvat$ : oldlast$=lastvat$
4670   Do_VAT_Return 1
4680   nextvat$=oldnext$ : lastvat$=oldlast$ : vatdoc=0 : vatclear=1
4690   Writeparam
4700   PAPER 7 : INK 0 : CLS
4710   FOR ii=1 TO 4 : PRINT
4720   PRINT "       Balancing  Forward"\ "         DO NOT DISTURB"
4730   IF carrying_fwd
4740     wkdt$ = DATE$
4750     doc_date$ = wkdt$(10 TO 11) & ' ' & wkdt$(6 TO 8) & ' ' & wkdt$(3 TO 4)
4760   ELSE
4770     doc_date$ = eoy$
4775     yy = 1900+eoy$(8 TO 9) : yy = yy + 1 : tp$=yy : eoy$(8 TO 9) = tp$(3 TO 4)
4780     file_blnc = 0
4790     FOR ii=4 TO grup_lim_max%
4800       grp_blnc = 0
4810       IF grup_rept%(ii)<=3
4820         x1 = Analysis_Base%((ii))
4830         FOR jj = x1 TO x1+grup_popl%(ii)-1
4840           grp_blnc = grp_blnc + anal_blnc(jj) : anal_blnc(jj) = 0
4845         END FOR jj
4850         IF grup_rept%(ii)<>1 : grp_blnc = -grp_blnc
4860         file_blnc = file_blnc + grp_blnc
4870       END IF
4880     END FOR ii
4890     anal_blnc(bf_profit_anl%) = anal_blnc(bf_profit_anl%) + file_blnc
4900   END IF
4910   doc_ct%=0 : tran_ct%=0
4920   doc_type%=0 : doc_acct%=0 : doc_ref%=0
4930   doc_reftxt$="B/FWD" : doc_totvl=0 : doc_vat=0 : doc_vat_adjmt=0
4940   FOR ii=1 TO lines_per_doc_max% : doci_vcd%(ii)=4 : doci_com$(ii) = 'B/FWD'
4950   OPEN #10,drive2$&"ct_header_dat" : OPEN #11,drive2$&"ct_transact_dat"
4960   INPUT #10,n$ : INPUT #11,n$
4970   FOR ii = 1 TO grup_lim_max%
4980     q=0
4990     IF grup_popl%(ii)<>0 AND (grup_rept%(ii) > 3 OR carrying_fwd)
5000       kk = Analysis_Base%((ii)) - 1
5010       FOR jj = 1 TO grup_popl%(ii)
5020         doci_val(jj)  = anal_blnc(kk+jj)
5030         doci_anl%(jj) = kk + jj
5040         q = q + doci_val(jj)
5050       END FOR jj
5060       q = -q
5070       doc_lin_ct% = grup_popl%(ii)+1
5080       doci_val(doc_lin_ct%) = q
5085       doci_anl%(doc_lin_ct%) = bf_profit_anl%
5090       doc_ct%  = doc_ct%+1 : doc_no% = doc_ct%
5100       tran_ct% = tran_ct% + doc_lin_ct%
5110       Store (5), doc_ct% : PRINT #10,n$
5120       FOR jj = 1 TO doc_lin_ct% : Store (1), jj : PRINT #11,n$
5130     END IF
5140   END FOR ii
5150   CLOSE #10 : CLOSE #11
5160   FOR ii = 0 TO vatf_lim_max% : vatf_gros(ii)=0 : vatf_vat(ii)=0
5170   Storevat : Storeanal
5180 END DEFine
5190 :
5200 DEFine PROCedure Backup_Files(clearing_out)
5210 LOCal z$(50), ii
5220   WINDOW 512,177,0,79 : PAPER 4 : CLS
5230   WINDOW 289,137,125,89 : PAPER 4,0 : CLS
5240   WINDOW 289,137,111,79 : BORDER 3,0 : PAPER 7 : CLS
5250   z$=" Security" : IF clearing_out : z$="n Audit"
5260   z$="Make a"&z$&" Copy of Data"
5270   ii = (46-LEN(z$)) DIV 2
5280   PAPER 2 : INK 7 : PRINT TO ii;z$; : CLS 4
5290   PAPER 7 : INK 0
5300   WINDOW 281,123,114,91 : BORDER 1,0
5310   IF NOT clearing_out
5320     PRINT \\\\\
5330   ELSE
5340     PRINT \" You should make a Security Copy of your Data"
5350     PRINT \" before carrying on."\\\
5360   END IF
5370   PRINT " Do you wish to make/restore a Security Copy ?"
5380   Wait_for_YN
5390   IF f$=="y" : Writeparam : Clone_Files
5400 END DEFine
5410 :
5420 DEFine PROCedure Get_Key
5430   exception = 0
5440   f$ = INKEY$(#14,-1) : key = CODE(f$)
5450   IF key = ESC% : key = ENTER% : f$ = CHR$(ENTER%) : exception = 1
5460 END DEFine
5470 :
5480 DEFine PROCedure Calc_Total_Stats
5490 LOCal ii, jj : REMark x,x1,kk
5500   grp_inpgrs=0 : grp_inpvat=0 : grp_outvat=0 : grp_outgrs=0
5510   FOR ii=0 TO 3
5520     grp_outgrs = grp_outgrs+vatf_gros(ii)
5530     grp_outvat = grp_outvat+vatf_vat(ii)
5540     grp_inpgrs = grp_inpgrs+vatf_gros(ii+5)
5550     grp_inpvat = grp_inpvat+vatf_vat(ii+5)
5560   END FOR ii
5570   ntp = grp_outvat - grp_inpvat
5580 END DEFine
5590 :
5600 DEFine PROCedure Identify_File(filno)
5610   SELect ON filno
5620     =1 : file$="ct_transact_dat" : rec_lenf%=35 : file_popl% = tran_lim_max%
5630     =2 : file$="ct_group_dat"    : rec_lenf%=22 : file_popl% = grup_lim_max%
5640     =3 : file$="ct_analysis_dat" : rec_lenf%=31 : file_popl% = anal_lim_max%
5650     =4 : file$="ct_vatfile_dat"  : rec_lenf%=29 : file_popl% = vatf_lim_max%+2
5660     =5 : file$="ct_header_dat"   : rec_lenf%=60 : file_popl% = tran_lim_max%
5670   END SELect
5680   file$=drive2$&file$
5690 END DEFine
5700 :
5710 DEFine PROCedure Store (filno,rcd)
5720 LOCal x$(12)
5730   Identify_File filno : n$=FILL$(" ",rec_lenf%)
5740   SELect ON filno
5750     =1 : n$(1 TO 10)=Decimal$(doci_val(rcd)) : n$(11 TO 30)=doci_com$(rcd)
5760          n$(31 TO 33)=doci_anl%(rcd) : n$(34 TO)=doci_vcd%(rcd)
5770     =2 : n$(1 TO 15)=grup_desc$(rcd) : n$(16)=grup_rept%(rcd)
5780          n$(17 TO 19)=grup_popl%(rcd) : n$(20 TO 22)=grup_max_popl%(rcd)
5790     =3 : n$(1 TO 15)=anal_desc$(rcd) : n$(16)=anal_vtcd%(rcd)
5800          n$(17 TO 26)=Decimal$(anal_blnc(rcd)) : n$(27 TO 31) = anal_price%(rcd)
5810     =4 : x$=Decimal$(vatf_pcnt(rcd)) : n$(1 TO 5)=x$(6 TO) : n$(6 TO 9)=vatf_desc$(rcd)
5820          n$(10 TO 19)=Decimal$(vatf_gros(rcd)) : n$(20 TO)=Decimal$(vatf_vat(rcd))
5830     =5 : n$(1 TO 9)=doc_date$ : n$(10 TO 11)=doc_type%
5840          n$(12 TO 15)=doc_acct% : n$(16)=doc_ref%
5850          n$(17 TO 24)=doc_reftxt$ : n$(25 TO 28)=doc_no%
5860          n$(29 TO 38)=Decimal$(doc_totvl)
5870          n$(39 TO 48)=Decimal$(doc_vat+doc_vat_adjmt)
5880          n$(49 TO 52)=(tran_ct%-doc_lin_ct%+1)
5890          n$(53 TO 55)=doc_lin_ct% : n$(56 TO 60)="00000"
5900   END SELect
5910 END DEFine
5920 :
5930 DEFine PROCedure Storeanal
5940 LOCal ii
5950   Identify_File 3 : OPEN #5,file$ : INPUT #5,n$
5960   FOR ii=1 TO Active_Heads% : Store (3), ii : PRINT #5,n$
5970   CLOSE #5 : Identify_File 2 : OPEN #5,file$ : INPUT #5,n$
5980   FOR ii=1 TO grup_lim_max% : Store (2), ii : PRINT #5,n$
5990   CLOSE #5
6000 END DEFine
6010 :
6020 DEFine PROCedure Storevat
6030 LOCal ii
6040   Identify_File 4 : OPEN #5,file$
6050   FOR ii=0 TO vatf_lim_max% : Store (4), ii : PRINT #5,n$
6060   n$=FILL$(" ",29) : n$(1 TO 9)=last_used_doc_date$ : n$(10 TO 13)=doc_ct%
6070   n$(14 TO 17)=tran_ct%
6080   PRINT #5,n$
6090   n$=FILL$(" ",32)
6100   FOR ii=0 TO 3 : n$((ii*8)+1 TO (ii*8)+8)=vatf_rate$(ii)
6110   PRINT #5,n$ : CLOSE #5
6120 END DEFine
6130 :
6140 DEFine PROCedure Select_Menu_Option(col%,paph%,inkh%)
6150   REPeat smo_lp
6160     ors = rng_sel
6170     PAPER 0 : INK 7 : Highlight col%
6180     Get_Key
6190     IF key = ENTER% AND NOT exception : EXIT smo_lp
6200     Adj_Selection options$
6210     PAPER paph% : INK inkh% : Highlight col%
6220   END REPeat smo_lp
6230 END DEFine
6240 :
6250 DEFine PROCedure Highlight(col%)
6260   AT ((ors-rng_min)*2),col% : PRINT options$(ors)
6270 END DEFine
6280 :
6290 REFERENCE array$(0,0)
6300 DEFine PROCedure Adj_Selection(array$)
6310 LOCal ii, jj
6320   SELect ON key
6330     = lf_arrow%, up_arrow% : rng_sel=rng_sel-1
6340                              IF rng_sel<rng_min : rng_sel=rng_max
6350                              RETurn
6360     = rt_arrow%, dn_arrow% : rng_sel=rng_sel+1
6370                              IF rng_sel>rng_max : rng_sel=rng_min
6380                              RETurn
6390   END SELect
6400   FOR ii = rng_sel+1 TO rng_max
6410     IF Found_Option_Match : rng_sel = ii : RETurn
6420   END FOR ii
6430   FOR ii = rng_min TO rng_sel-1
6440     IF Found_Option_Match : rng_sel = ii : RETurn
6450   END FOR ii
6460 END DEFine
6470 :
6480 DEFine FuNction Found_Option_Match
6490   jj = 0
6500   REPeat fom_lp
6510     jj=jj+1 : IF jj > LEN(array$(ii)) : RETurn 0
6520     IF array$(ii,jj)<>" " : EXIT fom_lp
6530   END REPeat fom_lp
6540   RETurn CHR$(key) == array$(ii,jj)
6550 END DEFine
6560 :
6570 DEFine PROCedure Build_Menu_Screen
6580 LOCal ii, jj
6590   WINDOW 512,256,0,0 : PAPER 4 : CLS
6600   WINDOW 256,125,20,9
6610   SCALE 110,0,0 : Draw_Logo
6620   INK 7
6630   WINDOW 302,42,166,20 : PAPER 0,4 : CLS
6640   WINDOW 302,42,156,10 : BORDER 1,0
6650   WINDOW 298,40,158,11 : BORDER 3,2 : PAPER 7 : INK 0 : CLS
6660   CSIZE 2,0 : PRINT " Cash Trader  with VAT"
6670   ii = (47-LEN(fullname$)) DIV 2
6680   CSIZE 0,0 : PRINT \TO ii;fullname$
6690   WINDOW 204,122,264,89 : PAPER 0,4 : CLS
6700   WINDOW 204,122,254,79 : BORDER 1,0
6710   WINDOW 200,120,256,80 : BORDER 3,7 : PAPER 2 : INK 0 : CLS
6720   Set_Window_3 1 : CLOCK #3
6730 END DEFine
6740 :
6750 DEFine PROCedure Set_Window_3 (small)
6760   OPEN #3,'scr_'
6770   WINDOW #3,133,42,65,120 : PAPER #3,0,4 : CLS #3
6780   WINDOW #3,133,42,57,110 : BORDER #3,1,7 : PAPER #3,2,0,1 : CLS #3
6790   WINDOW #3,113,22,67,120 : BORDER #3,1,7 : PAPER #3,0 : INK #3,7
6800   CLS #3
6810   IF small : WINDOW #3,60,20,100,121
6820 END DEFine
6830 :
6840 DEFine PROCedure Writeparam
6850   DELETE drive2$&"ct_paramfile"
6860   OPEN_NEW #5,drive2$&"ct_paramfile"
6870   PRINT #5,nextvat$\ eoy$\ printlines\ form$\ extract$\ vfq$
6880   PRINT #5,prin$\ lastvat$\ vatclear\ vatdoc : CLOSE #5
6890 END DEFine
6900 :
6910 DEFine PROCedure Clean_Down
6920   PAPER 2 : INK 0 : CLS
6930   PRINT \"   1: Clear Down all your Data"
6940   PRINT \"   2: Just the Values"
6950   PRINT \"   3: Return to Menu."
6960   PRINT \"   Which one 1,2 or 3 ?"
6970   REPeat tgh : Get_Key : IF f$ INSTR "123" <> 0 : EXIT tgh
6980   IF f$="3" : CLS : RETurn
6990   IF f$="1" : CLOSE #3 : Set_Window_3 0 : Reset_Files : Build_Menu_Screen : RETurn
7000   CLS
7010   PRINT \\\\\"        Do not Disturb"
7020   Initialise_VAT_array : Identify_File 4 : DELETE drive2$&"ct_vatfile_dat"
7030   OPEN_NEW #5,drive2$&"ct_vatfile_dat"
7040   FOR ii=0 TO file_popl% : PRINT #5,vat$(ii)
7050   CLOSE #5
7060   FOR ii = 1 TO anal_lim_max% : anal_blnc(ii) = 0
7070   Storeanal
7080   vatclear=1 : vatdoc=0 : Writeparam
7090   CLS
7100 END DEFine
7110 :
7120 DEFine PROCedure Reset_Files
7130   Initialise_VAT_array
7140   WINDOW 512,256,0,0 : PAPER 2 : CLS
7150   WINDOW 300,70,41,25 : PAPER 2,0 : CLS
7160   WINDOW 300,70,32,16 : BORDER 2,7
7170   WINDOW 296,66,34,18 : BORDER 2,0
7180   PAPER 4 : INK 0 : CLS
7190   PRINT \\'    Resetting files - O.K. to continue ?'
7200   Wait_for_YN : IF NOT (f$=='y') : RETurn
7210   CLS
7220   IF drive1$ <> drive2$
7230     PRINT \\"    PUT BLANK "&cart$&" IN ";drive2$
7240     Wait_for_ENTER
7245   END IF
7250   WINDOW 200,60,265,115 : PAPER 2,0 : CLS
7260   WINDOW 200,60,256,106 : BORDER 5,0 : PAPER 2 : CLS
7265   INK 7
7270   IF drive1$<>drive2$
7271     PRINT \'-- Format '&drive2$&' ?'
7272     Wait_for_YN:CLS
7276   END IF
7280   PRINT \"     RESETTING FILES "\\"     DO  NOT  DISTURB"
7290   REMark WINDOW 100,25,10,106 : INK 2 : PAPER 2
7300   IF drive1$ <> drive2$ AND f$=='y'
7310     Format_Volume drive2$, "CT DATA"
7320   ELSE
7330     FOR jj = 1 TO 5 : Identify_File jj : DELETE file$
7340     DELETE drive2$ & 'ct_register'
7350     DELETE drive2$ & 'ct_paramfile'
7360   END IF
7370   FOR jj=1 TO 5
7380     Kile jj
7390     OPEN_NEW #5,file$
7400     FOR ii=0 TO file_popl%
7410       IF ii = 0
7420         SELect ON jj
7430           = 1 TO 2 : PRINT #5,FILL$("*",rec_lenf%)
7440           = 3 : PRINT #5, grup_lim_max%;FILL$(" ",rec_lenf%-LEN(grup_lim_max%))
7450           = 4 : PRINT #5, anal_lim_max%;FILL$(" ",rec_lenf%-LEN(anal_lim_max%))
7460           = 5 : PRINT #5, vat$(ii)
7470         END SELect
7480         NEXT ii
7485       END IF
7490       SELect ON jj
7500         =1 TO 2 : PRINT #5,FILL$("*",rec_lenf%)
7510         =3      : n$(1 TO 3) = grup_max_popl%(ii)
7520                   SELect ON ii
7530                     =1 : PRINT #5,"MONEY BOXES....62  ";n$(1 TO 3)
7540                     =2 : PRINT #5,"PURCHASE A/C's.70  ";n$(1 TO 3)
7550                     =3 : PRINT #5,"SALES A/C's....60  ";n$(1 TO 3)
7560                     =4 : PRINT #5,"CAPITAL A/C's..52  ";n$(1 TO 3)
7570                     =REMAINDER : PRINT #5,"FREE GROUP.....00  0  "
7580                   END SELect
7590         =4      : SELect ON ii
7600                     =1 : PRINT #5,"VAT ACCOUNT....4       000"
7610                     =2 : PRINT #5,"CASH ACCOUNT...4       000"
7620                     =3 TO grup_max_popl%(1)
7630                          PRINT #5,"FREE MONEY BOX.4       000"
7640                     =grup_max_popl%(1)+1 TO bf_profit_anl%-1
7650                          PRINT #5,"FREE ACCOUNT...4       000"
7660                     =bf_profit_anl%
7670                          PRINT #5,"PROFIT B/FWD...4       000"
7680                     =bf_profit_anl% + 1
7690                          PRINT #5,"CURRENT PROFIT 4       000"
7700                     =REMAINDER
7710                          PRINT #5,"FREE HEAD......4       000"
7720                   END SELect
7730         =5      : PRINT #5,vat$(ii)
7740       END SELect
7750     END FOR ii
7760     CLOSE #5
7770   END FOR jj
7780   vatclear=1 : vatdoc=0 : Writeparam
7790   OPEN_NEW #5,drive2$&"ct_register"
7800   PRINT #5,fullname$\ example$\ name$\ last$\ create$\ vatno$ : CLOSE #5
7810 END DEFine
7820 :
7830 DEFine PROCedure Kile(filno)
7840   Identify_File "15234"(filno)
7850 END DEFine
7860 :
7870 DEFine PROCedure Initialise_VAT_array
7880   vat$(0)=" 0.00ZERO"
7890   vat$(1)="15.00STND"
7900   vat$(2)="14.25DISC"
7910   vat$(3)=" 0.00EXMT"
7920   vat$(4)=" 0.00NONE"
7930   FOR ii=5 TO vatf_lim_max% : vat$(ii)=vat$(ii-5)
7940   FOR ii=0 TO vatf_lim_max% : vat$(ii)=vat$(ii)&"       000       000"
7950   vat$(10)=" 1 Jan 84   0   0            "
7960   vat$(11)="    ZEROSTANDARD  OTHERS  EXEMPT"
7970 END DEFine
7980 :
7990 DEFine PROCedure Draw_Logo
8000   INK 4,0 : FILL 1 : CIRCLE 35,82,20
8010   INK 4 : FILL 1 : CIRCLE 35,82,13 : INK 4,0
8020   FILL 1 : LINE 53,61 TO 57,66 TO 48,71 TO 44,66 TO 53,61
8030   FILL 1
8040   LINE 60,101 TO 60,62 TO 87,62 TO 87,68 TO 68,68 TO 68,101 TO 60,101
8050   INK 0 : FILL 1 : CIRCLE 30,85,20
8060   INK 4 : FILL 1 : CIRCLE 30,85,13
8070   INK 0 : FILL 1 : LINE 48,64 TO 52,69 TO 43,74 TO 39,69 TO 48,64
8080   FILL 1 : INK 0
8090   LINE 55,104 TO 55,65 TO 82,65 TO 82,71 TO 63,71 TO 63,104 TO 55,104
8100   INK 4,0 : FILL 0 : FILL 1
8110   ARC 22,75 TO 38,95,-2.2;22,75 TO 38,95,-3.2
8120   FILL 0
8130 END DEFine
8140 :
8240 :
8250 DEFine FuNction Decimal$(num)
8260 LOCal x$(12), ii, q, p
8270   q = 100 * num
8280   IF ABS(q) >= .5 : q = INT(ABS(q) + .5) : ELSE : q = 0
8290   p = INT(q/100) : ii = q - p * 100
8300   x$ = p
8310   SELect ON ii
8320     = 0         : x$ = x$ & ".00"
8330     = 1 TO 9    : x$ = x$ & ".0" & ii
8340     = REMAINDER : x$ = x$ & "." & ii
8350   END SELect
8360   IF num < 0 : x$ = '-' & x$
8370   x$ = FILL$(" ",money_fieldsize%-LEN(x$)) & x$
8380   RETurn x$
8390 END DEFine
8400 :
8410 DEFine FuNction Within(val, min, max)
8420   RETurn val >= min AND val <= max
8430 END DEFine
8440 :
8450 DEFine FuNction Month_No%(txt$)
8460 LOCal jj
8470   jj = 0
8480   REPeat fmnth : jj=jj+1 : IF txt$ == m$(jj) : EXIT fmnth
8490   RETurn jj
8500 END DEFine
8510 :
8520 DEFine FuNction Numeric_Date(txt$)
8530 LOCal ii, ans, jj
8540   ii = Month_No%(txt$(4 TO 6))
8545   ans=txt$(8 TO):IF ans<50:ans=ans+100
8550   jj=txt$(1 TO 2) : ans=(ans*10000)+(ii*100)+jj
8560   RETurn ans
8570 END DEFine
8580 :
8590 DEFine PROCedure Clone_Files
8600 LOCal z$(50), stamp$(30),tmpdrv$(20)
8610   WINDOW 512,256,0,0 : PAPER 4 : CLS
8620   Build_Screen_Head "Secure or Restore Data files"
8630   PRINT \'  Do you want to Save or Restore the data ?'
8640   PRINT \ TO 20;'S or R'
8650   REPeat tx : Get_Key : IF f$=="S" OR f$=="R" : EXIT tx
8660   saving = (f$ == 's')
8670   tmpdrv$ = drive1$
8680   IF drive1$ == drive2$
8690     PRINT \\'  We may need a second device '
8700     PRINT '    - only ';drive1$;' is known to CT'
8710     PRINT '  ';drive1$;' for input AND output ?'
8720     Wait_for_YN
8730     IF NOT (f$ == 'Y') : Get_Second_Device : IF exception : RETurn
8740   END IF
8750 :
8760   IF saving
8770     Build_Screen_Head 'Securing to '&tmpdrv$&' from '&drive2$
8780     ELSE
8790     Build_Screen_Head 'Restoring from '&tmpdrv$&' to '&drive2$
8800   END IF
8810 :
8820   PRINT \"      Do you wish to Continue ?"
8830   Wait_for_YN
8840   IF NOT (f$=="y") : RETurn
8850 :
8860   CLS
8870   IF NOT (drive2$ == tmpdrv$)
8880     PRINT \\"  Put your Current Data ";cart$;" in ";drive2$
8890     PRINT \\" Put the ";
8900     IF saving : PRINT "Blank or ";
8910     PRINT "Security volume in ";tmpdrv$
8920     Wait_for_ENTER
8930   END IF
8940   format_reqd = NOT ((tmpdrv$ == drive2$) OR (NOT saving AND drive1$==drive2$))
8950   IF saving
8960     Check_Directory tmpdrv$, tmpdrv$
8970     stamp$ = DATE$
8980     stamp$ = stamp$(10 TO 11)&stamp$(6 TO 8)&"_"&stamp$(3 TO 4)
8990   ELSE
9000     Check_Directory tmpdrv$, drive2$
9010   END IF
9020   IF format_reqd
9030     Moan : INK 7
9040     IF saving
9050       Format_Volume tmpdrv$, stamp$
9060     ELSE
9070       Format_Volume drive2$, "CT DATA"
9080     END IF
9090     INK 0
9095   END IF
9100   Copy_File 'ct_group_dat','grp'
9110   Copy_File 'ct_analysis_dat','anl'
9120   Copy_File 'ct_vatfile_dat','vat'
9130   Copy_File 'ct_transact_dat','trn'
9140   Copy_File 'ct_header_dat','hdr'
9150   Copy_File 'ct_register','reg'
9160   Copy_File 'ct_paramfile','prm'
9170   BEEP 5000,10
9180   CLS : PRINT \\,,"Copying Finished"
9190   IF saving
9200     PRINT \\'    Note the Time Stamp: ';stamp$
9210   ELSE
9220     Read_Register : Read_Param
9230     OPEN_IN #5,drive2$ & 'ct_group_dat' : INPUT #5,n$
9240     ngrp% = '0' & n$ : IF ngrp% = 0 : ngrp% = 14
9250     CLOSE #5
9260     OPEN_IN #5,drive2$ & 'ct_analysis_dat' : INPUT #5,n$
9270     nlim% = '0' & n$ : IF nlim% = 0 : nlim% = 140
9280     CLOSE #5
9290     IF ngrp% <> grup_lim_max% OR nlim% <> anal_lim_max%
9300       Moan : Moan
9310       INK 2 : PRINT \"   ANALYSIS STRUCTURE ALTERATION "\"   **** RUN ct_config SOONEST ****"
9320       INK 0 : Moan : Moan
9330     ELSE
9340       Setup_Analysis_Tables
9350     END IF
9360   END IF
9370   IF NOT ((drive1$==tmpdrv$) OR (drive1$==drive2$))
9380     PRINT \'    Replace System ';cart$;' in ';drive1$
9385   END IF
9390   BEEP 10000,40
9400   Wait_for_ENTER
9410 END DEFine
9420 :
9430 DEFine PROCedure Wait_for_ENTER
9440   PRINT \\'    Press ENTER to continue'
9450   REPeat tx : Get_Key : IF key = ENTER% : EXIT tx
9460 END DEFine
9470 :
9480 DEFine PROCedure Wait_for_YN
9490   PRINT \TO 20;"Y or N"
9500   REPeat tx : Get_Key : IF f$ INSTR "YN" : EXIT tx
9510 END DEFine
9520 :
9530 DEFine PROCedure Copy_File(srce$,dest$)
9540   IF saving
9550     Copy_One drive2$&srce$, tmpdrv$&stamp$&dest$
9560   ELSE
9570     Copy_One tmpdrv$&stamp$&dest$, drive2$&srce$
9580   END IF
9590 END DEFine
9600 :
9610 DEFine PROCedure Copy_One (srce$, dest$)
9620   PRINT 'Copying: '; srce$;' TO '; dest$
9630   DELETE dest$
9640   COPY srce$, dest$
9650 END DEFine
9660 :
9670 DEFine PROCedure Build_Screen_Head(z$)
9680 LOCal ii
9690   WINDOW 313,137,113,89 : PAPER 4,0 : CLS
9700   WINDOW 313,137, 99,79 : BORDER 3,0 : PAPER 7 : CLS
9710   ii = (50-LEN(z$)) DIV 2
9720   PAPER 2 : INK 7 : PRINT TO ii;z$; : CLS 4
9730   WINDOW 305,123,102,91 : BORDER 1,0 : PAPER 7 : INK 0
9740 END DEFine
9750 :
9760 DEFine PROCedure Get_Second_Device
9770   REPeat gsd_lp
9780     PAPER #14,7 : INK #14,0 : WINDOW #14, 281,123,114,91 : BORDER#14,1
9790     AT#14,11,0 : PRINT #14,' Enter other device name: '; : CLS #14,4
9800     PAPER #14,0 : PRINT #14,'      '; : INK #14,7
9810     AT#14,11,26 : INPUT#14;tmpdrv$
9820     IF LEN(tmpdrv$) = 5 : IF tmpdrv$(5) = '_' : EXIT gsd_lp
9830     Moan
9840   END REPeat gsd_lp
9850 END DEFine
9860 :
9870 DEFine PROCedure Moan
9880   BEEP 5000,1
9890 END DEFine
9900 :
9910 DEFine PROCedure Check_Directory(ddvc$,fdvc$)
9920 LOCal showing
9930   REPeat right_vol
9940     CLS : PRINT \\'  Do you want a Directory of ';ddvc$
9950     Wait_for_YN : IF f$ == 'n' : showing = 0 : EXIT right_vol
9960     Display_Dir (ddvc$)
9970     AT 10,0 : CLS 2 : PRINT '  Is this the right ';cart$; : CLS 4
9980     Wait_for_YN : IF f$ == 'y' : showing = 1 : EXIT right_vol
9990   END REPeat right_vol
10000   IF saving
10010     IF showing : Scrap_Files (ddvc$)
10020   ELSE
10030     Get_Stamp
10040     IF NOT (ddvc$ == fdvc$)
10050       CLS : PRINT \\'  Do you want a Directory of ';fdvc$
10060       Wait_for_YN
10070       IF f$ == 'n' : showing = 0 : ELSE : Display_Dir (fdvc$) : Scrap_Files (fdvc$)
10080     END IF
10085   END IF
10090   IF format_reqd
10100     AT 10,0 : CLS 2 : PRINT '  Do you want to FORMAT ';fdvc$; : CLS 4
10110     Wait_for_YN
10120     format_reqd = (f$=="y")
10125   END IF
10130   CLS
10140 END DEFine
10150 :
10160 DEFine PROCedure Scrap_Files(dvc$)
10170   REPeat del_lp
10180     AT 10,0 : CLS 2 : PRINT '  Do you want to delete a file'; : CLS 4
10190     Wait_for_YN : IF f$ == 'n' : EXIT del_lp
10200     Delete_Named_File
10210     Display_Dir (dvc$)
10220   END REPeat del_lp
10230 END DEFine
10240 :
10250 DEFine PROCedure Get_Stamp
10260   REPeat gs_lp
10270     PAPER #14,7 : INK #14,0 : WINDOW #14, 281,123,114,91 : BORDER#14,1
10280     AT #14,11,0 : PRINT #14,' Enter Time Stamp: '; : CLS #14,4
10290     PAPER #14,0 : PRINT #14,'         '; : INK #14,7
10300     AT #14,11,19 : INPUT#14;stamp$
10310     IF LEN(stamp$) = 8
10320       IF stamp$(6) = '_'
10330         IF NOT FOP_IN(#12,tmpdrv$&stamp$&'reg') : EXIT gs_lp
10340       END IF
10345     END IF
10350     Moan
10360   END REPeat gs_lp
10370   CLOSE #12
10380 END DEFine
10390 :
10400 DEFine PROCedure Delete_Named_File
10410 LOCal fnm$(40)
10420   PAPER #14,7 : INK #14,0 : WINDOW #14, 281,123,114,91 : BORDER#14,1
10430   AT #14,11,0 : PRINT #14,' Enter file name: ';
10440   PAPER #14,0 : PRINT #14,'           '; : INK #14,7
10450   AT #14,11,19 : INPUT#14;fnm$
10460   IF LEN(fnm$)<>0 : DELETE dvc$&fnm$
10470 END DEFine
10480 :
10490 DEFine PROCedure Format_Volume(dvc$,label$)
10500 LOCal q$(6), sz
10510   IF ('ram' INSTR dvc$) <> 1 : FORMAT dvc$ & label$ : RETurn
10520   PAPER #14,0 : INK #14,7 : WINDOW #14, 281,123,114,91 : BORDER#14,1
10530   REPeat fv_lp
10540     PAPER 7 : INK 0 : CLS : AT 3,6
10550     PRINT 'Enter format size for ';dvc$;': ';
10560     PAPER 0 : INK 7 : AT 3,35 : PRINT '      ';
10570     AT #14,3,35 : INPUT #14,q$ : PAPER 7
10575     IF q$='':RETurn
10580     sz = '0' & q$ : IF sz > 0 : FORMAT dvc$ & sz : RETurn
10590   END REPeat fv_lp
10600 END DEFine
10610 :
10620 DEFine PROCedure Display_Dir (dvc$)
10630 LOCal wrong, dir_col%, dir_lin%, x%, file_ptr_ , filnam$(50)
10640 LOCal cont$(12), spare$(50)
10650   spare$ = Space_on_Device$
10660   IF FOP_DIR(#13,(dvc$)) : RETurn
10670   PAPER 0 : INK 4 : cont$ = "" : file_ptr_ = 0
10680   REPeat dir_outer
10690     IF EOF(#13) : EXIT dir_outer
10700     CLS  : dir_col% = 0
10710     PRINT "Directory: ";dvc$;cont$;"   Free: ";spare$
10720     REPeat dir_middle
10730       IF EOF(#13) : EXIT dir_middle
10740       dir_lin% = 2
10750       REPeat dir_inner
10760         BGET #13\(file_ptr_ * 64)
10770         IF EOF(#13) : EXIT dir_inner
10780         BGET #13\(file_ptr_ * 64 +14)
10790 :
10800         filnam$ = Str_from_File$(13,Int_from_File%(13,2))
10810 :
10820         file_ptr_ = file_ptr_ + 1
10830         x% = LEN(filnam$) : IF x% = 0: NEXT dir_inner
10840         IF x% > 16 : x% = 16
10850         INK 4 : AT dir_lin%, dir_col% : PRINT filnam$(1 TO x%)
10860         dir_lin% = dir_lin% + 1 : IF dir_lin%>8 : EXIT dir_inner
10870       END REPeat dir_inner
10880       dir_col% = dir_col% + 17 : IF dir_col% > 34 : EXIT dir_middle
10890     END REPeat dir_middle
10900     IF NOT EOF(#13)
10910       AT 11,20 : PRINT "   - Press any key - " : Get_Key
10920       IF exception : EXIT dir_outer
10930       cont$ = " cont"
10935     END IF
10940   END REPeat dir_outer
10950   PAPER 7 : INK 0 : CLOSE #13
10960 END DEFine
10970 :
10980 DEFine FuNction Int_from_File%(chn%,ct%)
10990 LOCal numb%,ipval%,ctl%
11000   numb% = 0 : ctl% = ct%
11010   REPeat ip_num_loop
11020     IF ctl% = 0 : EXIT ip_num_loop
11030     IF EOF(#chn%) : EXIT ip_num_loop
11040     ipval% = CODE(INKEY$(#(chn%),-1))
11050     numb% = numb% * 256 + ipval%
11060     ctl% = ctl% - 1
11065   END REPeat ip_num_loop
11070   RETurn numb%
11080 END DEFine
11090 :
11100 DEFine FuNction Str_from_File$(chn%,ct%)
11110 LOCal ipval%,ctl%,str$(200)
11120   str$ = "" : ctl% = ct%
11130   REPeat ip_str_loop
11140     IF ctl% = 0 : EXIT ip_str_loop
11150     IF EOF(#(chn%)) : EXIT ip_str_loop
11160     str$ = str$ & INKEY$(#(chn%),-1)
11170     ctl% = ctl% - 1
11175   END REPeat ip_str_loop
11180   RETurn str$
11190 END DEFine
11200 :
11210 DEFine FuNction Space_on_Device$
11220 LOCal wk$(50), ii, jj
11230   DELETE dvc$&'ctxdiry' : OPEN_NEW #15,dvc$&'ctxdiry'
11240   DIR #15,dvc$ : CLOSE #15
11250   OPEN_IN #15,dvc$&'ctxdiry' : wk$ = ""
11260   REPeat sod_lp
11270     IF EOF(#15) : EXIT sod_lp
11280     INPUT #15,wk$
11290     ii = 'sectors' INSTR wk$
11300     IF ii <> 0 : EXIT sod_lp
11310   END REPeat sod_lp
11320   REPeat sq : jj = ' ' INSTR wk$ : IF jj < ii-1 : wk$ = wk$(jj+1 TO) : ELSE : EXIT sq
11330   CLOSE #15 : DELETE dvc$&'ctxdiry'
11340   RETurn wk$
11350 END DEFine
11360 :
20000 DEFine FuNction Pull_Up$(off)
20010 LOCal x$(50),lenf%
20020   x$ = '':lenf%=PEEK_W(addr+off)
20030   FOR ii = 1 TO lenf% : x$ = x$ & CHR$(PEEK(addr+off+1+ii))
20040   ii = ' ' INSTR x$ : IF ii = 0 : RETurn x$
20050   RETurn x$(1 TO ii-1)
20060 END DEFine
